/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 30 "core/cfg.y" /* yacc.c:339  */


#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <arpa/inet.h>
#include <string.h>
#include <errno.h>
#include "route_struct.h"
#include "globals.h"
#include "shm_init.h"
#include "route.h"
#include "switch.h"
#include "dprint.h"
#include "sr_module.h"
#include "modparam.h"
#include "ip_addr.h"
#include "resolve.h"
#include "socket_info.h"
#include "name_alias.h"
#include "ut.h"
#include "dset.h"
#include "select.h"
#include "flags.h"
#include "tcp_init.h"
#include "tcp_options.h"
#include "sctp_core.h"
#include "pvar.h"
#include "lvalue.h"
#include "rvalue.h"
#include "sr_compat.h"
#include "msg_translator.h"
#include "async_task.h"

#include "kemi.h"
#include "ppcfg.h"
#include "pvapi.h"
#include "config.h"
#include "cfg_core.h"
#include "cfg/cfg.h"
#ifdef CORE_TLS
#include "tls/tls_config.h"
#endif
#include "timer_ticks.h"

#ifdef DEBUG_DMALLOC
#include <dmalloc.h>
#endif

/* hack to avoid alloca usage in the generated C file (needed for compiler
 with no built in alloca, like icc*/
#undef _ALLOCA_H

#define onsend_check(s) \
	do{\
		if (rt!=ONSEND_ROUTE) yyerror( s " allowed only in onsend_routes");\
	}while(0)

	#define IF_AUTO_BIND_IPV6(x) x

#ifdef USE_DNS_CACHE
	#define IF_DNS_CACHE(x) x
#else
	#define IF_DNS_CACHE(x) warn("dns cache support not compiled in")
#endif

#ifdef USE_DNS_FAILOVER
	#define IF_DNS_FAILOVER(x) x
#else
	#define IF_DNS_FAILOVER(x) warn("dns failover support not compiled in")
#endif

#ifdef USE_NAPTR
	#define IF_NAPTR(x) x
#else
	#define IF_NAPTR(x) warn("dns naptr support not compiled in")
#endif

#ifdef USE_DST_BLACKLIST
	#define IF_DST_BLACKLIST(x) x
#else
	#define IF_DST_BLACKLIST(x) warn("dst blacklist support not compiled in")
#endif

#ifdef USE_SCTP
	#define IF_SCTP(x) x
#else
	#define IF_SCTP(x) warn("sctp support not compiled in")
#endif

#ifdef USE_RAW_SOCKS
	#define IF_RAW_SOCKS(x) x
#else
	#define IF_RAW_SOCKS(x) warn("raw socket support not compiled in")
#endif


extern int yylex();
/* safer then using yytext which can be array or pointer */
extern char* yy_number_str;

static void yyerror(char* s, ...);
static void yyerror_at(struct cfg_pos* pos, char* s, ...);
static char* tmp = NULL;
static int i_tmp = 0;
static struct socket_id* lst_tmp = NULL;
static struct name_lst* nl_tmp = NULL;
static int rt = 0;  /* Type of route block for find_export */
static str* str_tmp = NULL;
static str s_tmp = STR_NULL;
static struct ip_addr* ip_tmp = NULL;
static struct avp_spec* s_attr = NULL;
static select_t sel;
static select_t* sel_ptr = NULL;
static pv_spec_t* pv_spec = NULL;
static struct action *mod_func_action = NULL;
static struct lvalue* lval_tmp = NULL;
static struct rvalue* rval_tmp = NULL;

static void warn(char* s, ...);
static void warn_at(struct cfg_pos* pos, char* s, ...);
static void get_cpos(struct cfg_pos* pos);
static struct rval_expr* mk_rve_rval(enum rval_type, void* v);
static struct rval_expr* mk_rve1(enum rval_expr_op op, struct rval_expr* rve1);
static struct rval_expr* mk_rve2(enum rval_expr_op op, struct rval_expr* rve1,
									struct rval_expr* rve2);
static int rval_expr_int_check(struct rval_expr *rve);
static int warn_ct_rve(struct rval_expr *rve, char* name);
static struct socket_id* mk_listen_id(char*, int, int);
static struct name_lst* mk_name_lst(char* name, int flags);
static struct socket_id* mk_listen_id2(struct name_lst*, int, int);
static void free_name_lst(struct name_lst* lst);
static void free_socket_id_lst(struct socket_id* i);

static struct case_stms* mk_case_stm(struct rval_expr* ct, int is_re,
									struct action* a, int* err);
static int case_check_type(struct case_stms* stms);
static int case_check_default(struct case_stms* stms);
static int mod_f_params_pre_fixup(struct action* a);
static void free_mod_func_action(struct action* a);


extern int line;
extern int column;
extern int startcolumn;
extern int startline;
extern char *finame;
extern char *routename;
extern char *default_routename;

#define set_cfg_pos(x) \
	do{\
		if(x) {\
		(x)->cline = line;\
		(x)->cfile = (finame!=0)?finame:((cfg_file!=0)?cfg_file:"default");\
		(x)->rname = (routename!=0)?routename:((default_routename!=0)?default_routename:"DEFAULT");\
		}\
	}while(0)



#line 232 "core/cfg.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "cfg.tab.h".  */
#ifndef YY_YY_CORE_CFG_TAB_H_INCLUDED
# define YY_YY_CORE_CFG_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    FORWARD = 258,
    FORWARD_TCP = 259,
    FORWARD_TLS = 260,
    FORWARD_SCTP = 261,
    FORWARD_UDP = 262,
    EXIT = 263,
    DROP = 264,
    RETURN = 265,
    BREAK = 266,
    LOG_TOK = 267,
    ERROR = 268,
    ROUTE = 269,
    ROUTE_REQUEST = 270,
    ROUTE_FAILURE = 271,
    ROUTE_ONREPLY = 272,
    ROUTE_REPLY = 273,
    ROUTE_BRANCH = 274,
    ROUTE_SEND = 275,
    ROUTE_EVENT = 276,
    EXEC = 277,
    SET_HOST = 278,
    SET_HOSTPORT = 279,
    SET_HOSTPORTTRANS = 280,
    PREFIX = 281,
    STRIP = 282,
    STRIP_TAIL = 283,
    SET_USERPHONE = 284,
    APPEND_BRANCH = 285,
    REMOVE_BRANCH = 286,
    CLEAR_BRANCHES = 287,
    SET_USER = 288,
    SET_USERPASS = 289,
    SET_PORT = 290,
    SET_URI = 291,
    REVERT_URI = 292,
    FORCE_RPORT = 293,
    ADD_LOCAL_RPORT = 294,
    FORCE_TCP_ALIAS = 295,
    UDP_MTU = 296,
    UDP_MTU_TRY_PROTO = 297,
    UDP4_RAW = 298,
    UDP4_RAW_MTU = 299,
    UDP4_RAW_TTL = 300,
    IF = 301,
    ELSE = 302,
    SET_ADV_ADDRESS = 303,
    SET_ADV_PORT = 304,
    FORCE_SEND_SOCKET = 305,
    SET_FWD_NO_CONNECT = 306,
    SET_RPL_NO_CONNECT = 307,
    SET_FWD_CLOSE = 308,
    SET_RPL_CLOSE = 309,
    SWITCH = 310,
    CASE = 311,
    DEFAULT = 312,
    WHILE = 313,
    CFG_SELECT = 314,
    CFG_RESET = 315,
    URIHOST = 316,
    URIPORT = 317,
    MAX_LEN = 318,
    SETFLAG = 319,
    RESETFLAG = 320,
    ISFLAGSET = 321,
    SETAVPFLAG = 322,
    RESETAVPFLAG = 323,
    ISAVPFLAGSET = 324,
    METHOD = 325,
    URI = 326,
    FROM_URI = 327,
    TO_URI = 328,
    SRCIP = 329,
    SRCPORT = 330,
    DSTIP = 331,
    DSTPORT = 332,
    TOIP = 333,
    TOPORT = 334,
    SNDIP = 335,
    SNDPORT = 336,
    SNDPROTO = 337,
    SNDAF = 338,
    PROTO = 339,
    AF = 340,
    MYSELF = 341,
    MSGLEN = 342,
    UDP = 343,
    TCP = 344,
    TLS = 345,
    SCTP = 346,
    WS = 347,
    WSS = 348,
    DEBUG_V = 349,
    FORK = 350,
    FORK_DELAY = 351,
    MODINIT_DELAY = 352,
    LOGSTDERROR = 353,
    LOGFACILITY = 354,
    LOGNAME = 355,
    LOGCOLOR = 356,
    LOGPREFIX = 357,
    LOGPREFIXMODE = 358,
    LOGENGINETYPE = 359,
    LOGENGINEDATA = 360,
    XAVPVIAPARAMS = 361,
    XAVPVIAFIELDS = 362,
    LISTEN = 363,
    ADVERTISE = 364,
    STRNAME = 365,
    ALIAS = 366,
    SR_AUTO_ALIASES = 367,
    DNS = 368,
    REV_DNS = 369,
    DNS_TRY_IPV6 = 370,
    DNS_TRY_NAPTR = 371,
    DNS_SRV_LB = 372,
    DNS_UDP_PREF = 373,
    DNS_TCP_PREF = 374,
    DNS_TLS_PREF = 375,
    DNS_SCTP_PREF = 376,
    DNS_RETR_TIME = 377,
    DNS_SLOW_QUERY_MS = 378,
    DNS_RETR_NO = 379,
    DNS_SERVERS_NO = 380,
    DNS_USE_SEARCH = 381,
    DNS_SEARCH_FMATCH = 382,
    DNS_NAPTR_IGNORE_RFC = 383,
    DNS_CACHE_INIT = 384,
    DNS_USE_CACHE = 385,
    DNS_USE_FAILOVER = 386,
    DNS_CACHE_FLAGS = 387,
    DNS_CACHE_NEG_TTL = 388,
    DNS_CACHE_MIN_TTL = 389,
    DNS_CACHE_MAX_TTL = 390,
    DNS_CACHE_MEM = 391,
    DNS_CACHE_GC_INT = 392,
    DNS_CACHE_DEL_NONEXP = 393,
    DNS_CACHE_REC_PREF = 394,
    AUTO_BIND_IPV6 = 395,
    BIND_IPV6_LINK_LOCAL = 396,
    DST_BLST_INIT = 397,
    USE_DST_BLST = 398,
    DST_BLST_MEM = 399,
    DST_BLST_TTL = 400,
    DST_BLST_GC_INT = 401,
    DST_BLST_UDP_IMASK = 402,
    DST_BLST_TCP_IMASK = 403,
    DST_BLST_TLS_IMASK = 404,
    DST_BLST_SCTP_IMASK = 405,
    IP_FREE_BIND = 406,
    PORT = 407,
    STAT = 408,
    CHILDREN = 409,
    SOCKET_WORKERS = 410,
    ASYNC_WORKERS = 411,
    ASYNC_USLEEP = 412,
    ASYNC_NONBLOCK = 413,
    CHECK_VIA = 414,
    PHONE2TEL = 415,
    MEMLOG = 416,
    MEMDBG = 417,
    MEMSUM = 418,
    MEMSAFETY = 419,
    MEMJOIN = 420,
    MEMSTATUSMODE = 421,
    CORELOG = 422,
    SIP_WARNING = 423,
    SERVER_SIGNATURE = 424,
    SERVER_HEADER = 425,
    USER_AGENT_HEADER = 426,
    REPLY_TO_VIA = 427,
    LOADMODULE = 428,
    LOADPATH = 429,
    MODPARAM = 430,
    CFGENGINE = 431,
    MAXBUFFER = 432,
    SQL_BUFFER_SIZE = 433,
    USER = 434,
    GROUP = 435,
    CHROOT = 436,
    WDIR = 437,
    RUNDIR = 438,
    MHOMED = 439,
    DISABLE_TCP = 440,
    TCP_ACCEPT_ALIASES = 441,
    TCP_ACCEPT_UNIQUE = 442,
    TCP_CONNECTION_MATCH = 443,
    TCP_CHILDREN = 444,
    TCP_CONNECT_TIMEOUT = 445,
    TCP_SEND_TIMEOUT = 446,
    TCP_CON_LIFETIME = 447,
    TCP_POLL_METHOD = 448,
    TCP_MAX_CONNECTIONS = 449,
    TLS_MAX_CONNECTIONS = 450,
    TCP_NO_CONNECT = 451,
    TCP_SOURCE_IPV4 = 452,
    TCP_SOURCE_IPV6 = 453,
    TCP_OPT_FD_CACHE = 454,
    TCP_OPT_BUF_WRITE = 455,
    TCP_OPT_CONN_WQ_MAX = 456,
    TCP_OPT_WQ_MAX = 457,
    TCP_OPT_RD_BUF = 458,
    TCP_OPT_WQ_BLK = 459,
    TCP_OPT_DEFER_ACCEPT = 460,
    TCP_OPT_DELAYED_ACK = 461,
    TCP_OPT_SYNCNT = 462,
    TCP_OPT_LINGER2 = 463,
    TCP_OPT_KEEPALIVE = 464,
    TCP_OPT_KEEPIDLE = 465,
    TCP_OPT_KEEPINTVL = 466,
    TCP_OPT_KEEPCNT = 467,
    TCP_OPT_CRLF_PING = 468,
    TCP_OPT_ACCEPT_NO_CL = 469,
    TCP_OPT_ACCEPT_HEP3 = 470,
    TCP_OPT_ACCEPT_HAPROXY = 471,
    TCP_CLONE_RCVBUF = 472,
    TCP_REUSE_PORT = 473,
    DISABLE_TLS = 474,
    ENABLE_TLS = 475,
    TLSLOG = 476,
    TLS_PORT_NO = 477,
    TLS_METHOD = 478,
    TLS_HANDSHAKE_TIMEOUT = 479,
    TLS_SEND_TIMEOUT = 480,
    SSLv23 = 481,
    SSLv2 = 482,
    SSLv3 = 483,
    TLSv1 = 484,
    TLS_VERIFY = 485,
    TLS_REQUIRE_CERTIFICATE = 486,
    TLS_CERTIFICATE = 487,
    TLS_PRIVATE_KEY = 488,
    TLS_CA_LIST = 489,
    DISABLE_SCTP = 490,
    ENABLE_SCTP = 491,
    SCTP_CHILDREN = 492,
    ADVERTISED_ADDRESS = 493,
    ADVERTISED_PORT = 494,
    DISABLE_CORE = 495,
    OPEN_FD_LIMIT = 496,
    SHM_MEM_SZ = 497,
    SHM_FORCE_ALLOC = 498,
    MLOCK_PAGES = 499,
    REAL_TIME = 500,
    RT_PRIO = 501,
    RT_POLICY = 502,
    RT_TIMER1_PRIO = 503,
    RT_TIMER1_POLICY = 504,
    RT_TIMER2_PRIO = 505,
    RT_TIMER2_POLICY = 506,
    MCAST_LOOPBACK = 507,
    MCAST_TTL = 508,
    MCAST = 509,
    TOS = 510,
    PMTU_DISCOVERY = 511,
    KILL_TIMEOUT = 512,
    MAX_WLOOPS = 513,
    PVBUFSIZE = 514,
    PVBUFSLOTS = 515,
    PVCACHELIMIT = 516,
    PVCACHEACTION = 517,
    HTTP_REPLY_PARSE = 518,
    VERSION_TABLE_CFG = 519,
    VERBOSE_STARTUP = 520,
    ROUTE_LOCKS_SIZE = 521,
    CFG_DESCRIPTION = 522,
    SERVER_ID = 523,
    KEMI = 524,
    ONSEND_ROUTE_CALLBACK = 525,
    REPLY_ROUTE_CALLBACK = 526,
    EVENT_ROUTE_CALLBACK = 527,
    RECEIVED_ROUTE_CALLBACK = 528,
    RECEIVED_ROUTE_MODE = 529,
    MAX_RECURSIVE_LEVEL = 530,
    MAX_BRANCHES_PARAM = 531,
    LATENCY_CFG_LOG = 532,
    LATENCY_LOG = 533,
    LATENCY_LIMIT_DB = 534,
    LATENCY_LIMIT_ACTION = 535,
    LATENCY_LIMIT_CFG = 536,
    MSG_TIME = 537,
    ONSEND_RT_REPLY = 538,
    FLAGS_DECL = 539,
    AVPFLAGS_DECL = 540,
    ATTR_MARK = 541,
    SELECT_MARK = 542,
    ATTR_FROM = 543,
    ATTR_TO = 544,
    ATTR_FROMURI = 545,
    ATTR_TOURI = 546,
    ATTR_FROMUSER = 547,
    ATTR_TOUSER = 548,
    ATTR_FROMDOMAIN = 549,
    ATTR_TODOMAIN = 550,
    ATTR_GLOBAL = 551,
    ADDEQ = 552,
    SUBST = 553,
    SUBSTDEF = 554,
    SUBSTDEFS = 555,
    EQUAL = 556,
    LOG_OR = 557,
    LOG_AND = 558,
    BIN_OR = 559,
    BIN_AND = 560,
    BIN_XOR = 561,
    BIN_LSHIFT = 562,
    BIN_RSHIFT = 563,
    EQUAL_T = 564,
    DIFF = 565,
    MATCH = 566,
    INTEQ = 567,
    INTDIFF = 568,
    STREQ = 569,
    STRDIFF = 570,
    GT = 571,
    LT = 572,
    GTE = 573,
    LTE = 574,
    PLUS = 575,
    MINUS = 576,
    STAR = 577,
    SLASH = 578,
    MODULO = 579,
    NOT = 580,
    UNARY = 581,
    BIN_NOT = 582,
    DEFINED = 583,
    INTCAST = 584,
    STRCAST = 585,
    DOT = 586,
    STRLEN = 587,
    STREMPTY = 588,
    NUMBER = 589,
    ID = 590,
    NUM_ID = 591,
    STRING = 592,
    IPV6ADDR = 593,
    PVAR = 594,
    AVP_OR_PVAR = 595,
    EVENT_RT_NAME = 596,
    COMMA = 597,
    SEMICOLON = 598,
    RPAREN = 599,
    LPAREN = 600,
    LBRACE = 601,
    RBRACE = 602,
    LBRACK = 603,
    RBRACK = 604,
    CR = 605,
    COLON = 606
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 196 "core/cfg.y" /* yacc.c:355  */

	long intval;
	unsigned long uval;
	char* strval;
	struct expr* expr;
	struct action* action;
	struct case_stms* case_stms;
	struct net* ipnet;
	struct ip_addr* ipaddr;
	struct socket_id* sockid;
	struct name_lst* name_l;
	struct avp_spec* attr;
	struct _pv_spec* pvar;
	struct lvalue* lval;
	struct rvalue* rval;
	struct rval_expr* rv_expr;
	select_t* select;

#line 643 "core/cfg.tab.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_CORE_CFG_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 660 "core/cfg.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  465
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   12005

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  352
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  104
/* YYNRULES -- Number of rules.  */
#define YYNRULES  908
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1695

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   606

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   626,   626,   629,   630,   631,   634,   635,   636,   637,
     638,   639,   639,   640,   640,   641,   642,   642,   643,   643,
     644,   644,   645,   646,   649,   665,   673,   687,   688,   694,
     695,   699,   700,   701,   702,   703,   706,   707,   708,   709,
     710,   711,   712,   715,   716,   719,   720,   721,   722,   723,
     727,   728,   729,   730,   731,   735,   736,   739,   740,   743,
     744,   746,   747,   750,   753,   759,   760,   764,   765,   768,
     769,   772,   778,   779,   780,   781,   782,   783,   784,   785,
     786,   789,   790,   796,   797,   798,   799,   800,   801,   802,
     803,   804,   805,   806,   807,   808,   809,   812,   813,   816,
     817,   818,   819,   820,   821,   822,   823,   824,   825,   826,
     827,   828,   829,   830,   831,   832,   833,   835,   836,   837,
     838,   839,   840,   841,   842,   843,   844,   845,   846,   847,
     848,   849,   850,   851,   852,   853,   854,   855,   856,   857,
     858,   859,   860,   861,   862,   863,   864,   865,   866,   867,
     868,   869,   870,   871,   872,   873,   874,   875,   876,   877,
     878,   881,   882,   885,   886,   889,   890,   891,   892,   895,
     896,   899,   900,   903,   904,   907,   908,   909,   910,   911,
     912,   913,   914,   915,   916,   917,   918,   919,   920,   921,
     922,   923,   924,   925,   926,   927,   928,   929,   930,   931,
     932,   933,   934,   935,   936,   937,   938,   939,   940,   941,
     942,   943,   944,   945,   946,   949,   950,   957,   964,   965,
     966,   967,   968,   969,   970,   971,   972,   973,   974,   975,
     976,   977,   978,   979,   986,   987,   994,   995,  1002,  1003,
    1010,  1011,  1018,  1019,  1026,  1027,  1034,  1035,  1045,  1046,
    1060,  1074,  1075,  1082,  1083,  1090,  1091,  1098,  1099,  1108,
    1109,  1118,  1119,  1126,  1127,  1134,  1135,  1142,  1143,  1150,
    1151,  1158,  1159,  1166,  1167,  1174,  1175,  1182,  1183,  1190,
    1191,  1198,  1199,  1206,  1207,  1214,  1215,  1222,  1223,  1230,
    1231,  1238,  1239,  1246,  1247,  1254,  1255,  1262,  1264,  1271,
    1272,  1283,  1284,  1291,  1292,  1299,  1300,  1307,  1308,  1315,
    1316,  1323,  1330,  1337,  1344,  1351,  1358,  1359,  1366,  1367,
    1374,  1375,  1382,  1383,  1390,  1391,  1398,  1399,  1406,  1407,
    1414,  1415,  1422,  1423,  1430,  1431,  1432,  1433,  1436,  1437,
    1440,  1441,  1442,  1443,  1455,  1467,  1480,  1493,  1506,  1519,
    1521,  1532,  1533,  1534,  1535,  1541,  1542,  1552,  1553,  1554,
    1555,  1556,  1557,  1564,  1565,  1572,  1573,  1574,  1575,  1576,
    1577,  1578,  1579,  1580,  1581,  1582,  1583,  1584,  1585,  1586,
    1587,  1588,  1589,  1596,  1597,  1604,  1605,  1612,  1619,  1620,
    1621,  1648,  1649,  1650,  1651,  1652,  1653,  1654,  1655,  1656,
    1657,  1658,  1659,  1660,  1661,  1662,  1663,  1664,  1665,  1666,
    1667,  1668,  1669,  1670,  1671,  1680,  1681,  1690,  1691,  1700,
    1701,  1710,  1711,  1712,  1713,  1714,  1715,  1716,  1717,  1718,
    1719,  1720,  1721,  1722,  1723,  1724,  1725,  1726,  1727,  1728,
    1729,  1730,  1731,  1733,  1734,  1736,  1738,  1739,  1740,  1743,
    1744,  1747,  1748,  1749,  1752,  1753,  1756,  1757,  1758,  1766,
    1771,  1776,  1781,  1786,  1789,  1794,  1802,  1808,  1809,  1819,
    1820,  1830,  1831,  1840,  1849,  1850,  1856,  1857,  1863,  1867,
    1868,  1871,  1900,  1915,  1916,  1920,  1931,  1932,  1936,  1937,
    1941,  1948,  1964,  1965,  1968,  1971,  1978,  1994,  1998,  1999,
    2004,  2004,  2011,  2012,  2014,  2013,  2036,  2041,  2044,  2051,
    2067,  2070,  2073,  2080,  2096,  2099,  2102,  2119,  2122,  2123,
    2124,  2125,  2126,  2127,  2149,  2150,  2151,  2152,  2155,  2156,
    2157,  2158,  2161,  2162,  2168,  2169,  2170,  2171,  2172,  2173,
    2174,  2177,  2178,  2179,  2180,  2187,  2188,  2189,  2196,  2197,
    2198,  2202,  2203,  2204,  2205,  2206,  2211,  2212,  2215,  2216,
    2217,  2223,  2225,  2227,  2228,  2230,  2232,  2234,  2236,  2238,
    2239,  2241,  2242,  2243,  2244,  2246,  2248,  2250,  2252,  2254,
    2256,  2257,  2293,  2295,  2297,  2299,  2302,  2304,  2306,  2308,
    2312,  2313,  2324,  2325,  2329,  2330,  2345,  2360,  2361,  2364,
    2365,  2366,  2378,  2379,  2394,  2409,  2411,  2418,  2460,  2461,
    2464,  2465,  2466,  2469,  2470,  2471,  2472,  2473,  2474,  2475,
    2476,  2479,  2487,  2497,  2514,  2521,  2528,  2535,  2542,  2547,
    2552,  2553,  2554,  2555,  2556,  2559,  2568,  2575,  2600,  2616,
    2617,  2622,  2641,  2650,  2662,  2677,  2678,  2681,  2681,  2691,
    2692,  2693,  2694,  2695,  2696,  2697,  2698,  2699,  2702,  2705,
    2706,  2709,  2716,  2719,  2726,  2732,  2733,  2742,  2743,  2744,
    2747,  2748,  2760,  2784,  2795,  2826,  2830,  2840,  2854,  2866,
    2867,  2869,  2870,  2871,  2885,  2886,  2887,  2888,  2889,  2890,
    2891,  2895,  2896,  2897,  2910,  2916,  2917,  2918,  2919,  2920,
    2921,  2922,  2923,  2924,  2925,  2926,  2927,  2928,  2929,  2930,
    2948,  2949,  2950,  2951,  2952,  2953,  2954,  2955,  2956,  2957,
    2958,  2959,  2960,  2961,  2962,  2963,  2964,  2966,  2968,  2969,
    2970,  2971,  2972,  2975,  2993,  2994,  2995,  2998,  2999,  3000,
    3001,  3002,  3003,  3004,  3005,  3006,  3007,  3008,  3009,  3010,
    3011,  3012,  3013,  3014,  3015,  3016,  3017,  3018,  3019,  3020,
    3021,  3022,  3023,  3024,  3025,  3026,  3027,  3028,  3029,  3030,
    3031,  3032,  3040,  3048,  3056,  3064,  3072,  3080,  3088,  3096,
    3104,  3105,  3107,  3115,  3123,  3131,  3140,  3149,  3158,  3166,
    3175,  3183,  3184,  3186,  3189,  3190,  3191,  3192,  3199,  3206,
    3207,  3213,  3220,  3221,  3227,  3234,  3235,  3241,  3244,  3247,
    3248,  3249,  3252,  3253,  3254,  3263,  3272,  3273,  3274,  3275,
    3276,  3277,  3278,  3279,  3280,  3281,  3282,  3283,  3284,  3285,
    3286,  3287,  3288,  3289,  3293,  3297,  3298,  3299,  3300,  3301,
    3302,  3303,  3304,  3305,  3306,  3307,  3308,  3309,  3310,  3311,
    3312,  3313,  3314,  3315,  3316,  3317,  3318,  3319,  3320,  3321,
    3322,  3323,  3324,  3332,  3340,  3348,  3349,  3351,  3353,  3364,
    3365,  3366,  3382,  3383,  3384,  3388,  3391,  3392,  3395,  3398,
    3401,  3404,  3407,  3410,  3413,  3416,  3419,  3422,  3423,  3424,
    3427,  3428,  3429,  3429,  3462,  3464,  3466,  3467,  3470,  3487,
    3491,  3495,  3499,  3504,  3508,  3513,  3517,  3521,  3525
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "FORWARD", "FORWARD_TCP", "FORWARD_TLS",
  "FORWARD_SCTP", "FORWARD_UDP", "EXIT", "DROP", "RETURN", "BREAK",
  "LOG_TOK", "ERROR", "ROUTE", "ROUTE_REQUEST", "ROUTE_FAILURE",
  "ROUTE_ONREPLY", "ROUTE_REPLY", "ROUTE_BRANCH", "ROUTE_SEND",
  "ROUTE_EVENT", "EXEC", "SET_HOST", "SET_HOSTPORT", "SET_HOSTPORTTRANS",
  "PREFIX", "STRIP", "STRIP_TAIL", "SET_USERPHONE", "APPEND_BRANCH",
  "REMOVE_BRANCH", "CLEAR_BRANCHES", "SET_USER", "SET_USERPASS",
  "SET_PORT", "SET_URI", "REVERT_URI", "FORCE_RPORT", "ADD_LOCAL_RPORT",
  "FORCE_TCP_ALIAS", "UDP_MTU", "UDP_MTU_TRY_PROTO", "UDP4_RAW",
  "UDP4_RAW_MTU", "UDP4_RAW_TTL", "IF", "ELSE", "SET_ADV_ADDRESS",
  "SET_ADV_PORT", "FORCE_SEND_SOCKET", "SET_FWD_NO_CONNECT",
  "SET_RPL_NO_CONNECT", "SET_FWD_CLOSE", "SET_RPL_CLOSE", "SWITCH", "CASE",
  "DEFAULT", "WHILE", "CFG_SELECT", "CFG_RESET", "URIHOST", "URIPORT",
  "MAX_LEN", "SETFLAG", "RESETFLAG", "ISFLAGSET", "SETAVPFLAG",
  "RESETAVPFLAG", "ISAVPFLAGSET", "METHOD", "URI", "FROM_URI", "TO_URI",
  "SRCIP", "SRCPORT", "DSTIP", "DSTPORT", "TOIP", "TOPORT", "SNDIP",
  "SNDPORT", "SNDPROTO", "SNDAF", "PROTO", "AF", "MYSELF", "MSGLEN", "UDP",
  "TCP", "TLS", "SCTP", "WS", "WSS", "DEBUG_V", "FORK", "FORK_DELAY",
  "MODINIT_DELAY", "LOGSTDERROR", "LOGFACILITY", "LOGNAME", "LOGCOLOR",
  "LOGPREFIX", "LOGPREFIXMODE", "LOGENGINETYPE", "LOGENGINEDATA",
  "XAVPVIAPARAMS", "XAVPVIAFIELDS", "LISTEN", "ADVERTISE", "STRNAME",
  "ALIAS", "SR_AUTO_ALIASES", "DNS", "REV_DNS", "DNS_TRY_IPV6",
  "DNS_TRY_NAPTR", "DNS_SRV_LB", "DNS_UDP_PREF", "DNS_TCP_PREF",
  "DNS_TLS_PREF", "DNS_SCTP_PREF", "DNS_RETR_TIME", "DNS_SLOW_QUERY_MS",
  "DNS_RETR_NO", "DNS_SERVERS_NO", "DNS_USE_SEARCH", "DNS_SEARCH_FMATCH",
  "DNS_NAPTR_IGNORE_RFC", "DNS_CACHE_INIT", "DNS_USE_CACHE",
  "DNS_USE_FAILOVER", "DNS_CACHE_FLAGS", "DNS_CACHE_NEG_TTL",
  "DNS_CACHE_MIN_TTL", "DNS_CACHE_MAX_TTL", "DNS_CACHE_MEM",
  "DNS_CACHE_GC_INT", "DNS_CACHE_DEL_NONEXP", "DNS_CACHE_REC_PREF",
  "AUTO_BIND_IPV6", "BIND_IPV6_LINK_LOCAL", "DST_BLST_INIT",
  "USE_DST_BLST", "DST_BLST_MEM", "DST_BLST_TTL", "DST_BLST_GC_INT",
  "DST_BLST_UDP_IMASK", "DST_BLST_TCP_IMASK", "DST_BLST_TLS_IMASK",
  "DST_BLST_SCTP_IMASK", "IP_FREE_BIND", "PORT", "STAT", "CHILDREN",
  "SOCKET_WORKERS", "ASYNC_WORKERS", "ASYNC_USLEEP", "ASYNC_NONBLOCK",
  "CHECK_VIA", "PHONE2TEL", "MEMLOG", "MEMDBG", "MEMSUM", "MEMSAFETY",
  "MEMJOIN", "MEMSTATUSMODE", "CORELOG", "SIP_WARNING", "SERVER_SIGNATURE",
  "SERVER_HEADER", "USER_AGENT_HEADER", "REPLY_TO_VIA", "LOADMODULE",
  "LOADPATH", "MODPARAM", "CFGENGINE", "MAXBUFFER", "SQL_BUFFER_SIZE",
  "USER", "GROUP", "CHROOT", "WDIR", "RUNDIR", "MHOMED", "DISABLE_TCP",
  "TCP_ACCEPT_ALIASES", "TCP_ACCEPT_UNIQUE", "TCP_CONNECTION_MATCH",
  "TCP_CHILDREN", "TCP_CONNECT_TIMEOUT", "TCP_SEND_TIMEOUT",
  "TCP_CON_LIFETIME", "TCP_POLL_METHOD", "TCP_MAX_CONNECTIONS",
  "TLS_MAX_CONNECTIONS", "TCP_NO_CONNECT", "TCP_SOURCE_IPV4",
  "TCP_SOURCE_IPV6", "TCP_OPT_FD_CACHE", "TCP_OPT_BUF_WRITE",
  "TCP_OPT_CONN_WQ_MAX", "TCP_OPT_WQ_MAX", "TCP_OPT_RD_BUF",
  "TCP_OPT_WQ_BLK", "TCP_OPT_DEFER_ACCEPT", "TCP_OPT_DELAYED_ACK",
  "TCP_OPT_SYNCNT", "TCP_OPT_LINGER2", "TCP_OPT_KEEPALIVE",
  "TCP_OPT_KEEPIDLE", "TCP_OPT_KEEPINTVL", "TCP_OPT_KEEPCNT",
  "TCP_OPT_CRLF_PING", "TCP_OPT_ACCEPT_NO_CL", "TCP_OPT_ACCEPT_HEP3",
  "TCP_OPT_ACCEPT_HAPROXY", "TCP_CLONE_RCVBUF", "TCP_REUSE_PORT",
  "DISABLE_TLS", "ENABLE_TLS", "TLSLOG", "TLS_PORT_NO", "TLS_METHOD",
  "TLS_HANDSHAKE_TIMEOUT", "TLS_SEND_TIMEOUT", "SSLv23", "SSLv2", "SSLv3",
  "TLSv1", "TLS_VERIFY", "TLS_REQUIRE_CERTIFICATE", "TLS_CERTIFICATE",
  "TLS_PRIVATE_KEY", "TLS_CA_LIST", "DISABLE_SCTP", "ENABLE_SCTP",
  "SCTP_CHILDREN", "ADVERTISED_ADDRESS", "ADVERTISED_PORT", "DISABLE_CORE",
  "OPEN_FD_LIMIT", "SHM_MEM_SZ", "SHM_FORCE_ALLOC", "MLOCK_PAGES",
  "REAL_TIME", "RT_PRIO", "RT_POLICY", "RT_TIMER1_PRIO",
  "RT_TIMER1_POLICY", "RT_TIMER2_PRIO", "RT_TIMER2_POLICY",
  "MCAST_LOOPBACK", "MCAST_TTL", "MCAST", "TOS", "PMTU_DISCOVERY",
  "KILL_TIMEOUT", "MAX_WLOOPS", "PVBUFSIZE", "PVBUFSLOTS", "PVCACHELIMIT",
  "PVCACHEACTION", "HTTP_REPLY_PARSE", "VERSION_TABLE_CFG",
  "VERBOSE_STARTUP", "ROUTE_LOCKS_SIZE", "CFG_DESCRIPTION", "SERVER_ID",
  "KEMI", "ONSEND_ROUTE_CALLBACK", "REPLY_ROUTE_CALLBACK",
  "EVENT_ROUTE_CALLBACK", "RECEIVED_ROUTE_CALLBACK", "RECEIVED_ROUTE_MODE",
  "MAX_RECURSIVE_LEVEL", "MAX_BRANCHES_PARAM", "LATENCY_CFG_LOG",
  "LATENCY_LOG", "LATENCY_LIMIT_DB", "LATENCY_LIMIT_ACTION",
  "LATENCY_LIMIT_CFG", "MSG_TIME", "ONSEND_RT_REPLY", "FLAGS_DECL",
  "AVPFLAGS_DECL", "ATTR_MARK", "SELECT_MARK", "ATTR_FROM", "ATTR_TO",
  "ATTR_FROMURI", "ATTR_TOURI", "ATTR_FROMUSER", "ATTR_TOUSER",
  "ATTR_FROMDOMAIN", "ATTR_TODOMAIN", "ATTR_GLOBAL", "ADDEQ", "SUBST",
  "SUBSTDEF", "SUBSTDEFS", "EQUAL", "LOG_OR", "LOG_AND", "BIN_OR",
  "BIN_AND", "BIN_XOR", "BIN_LSHIFT", "BIN_RSHIFT", "EQUAL_T", "DIFF",
  "MATCH", "INTEQ", "INTDIFF", "STREQ", "STRDIFF", "GT", "LT", "GTE",
  "LTE", "PLUS", "MINUS", "STAR", "SLASH", "MODULO", "NOT", "UNARY",
  "BIN_NOT", "DEFINED", "INTCAST", "STRCAST", "DOT", "STRLEN", "STREMPTY",
  "NUMBER", "ID", "NUM_ID", "STRING", "IPV6ADDR", "PVAR", "AVP_OR_PVAR",
  "EVENT_RT_NAME", "COMMA", "SEMICOLON", "RPAREN", "LPAREN", "LBRACE",
  "RBRACE", "LBRACK", "RBRACK", "CR", "COLON", "$accept", "cfg",
  "statements", "statement", "$@1", "$@2", "$@3", "$@4", "$@5",
  "listen_id", "listen_id_lst", "listen_id2", "proto", "eqproto", "port",
  "phostport", "listen_phostport", "id_lst", "intno", "flags_decl",
  "flag_list", "flag_spec", "flag_name", "avpflags_decl", "avpflag_list",
  "avpflag_spec", "assign_stm", "cfg_var_id", "cfg_var_idn", "cfg_var",
  "module_stm", "ip", "ipv4", "ipv6addr", "ipv6", "route_name",
  "route_main", "route_stm", "failure_route_main", "failure_route_stm",
  "route_reply_main", "onreply_route_stm", "$@6", "$@7",
  "branch_route_main", "branch_route_stm", "send_route_main",
  "send_route_stm", "event_route_main", "event_route_stm",
  "preprocess_stm", "equalop", "cmpop", "strop", "rve_equalop",
  "rve_cmpop", "uri_type", "eint_op_onsend", "eint_op", "eip_op_onsend",
  "eip_op", "exp_elem", "ipnet", "host", "host_if_id", "host_or_if",
  "fcmd", "stm", "actions", "action", "if_cmd", "ct_rval", "single_case",
  "case_stms", "switch_cmd", "while_cmd", "select_param", "select_params",
  "select_id", "$@8", "attr_class_spec", "attr_name_spec", "attr_spec",
  "attr_mark", "attr_id", "attr_id_num_idx", "attr_id_no_idx",
  "attr_id_ass", "attr_id_any", "attr_id_any_str", "pvar", "avp_pvar",
  "assign_op", "lval", "rval", "rve_un_op", "rval_expr", "assign_action",
  "avpflag_oper", "cmd", "$@9", "func_params", "func_param", "ret_cmd", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606
};
# endif

#define YYPACT_NINF -1168

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-1168)))

#define YYTABLE_NINF -893

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    2440,  -275,    39,    19,  -242,  -234,  -211,  -164,  -143,  -135,
   -1168,  -123,  -100,   -86,   -46,   -40,   -31,   -29,   -13,     4,
      23,    32,   140,   151,   251,   538,   539,   544,   555,   580,
      44,    51,   142,   710,   711,   714,   741,   752,   798,   810,
     811,   815,   817,   819,   821,   837,   859,   864,   867,   893,
     903,   905,   908,   909,   910,   916,   918,   921,   929,   931,
     942,   944,   945,   955,   958,   959,   583,   587,   592,   602,
     607,   611,   612,   641,   678,   686,   707,   709,   721,   722,
     728,   761,   768,   777,   804,   823,   850,    63,    24,    21,
     101,   873,   877,   884,   885,   889,   890,   894,   899,   900,
     904,   914,   920,   932,   943,   946,   952,   957,   967,   970,
     995,  1010,  1047,  1050,  1052,   968,   969,   971,   972,  1053,
    1055,  1057,  1059,  1061,  1063,  1064,  1066,  1067,  1069,  1070,
    1071,  1076,  1077,  1078,  1132,  1133,  1158,  1160,  1161,  1167,
    1168,  1169,  1170,  1178,  1179,  1180,  1181,  1183,  1184,  1186,
    1188,  1189,  1197,  1198,  1199,  1200,  1204,  1231,  1232,  1233,
    1234,  1235,  1236,  1237,  1238,  1239,   973,  1240,  1241,  1242,
    1243,  1247,  1248,  1249,  1251,  1253,  1254,  1255,    -1,  1256,
    1257,  1283,  1284,  1290,  1291,  1292,  1293,  1294,  1295,   164,
     219,    83,   147,   175, -1168, -1168, -1168,   961,  1545, -1168,
     157,   950,   979,   947,   981, -1168, -1168, -1168,  -265, -1168,
   -1168,   646, -1168, -1168, -1168, -1168,   491, -1168,   124,   204,
     862,   315,   300,   305,   316,   308,   322,   350,   353,    69,
     186,   355,   208,   356,   218,   230,   231,   246,    33,    61,
     362,   556,   599, -1168,   669, -1168,   670, -1168,   687, -1168,
    -175, -1168,  -175, -1168,  -175, -1168,  -175, -1168,   705, -1168,
     724, -1168,   731, -1168,   732, -1168,   739, -1168,   843, -1168,
    1263, -1168,  1264, -1168,  1265, -1168,  1266, -1168,  1267, -1168,
    1297, -1168,  1298, -1168,  1299, -1168,  1300, -1168,  1302, -1168,
    1303, -1168,  1320, -1168,  1321, -1168,  1364, -1168,  1437, -1168,
    1438, -1168,  1439, -1168,  1440, -1168,  1478, -1168,  1481, -1168,
    1482, -1168,  1483, -1168,  1484,   319,   613,   623,   647,   650,
     651,   657,   659,   660,   320,   334,   336,   341,   342,   345,
     357,   666,   671,   255,   257,   672, -1168, -1168, -1168,   258,
   -1168, -1168,   643, -1168,   259, -1168,   685,   691,   225,   234,
     238,   239,   244,   692,   693,   694,   696,   697,   698,   503,
     584,   586,   245,   699,   700,   701,   702,    42,   703,   704,
   -1168,  1497, -1168,  1498, -1168,  1499, -1168,  1500,   706,   712,
     713,   715,   720,   729,   730,   733,   734,   736,   737,   738,
     740,   746,   747,   748,   749,   750,  1023,   751,   753,   754,
     755,   261,   262,   265,   756,   757,   758,   113,   759,   760,
     762,   763,   764,   770,   772,   779,   780,   781,   783,   785,
     787,   789,   791,   249,   297, -1168,  1501,   792,   793,   794,
     796,   797,   799,   800,   266,   801,   802,   803,   830,   610,
    1502,  1503,   634,   637,   805,   806,   807,   808,   809, -1168,
   -1168, -1168, -1168,   892,   744, -1168, -1168, -1168,  1285, -1168,
   -1168, -1168, -1168, -1168, -1168, -1168,  -275, -1168,    59,    45,
    1280, -1168,    62,  1282, -1168,    75,  1289, -1168,    78,  1492,
   -1168,    71,   695, -1168,    -3,  1505, -1168, -1168, -1168, -1168,
    1491, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168,
   -1168, -1168, -1168,  1507, -1168, -1168, -1168, -1168, -1168, -1168,
   -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168,
   -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168,
   -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168,   822,
   -1168, -1168, -1168, -1168,  1129,  1504, -1168,  1278,  1495,  1138,
     826, -1168, -1168, -1168, -1168, -1168,  -114, -1168, -1168, -1168,
   -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168,
   -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168,
   -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168,
   -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168,
   -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168,
   -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168,
   -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168,
   -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168,
   -1168, -1168, -1168, -1168, -1168,  1529, -1168, -1168, -1168, -1168,
   -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168,
   -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168,
   -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168,
   -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168,
   -1168, -1168, -1168, -1168, -1168,   822, -1168, -1168, -1168, -1168,
   -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168,
   -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168,
   -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168,
   -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168,
   -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168,
   -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168,
   -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168,
   -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168,
   -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168,
   -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168,
   -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168,
   -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168,
   -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168,  1571,
    1572,  1573,  1574, -1168, -1168, -1168, -1168, -1168, -1168, -1168,
   -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168,
   -1168,  -129,  1513,  -129, -1168,   491, -1168, 11662, -1168,   491,
   11662, -1168,   491, 11662, -1168,   491, 11662, -1168,  1535, -1168,
   -1168, -1168,  1576,  1530, 11662,    48, -1168,  1544,  1539,  1538,
    1534,   325,  1007, -1168,  1129,  1547,   291,   294,  1548,   267,
     268,   270,   273, -1168, -1168, -1168,  1537,    29,    80,    86,
      88,    91, 10580, 10924, 11009, -1168,    92,    94,    95,  1542,
      99,   100,   110,   111,   112,   114,   115,   117,  1563,   118,
     119,   125,   127,  1564,  1565,  1566,  1567,  1568, 11094,   133,
     143,   146,  1569,  1578,  1589,  1591,  6268, 11094,   153,   162,
     172,   173,   174, -1168, -1168, -1168, -1168,   183, -1168, -1168,
   -1168,    36,  3539, -1168, -1168, -1168, -1168,  1011, -1168, -1168,
   -1168, -1168, -1168,  1588,  1549,   192, -1168,  1550,  1600,  3613,
    1601,  3693,  1605,  3958,  1606,   163,  1560,  4038, -1168,  1592,
    1609,  1129, -1168, -1168, -1168, -1168, -1168, -1168,  1586,   -62,
   -1168, -1168, -1168, -1168, -1168, -1168,  1614, -1168, -1168, -1168,
   -1168, -1168, -1168, -1168, -1168,  1618, -1168,    38, -1168,   131,
   -1168,   155, -1168,   187, -1168,   196,   852, -1168, -1168, -1168,
   -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168,   -72, -1168,
     -72, -1168,   898, -1168, -1168,  1507, -1168, -1168,  6355,  6442,
    6788,  1632,  1633, -1168,  5402, 11592, -1168,   878, -1168,   840,
   -1168,   888, -1168, -1168, -1168,  1011, -1168, -1168, -1168, -1168,
   -1168, -1168, -1168,  6875,  1301,  5748,  1301,  5835,  1301, -1168,
     195, -1168,   275, -1168,  6962,  1642, -1168,   276, -1168,   278,
   -1168,   279, -1168,   280, -1168,   812, -1168,   813, -1168,  1636,
   -1168,   161,  1637, -1168,   281, -1168,   282, -1168,   283, -1168,
     284,  1638,  1639,  1648,   141,   874,  7308, 10513, -1168,   213,
   -1168,   814, -1168,    79,  1659,  1661,  1662,  1663, -1168,  1013,
   10513, -1168,   285, -1168,   286, -1168,   679, -1168,   683, -1168,
     742, -1168,  1664, -1168, -1168, -1168, -1168, -1168, -1168, -1168,
   -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168,  1687, -1168,
    1671, -1168, 11094, -1168, -1168,    22, -1168,  1677, -1168,  1678,
   -1168,  1679, -1168,  1700, -1168,  1766,  1780,    -3, -1168, 11662,
    1714, -1168,  -249,  1712,  1716,  -246, 11662,  1707,  -108, -1168,
     -48, -1168,   384,  -132,  1708,   475,   479,   489,  -131,  1717,
     522,   527,   765,   513,  1728,   766,   876,   895,   665,  1730,
     896,   933,   934,  1019, -1168, -1168, -1168, -1168, -1168, -1168,
   -1168,  7395,  5216,  5309, -1168,  1215,  1740, -1168, -1168, -1168,
   -1168, -1168, -1168,  7482,  7828,  1732, -1168,  1777,  1786,  1787,
    1791,  1079,  1749,  1747,  4107, -1168,  7915, -1168, -1168, -1168,
   -1168, -1168,  8002,  8348, -1168,  2773,  1754, -1168, -1168,  8435,
    8522,  8868,  8955, 11094, 11094, 11094, -1168, -1168, -1168, -1168,
   -1168, -1168, -1168, -1168, -1168, -1168, -1168,  9042,  9388,  9475,
    9562,  9908,  9995, 10082, -1168, -1168,  1771,  1774,  1773,  1775,
    1776,  1797,    85,  1134,  1799,  1800,  1801,  1803,  1812,  1813,
    1817,  1818,  1819,  1826,  1827,  1828,  1829, -1168,  1830, -1168,
    1831, -1168,  1832,  1833,  1834,  1836,  1837,  1838,  1839,  1840,
   -1168, -1168, -1168,  1841,  1842, -1168,  1843,  1844, 11662,  2073,
   -1168,  1845,  1846,  1847,  1848,  1849,  1770,  1779,  1850, -1168,
   -1168, -1168, -1168,    41, -1168,  1874,  1877,  1876,  1878,  1879,
    1881,  1882,  1883,  1885,  1886, 11094,  1896,  1872,  1301,   948,
   -1168,  1011, -1168,  1892, -1168, 11662, 11662, 11662, 11662,  1903,
    1904,  1941,  4181,  1912, -1168, -1168,  2135,  1902,  1905,  4303,
   -1168,   -24, -1168,  1913, -1168,  1916, -1168,   132,   298,  1917,
   -1168, -1168,     7, -1168,  1918, -1168,  1919, -1168,  1920, -1168,
   -1168,    15, -1168,  1921, -1168,  1922, -1168,  1923, -1168, -1168,
      16, -1168,  1924, -1168,  1925, -1168,  1926, -1168, -1168,   120,
   -1168,  1927, -1168,  1928, -1168,  1929, -1168, -1168,  1962,  1108,
   -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168,  1108,
   -1168, -1168,  1108, -1168, -1168, -1168,  1939, -1168,  1957,  1945,
    1207,  1946,  1546, -1168, -1168, -1168, -1168, -1168, -1168,  2031,
    1108, -1168,  1108, -1168,  1173, -1168,  2100,   822,  1893,  1968,
   -1168,   -19,  1108,  -204, -1168,  2438, -1168,  2764, -1168,  2911,
   -1168,  1098,  2930,  2977,  1258, -1168,   601, -1168,   601, -1168,
   -1168, -1168, -1168, -1168, -1168, -1168,  1108, -1168,  1173, -1168,
    1955, -1168, -1168,  1956, -1168, -1168, -1168, -1168, -1168, -1168,
   -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168,
   -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168,
   -1168, -1168, -1168, -1168,  4526, 11523, -1168, -1168, -1168, -1168,
   -1168,   347,  1129, -1168,  1947,  5922,  1944, -1168, -1168,   502,
   -1168, 11438, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168,
    1301,  1005, -1168, -1168, -1168,  -129, -1168, -1168,   253,  4648,
    4717,  4791,  4871, -1168, -1168,  -154, -1168,  1964,  1959, -1168,
   -1168, -1168,  1965,  1966,  1967,  1970, -1168, -1168, -1168, -1168,
    1971,  1972,  1974,  1975,  1976,  1977,  1978,  1979,  1980,  1981,
    1982,  1983,  1984,  1985,  1986,  1987,  1988,  2012,  2013,  2014,
    2015,   546,  1740, -1168, -1168, -1168, -1168,    55,  1950,  2016,
    2017, -1168, -1168, -1168, -1168,  1949, -1168,  1952, 10428,  1961,
    1301, 11662, -1168, -1168,  2018,  2205, 11094, -1168,  2019,  2020,
    2021, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168,
   -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168,
   -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168,
   -1168, -1168, -1168, -1168,  2023,  2027, -1168, -1168,   822, -1168,
   -1168, -1168, -1168,  -249, 11662,  2028,  2029,  2860,  2929, -1168,
   -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168,  2998, 11662,
   11662, -1168,  3125,  3348,  3470
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     455,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   454,    22,    23,     0,     0,     4,
       0,     0,     0,     0,     0,     8,     9,     6,     0,   452,
      10,     0,    15,     7,   453,   502,     0,   503,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   105,     0,   107,     0,   109,     0,   111,
       0,   113,     0,   115,     0,   117,     0,   119,     0,   121,
       0,   123,     0,   125,     0,   127,     0,   129,     0,   131,
       0,   133,     0,   135,     0,   137,     0,   139,     0,   141,
       0,   145,     0,   143,     0,   147,     0,   149,     0,   151,
       0,   153,     0,   155,     0,   157,     0,   159,     0,   161,
       0,   163,     0,   165,     0,   167,     0,   169,     0,   171,
       0,   173,     0,   175,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   467,   466,   469,     0,
     468,   474,     0,   476,     0,   475,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     267,     0,   269,     0,   271,     0,   273,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   393,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    60,
      66,    65,    59,    61,    63,    68,    71,    67,    69,   519,
     518,   521,   520,   523,   522,     1,     5,     3,     0,     0,
       0,    12,     0,     0,    14,     0,     0,    17,     0,     0,
      19,     0,     0,    21,     0,     0,   500,   485,   486,   487,
       0,   443,   442,   441,   440,   445,    31,    32,    33,    34,
      35,   444,   447,     0,    57,   446,   449,   448,   451,   450,
      73,    72,    75,    74,    77,    76,    79,    78,    81,    80,
      83,    82,    85,    84,    87,    86,    89,    88,    91,    90,
      93,    92,    95,    94,    97,    96,    99,    98,   349,   601,
     599,   600,    25,   482,     0,     0,    30,    50,     0,    55,
     343,    24,   479,   483,   480,   602,    26,   351,   350,   353,
     352,   101,   100,   103,   102,   104,   106,   108,   110,   112,
     114,   116,   118,   120,   122,   124,   126,   128,   130,   132,
     134,   136,   138,   140,   144,   142,   146,   148,   150,   152,
     154,   156,   158,   160,   162,   164,   166,   168,   170,   172,
     174,   177,   176,   183,   178,   185,   184,   187,   186,   189,
     188,   191,   190,   193,   192,   195,   194,   197,   196,   199,
     198,   201,   200,   203,   202,   205,   204,   207,   206,   209,
     208,   211,   210,   213,   212,   336,   335,   338,   337,   340,
     339,   342,   341,   471,   470,     0,   478,   477,   180,   179,
     182,   181,   218,   217,   216,   221,   220,   219,   224,   223,
     222,   227,   226,   225,   230,   229,   228,   232,   231,   234,
     233,   236,   235,   238,   237,   240,   239,   242,   241,   244,
     243,   246,   245,   248,   247,   251,   249,   250,   253,   252,
     255,   254,   257,   256,   259,     0,   258,   261,   260,   263,
     262,   265,   264,   266,   268,   270,   272,   275,   274,   277,
     276,   279,   278,   281,   280,   283,   282,   285,   284,   287,
     286,   289,   288,   291,   290,   293,   292,   295,   294,   297,
     296,   299,   298,   301,   300,   303,   302,   305,   304,   307,
     306,   309,   308,   314,   310,   311,   312,   313,   326,   325,
     328,   327,   316,   315,   318,   317,   320,   319,   322,   321,
     324,   323,   330,   329,   332,   331,   334,   333,   355,   354,
     357,   356,   359,   358,   361,   360,   363,   362,   365,   364,
     367,   366,   369,   368,   371,   370,   373,   372,   375,   374,
     377,   376,   379,   378,   381,   380,   383,   382,   385,   384,
     388,   386,   387,   391,   389,   390,   392,   395,   394,   397,
     396,   399,   398,   401,   400,   403,   402,   405,   404,   407,
     406,   215,   214,   409,   408,   411,   410,   413,   412,     0,
       0,     0,     0,   423,   422,   424,   425,   429,   428,   427,
     426,   431,   430,   433,   432,   435,   434,   437,   436,   439,
     438,     0,     0,     0,   492,     0,   493,     0,   497,     0,
       0,   510,     0,     0,   514,     0,     0,   517,     0,   457,
     458,   456,     0,     0,     0,     0,    58,     0,    27,     0,
       0,     0,     0,    56,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    62,    64,    70,     0,     0,     0,     0,
       0,     0,   904,   901,   905,   908,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   857,   859,   861,   864,     0,     0,     0,
       0,     0,   878,   880,   882,   884,     0,     0,     0,     0,
       0,     0,     0,   734,   735,   736,   661,     0,   673,   674,
     619,     0,     0,   611,   614,   615,   616,     0,   665,   666,
     676,   677,   678,     0,     0,     0,   607,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   506,     0,
       0,     0,    29,   484,    54,    44,    43,    51,    52,   347,
     344,   606,   601,   604,   605,   603,     0,   415,   414,   417,
     416,   419,   418,   421,   420,     0,   747,     0,   769,     0,
     780,     0,   791,     0,   758,     0,     0,   545,   546,   547,
     558,   551,   559,   552,   557,   549,   556,   548,     0,   550,
       0,   553,     0,   554,   647,   693,   691,   692,     0,     0,
       0,     0,     0,   680,     0,     0,   679,     0,   555,     0,
     560,     0,   686,   685,   684,     0,   667,   669,   668,   681,
     682,   683,   694,     0,   903,     0,   900,     0,   907,   795,
       0,   812,     0,   816,     0,     0,   820,     0,   839,     0,
     842,     0,   823,     0,   829,     0,   826,     0,   832,     0,
     835,     0,     0,   848,     0,   851,     0,   845,     0,   854,
       0,     0,     0,     0,     0,     0,     0,     0,   870,     0,
     873,     0,   876,     0,     0,     0,     0,     0,   639,     0,
       0,   887,     0,   890,     0,   799,     0,   802,     0,   805,
       0,   894,     0,   620,   613,   612,   490,   610,   649,   650,
     651,   652,   653,   654,   655,   656,   657,   658,     0,   659,
     662,   675,     0,   618,   810,     0,   617,     0,   495,     0,
     508,     0,   512,     0,   463,   459,   460,     0,   501,     0,
       0,    28,     0,     0,     0,     0,     0,     0,     0,   594,
       0,   737,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   564,   524,   525,   533,   526,   527,
     532,     0,     0,     0,   589,     0,     0,   732,   715,   717,
     696,   718,   697,     0,     0,     0,   902,   667,   668,   682,
     683,     0,     0,     0,     0,   568,     0,   573,   528,   529,
     530,   531,     0,     0,   585,     0,   662,   716,   695,     0,
       0,     0,     0,     0,     0,     0,   534,   535,   540,   536,
     537,   538,   539,   541,   542,   543,   544,     0,     0,     0,
       0,     0,     0,     0,   899,   906,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   831,     0,   834,
       0,   837,     0,     0,     0,     0,     0,     0,     0,     0,
     856,   858,   860,     0,     0,   863,     0,     0,     0,   621,
     608,     0,     0,     0,     0,     0,    45,     0,     0,   877,
     879,   881,   883,     0,   641,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   895,     0,     0,   733,     0,
     672,     0,   670,     0,   671,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    53,   348,   345,     0,     0,     0,
     748,     0,   746,     0,   739,     0,   740,     0,     0,     0,
     738,   770,     0,   768,     0,   761,     0,   762,     0,   760,
     781,     0,   779,     0,   772,     0,   773,     0,   771,   792,
       0,   790,     0,   783,     0,   784,     0,   782,   759,     0,
     757,     0,   750,     0,   751,     0,   749,   563,     0,   561,
     579,    36,    37,    38,    39,    40,    41,    42,   577,   578,
     576,   574,   575,   588,   586,   587,   642,   646,   648,     0,
       0,     0,     0,   690,   712,   689,   688,   687,   567,     0,
     565,   572,   570,   571,   569,   584,     0,    57,     0,   592,
     580,   582,   581,     0,   729,   711,   728,   710,   724,   703,
     725,   704,   705,   706,   707,   719,   698,   720,   699,   721,
     700,   722,   701,   723,   702,   727,   709,   726,   708,   796,
       0,   793,   813,     0,   817,   815,   814,   818,   821,   819,
     840,   838,   843,   841,   824,   822,   830,   828,   827,   825,
     836,   833,   849,   847,   852,   850,   846,   844,   855,   853,
     865,   862,   867,   866,     0,     0,   869,   868,   872,   871,
     875,     0,     0,   874,     0,     0,     0,   638,   636,     0,
     888,     0,   891,   889,   797,   798,   800,   801,   803,   804,
     898,     0,   897,   660,   664,     0,   809,   662,     0,     0,
       0,     0,     0,   461,   462,     0,   505,     0,     0,   472,
     473,   491,     0,     0,     0,     0,   598,   596,   597,   595,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   730,   713,   731,   714,     0,     0,     0,
       0,   609,   622,    49,    46,    47,   640,     0,     0,     0,
     623,   629,   637,   635,    57,     0,     0,   893,     0,     0,
       0,   496,   509,   513,   516,   464,   465,   481,   346,   744,
     745,   742,   743,   741,   766,   767,   764,   765,   763,   777,
     778,   775,   776,   774,   788,   789,   786,   787,   785,   755,
     756,   753,   754,   752,     0,     0,   645,   593,   591,   590,
     663,   794,   811,     0,   632,     0,     0,     0,     0,   885,
     886,   896,   808,   807,   806,   644,   643,    48,     0,   633,
     627,   634,     0,     0,     0
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1168, -1168, -1168,  2169, -1168, -1168, -1168, -1168, -1168,  -403,
    1387,  1487,  -218,  1165, -1167, -1168, -1168,   -53,  -221, -1168,
    1532, -1168,  -189, -1168,  1528, -1168, -1168, -1168,  1217, -1168,
   -1168, -1001,  2022,  1851,  2024,  -562, -1168, -1168, -1168, -1168,
   -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168, -1168,
   -1168, -1021, -1168,  -740, -1168, -1168,  1172, -1168, -1168, -1168,
    1174, -1168, -1168,   -14,  -692, -1168,  -186, -1103,  -847,  -916,
   -1168,   767,   851, -1168, -1168, -1168,   790, -1168, -1168, -1168,
   -1168,  1048, -1004,  -380,  -842, -1168,  -792, -1168, -1168, -1168,
    -633,  -816, -1168, -1168, -1168, -1168,    12,   108, -1168, -1168,
   -1168, -1168,   769, -1168
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,   197,   198,   199,   200,   201,   202,   203,   204,   546,
     879,   547,   548,  1428,   987,  1328,   549,   550,  1046,   205,
     452,   453,   454,   206,   457,   458,   207,   208,   872,   209,
     210,   551,   552,   553,   554,   490,   470,   471,   473,   474,
     211,   212,   874,   979,   476,   477,   479,   480,   482,   483,
     213,  1210,  1243,  1211,  1272,  1273,  1047,  1048,  1049,  1050,
    1051,  1052,  1460,  1183,   555,   556,  1053,  1319,   952,   953,
     954,  1619,  1538,  1539,   955,   956,  1437,  1438,  1054,  1216,
    1148,  1149,  1150,  1055,  1056,  1057,  1058,   960,  1059,  1353,
    1060,  1061,  1152,   963,  1062,  1063,  1231,   964,   965,   966,
    1132,  1551,  1552,   967
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     505,   456,   501,   511,   769,  1364,  1182,  1212,  1187,  1213,
    1192,  1215,  1197,   969,  1202,   958,   971,  1334,   958,   973,
     217,   958,   341,  1349,   958,   338,   214,   977,  1242,   568,
    1006,   569,   958,   570,   538,   571,  1137,  1133,  1572,  1177,
     215,   962,  1534,   697,   962,   243,   856,   962,  1173,   978,
     962,  1246,   245,  1137,   869,  1137,  1667,  1137,   962,   218,
     854,  1137,   557,   858,   336,   959,   484,   219,   959,  1581,
     520,   959,   867,   985,   959,   503,   861,  1586,  1591,   864,
    1325,  1008,   959,   485,   459,   986,  1131,  1010,   504,  1012,
     220,  1367,  1014,  1069,   602,  1071,  1073,  1535,  1536,  1178,
    1076,  1078,   343,   620,   622,   624,   626,   628,   630,   632,
     958,  1080,  1082,  1084,   768,  1086,  1088,   503,  1090,  1093,
    1095,   496,   497,   498,   499,   491,  1097,   958,  1099,   958,
     504,   958,  1184,  1576,  1108,   958,   962,   221,   680,   682,
     684,   878,  1313,   247,  1110,  1554,   503,  1112,   461,   496,
     497,   498,   499,   962,  1121,   962,  1189,   962,   222,   504,
     959,   962,  1298,  1123,  1164,   449,   223,   496,   497,   498,
     499,   468,   469,  1125,  1127,  1129,   463,   959,   224,   959,
    1635,   959,  1596,  1636,  1131,   959,   558,   522,  1194,  1377,
    1377,  1320,  1185,  1154,   993,   995,  1276,  1199,  1234,  1378,
    1378,   225,  1227,   958,  1320,   493,   450,   886,   451,   526,
    1379,  1388,  1380,  1389,  1321,   226,  1190,   887,   834,   530,
     455,   838,   840,  1227,   961,  1227,   652,   961,  1230,   962,
     961,   532,   534,   961,  1371,   655,  1372,  1205,  1206,   658,
     661,   961,  1208,  1209,  1459,   664,   685,   536,  1195,  1230,
     800,  1230,  1228,   959,  1629,   227,   637,  1200,   639,   643,
     646,   228,   756,   758,  1227,   958,   760,   821,   997,   999,
     229,  1001,   230,  1228,  1003,  1228,  1279,  1285,   958,  1287,
    1289,  1291,  1302,  1304,  1306,  1308,  1335,  1337,   231,  1174,
    1230,   962,   991,   896,  1373,   994,  1374,   968,   803,  1578,
     970,   506,  1377,   972,   962,   232,   508,  1236,   946,   512,
    1573,  1245,  1378,  1352,  1228,   959,   502,   510,  1137,   961,
     601,   619,  1362,   514,   233,   339,   984,   958,   959,  1369,
     438,   870,   871,   234,   958,   621,   961,   623,   961,  1354,
     961,  1582,   625,   627,   961,   244,   629,  1557,  1613,  1587,
    1592,   516,   246,   962,   518,   500,   524,   528,   631,  1350,
     962,   340,   949,   559,  1614,  -499,   342,   539,   540,   541,
     542,   543,   695,  1179,  1007,  1180,   543,   959,   544,  1134,
     543,   545,  1181,   500,   959,  -498,   545,   216,  1537,  1668,
     545,  -489,   958,   543,  -504,   539,   540,   541,   542,   543,
     337,   500,   344,   545,   521,  -488,   544,   855,  -494,   545,
     859,  1229,   961,   539,   540,   541,   542,   543,   962,  -515,
     460,  -507,  1612,   862,  -511,  1009,   865,   545,  1215,  1495,
    -892,  1011,  1229,  1013,  1229,  1215,  1015,  1070,   345,  1072,
    1074,   235,   959,   248,  1077,  1079,  1137,   539,   540,   541,
     542,   543,   236,  1137,  1597,  1081,  1083,  1085,   492,  1087,
    1089,   545,  1091,  1094,  1096,   695,  1179,  1577,  1186,   543,
    1098,  1524,  1100,  1229,   961,  1314,   958,   957,  1109,   545,
     957,   989,   503,   957,   462,  1315,   957,   961,  1111,   695,
    1179,  1113,  1191,   543,   957,   504,   883,  1165,  1122,   450,
    1166,   451,   962,   545,   679,  1299,  1687,  1124,  1559,  1560,
    1561,  1562,   464,   958,   958,   958,   958,  1126,  1128,  1130,
     958,   695,  1179,   523,  1196,   543,   959,   958,  -892,  1277,
     695,  1179,  1278,  1201,   543,   545,   961,  1155,   494,   962,
     962,   962,   962,   961,   545,   527,   962,   539,   540,   541,
     542,   543,   237,   962,   450,   531,   451,   561,  1535,  1536,
     653,   545,   654,   959,   959,   959,   959,   533,   535,   656,
     959,   657,   957,   659,   662,   660,   663,   959,   878,   665,
     686,   666,   687,   537,   801,   681,   802,   683,   450,   957,
     451,   957,   638,   957,   640,   644,   647,   957,   757,   759,
     563,   961,   761,   822,   998,  1000,  1669,  1002,  1137,  1320,
    1004,   833,  1280,  1286,   603,  1288,  1290,  1292,  1303,  1305,
    1307,  1309,  1336,  1338,   605,   992,   540,   541,   992,   540,
     541,   804,   805,  1579,   507,   837,   503,   503,   839,   509,
     503,   503,   513,  1137,  1137,  1137,  1137,   985,   607,   504,
     504,   609,   611,   504,   504,   503,   515,   503,   613,   986,
     615,   617,   503,   503,   456,   957,   503,   633,   504,   985,
     504,   951,   635,   641,   951,   504,   504,   951,   503,   504,
     951,   986,   958,   958,   517,   961,   648,   519,   951,   525,
     529,   504,   650,   667,   669,   671,   560,   673,   675,   677,
     688,   690,   692,   694,   699,   701,  1322,   707,   962,   962,
    1326,   249,   251,   709,   711,   253,   713,   958,   958,   958,
     958,   715,   961,   961,   961,   961,  1375,   957,  1376,   961,
     717,   719,   959,   959,   721,   723,   961,   725,   727,   729,
     957,   731,   255,   962,   962,   962,   962,   733,   735,   737,
     739,   741,   748,   257,   750,   752,   754,   762,   764,   766,
     770,   772,  1137,   774,   776,   778,   951,   959,   959,   959,
     959,   780,  1137,   782,  1678,  1351,  1137,  1137,  1137,   958,
     784,   786,   788,   951,   790,   951,   792,   951,   794,   957,
     796,   951,   798,   807,   809,   811,   957,   813,   815,   259,
     817,   819,   823,   825,   827,   962,   841,   843,   845,   847,
     849,   261,   263,  1293,  1295,  1323,   265,  1382,   267,  1383,
     269,  1384,   271,  1385,   503,   487,   488,  1688,   489,   959,
    1692,  1386,   958,  1387,  1377,   958,   958,   504,   273,   238,
     239,  1237,  1693,  1694,  1378,   240,   958,   958,   958,  1622,
     958,   958,   958,  1204,   957,  1397,   241,  1398,   962,   951,
     275,   962,   962,   495,  1391,   277,  1392,   503,   279,  1393,
    1300,  1394,   962,   962,   962,  1316,   962,   962,   962,  1235,
     504,   242,   959,  1664,   315,   959,   959,  1317,   316,  1244,
     562,   961,   961,   317,   281,  1327,   959,   959,   959,  1214,
     959,   959,   959,   318,   283,   503,   285,   503,   319,   287,
     289,   291,   320,   321,  1064,  1066,  1068,   293,   504,   295,
     504,   951,   297,  1269,  1270,  1271,   961,   961,   961,   961,
     299,   503,   301,   564,   951,   884,   885,  1340,   957,  1342,
    1107,  1344,   322,   303,   504,   305,   307,   604,  1119,  1120,
     496,   497,   498,   499,  1368,   503,   309,   606,   503,   311,
     313,   465,   496,   497,   498,   499,   472,   478,   504,   370,
     372,   504,   374,   376,   425,   957,   957,   957,   957,   323,
     645,   608,   957,   951,   610,   612,  1377,   324,   961,   957,
     951,   614,   486,   616,   618,  1188,  1378,  1193,   475,  1198,
     634,  1203,   481,   565,   566,   636,   642,  1406,   325,  1407,
     326,   250,   252,  1339,   450,   254,   451,  1341,   450,   649,
     451,   567,   327,   328,   743,   651,   668,   670,   672,   329,
     674,   676,   678,   689,   691,   693,   695,   700,   702,   572,
     708,   961,   256,   868,   961,   961,   710,   712,   951,   714,
    1218,  1220,  1222,   258,   716,   961,   961,   961,   573,   961,
     961,   961,   330,   718,   720,   574,   575,   722,   724,   331,
     726,   728,   730,   576,   732,  1248,  1343,   450,   332,   451,
     734,   736,   738,   740,   742,   749,  1283,   751,   753,   755,
     763,   765,   767,   771,   773,   852,   775,   777,   779,   260,
     829,   830,   831,   832,   781,   333,   783,  1395,  1400,  1396,
    1401,   262,   264,   785,   787,   789,   266,   791,   268,   793,
     270,   795,   272,   797,   334,   799,   808,   810,   812,  1615,
     814,   816,   951,   818,   820,   824,   826,   828,   274,   842,
     844,   846,   848,   850,   957,   957,  1294,  1296,  1324,  1205,
    1206,   335,  1232,   877,  1208,  1209,  1238,  1239,  1240,  1241,
     276,  1205,  1206,  1207,  1348,   278,  1208,  1209,   280,   951,
     951,   951,   951,  1232,   346,  1232,   951,   577,   347,   957,
     957,   957,   957,   951,   500,   348,   349,  1205,  1206,  1207,
     350,   351,  1208,  1209,   282,   352,   500,  1205,  1206,  1207,
     353,   354,  1208,  1209,   284,   355,   286,  1205,  1206,   288,
     290,   292,  1208,  1209,  1232,   356,  1433,   294,  1402,   296,
    1403,   357,   298,  1419,  1429,  1432,   496,   497,   498,   499,
     300,  1461,   302,   358,   851,  1440,  1442,  1404,  1409,  1405,
    1410,   957,  1608,   304,   359,   306,   308,   360,  1450,   744,
     745,   746,   747,   361,  1452,  1454,   310,  1462,   362,   312,
     314,  1465,  1467,  1469,  1471,  1472,  1473,  1474,   363,   371,
     373,   364,   375,   377,   426,  1411,  1413,  1412,  1414,  1476,
    1478,  1480,  1482,  1484,  1486,  1488,  1017,  1018,  1019,  1020,
    1555,  1022,  1556,  1024,   957,  1026,   365,   957,   957,  1138,
    1139,  1140,  1141,  1142,  1143,  1144,  1145,  1146,   957,   957,
     957,   366,   957,   957,   957,  1249,  1250,  1251,  1252,  1253,
    1254,  1255,  1256,  1257,  1258,  1259,  1260,  1261,  1262,  1263,
    1264,  1265,  1266,  1267,  1268,  1269,  1270,  1271,   951,   951,
    1377,   539,   540,   541,   542,   543,  1147,  1626,   367,  1627,
    1378,   368,   544,   369,   378,   545,   379,  1550,   380,  1333,
     381,  1415,   382,  1416,   383,   384,  1628,   385,   386,  1630,
     387,   388,   389,   951,   951,   951,   951,   390,   391,   392,
    1665,  1249,  1250,  1251,  1252,  1253,  1254,  1255,  1256,  1257,
    1258,  1259,  1260,  1261,  1262,  1263,  1264,  1265,  1266,  1267,
    1268,  1269,  1270,  1271,  1253,  1254,  1255,  1256,  1257,  1258,
    1259,  1260,  1261,  1262,  1263,  1264,  1265,  1266,  1267,  1268,
    1269,  1270,  1271,  1444,  1263,  1264,  1265,  1266,  1267,  1268,
    1269,  1270,  1271,   393,   394,   951,  1249,  1250,  1251,  1252,
    1253,  1254,  1255,  1256,  1257,  1258,  1259,  1260,  1261,  1262,
    1263,  1264,  1265,  1266,  1267,  1268,  1269,  1270,  1271,   395,
     500,   396,   397,   539,   540,   541,   542,   543,   398,   399,
     400,   401,   539,   540,   541,   542,   543,   545,  1496,   402,
     403,   404,   405,   544,   406,   407,   545,   408,   951,   409,
     410,   951,   951,  1267,  1268,  1269,  1270,  1271,   411,   412,
     413,   414,   951,   951,   951,   415,   951,   951,   951,  1249,
    1250,  1251,  1252,  1253,  1254,  1255,  1256,  1257,  1258,  1259,
    1260,  1261,  1262,  1263,  1264,  1265,  1266,  1267,  1268,  1269,
    1270,  1271,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   427,   428,   429,   430,    -2,   466,  1620,   431,   432,
     433,  1604,   434,  1625,   435,   436,   437,   439,   440,   -11,
     -11,   -13,     2,     3,   -16,   -18,   -20,  1256,  1257,  1258,
    1259,  1260,  1261,  1262,  1263,  1264,  1265,  1266,  1267,  1268,
    1269,  1270,  1271,     4,   441,   442,     5,     6,     7,     8,
       9,   443,   444,   445,   446,   447,   448,   578,   579,   580,
     581,   582,    10,  1249,  1250,  1251,  1252,  1253,  1254,  1255,
    1256,  1257,  1258,  1259,  1260,  1261,  1262,  1263,  1264,  1265,
    1266,  1267,  1268,  1269,  1270,  1271,   857,   853,   860,   881,
    1620,   583,   584,   585,   586,   863,   587,   588,  1550,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,   589,   590,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,   591,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   592,   593,   594,   595,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   596,   177,   178,   597,   598,   599,   600,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   703,   704,   705,   706,   806,   835,   836,   866,   873,
     875,   876,   543,   191,   192,   193,   882,   894,  1249,  1250,
    1251,  1252,  1253,  1254,  1255,  1256,  1257,  1258,  1259,  1260,
    1261,  1262,  1263,  1264,  1265,  1266,  1267,  1268,  1269,  1270,
    1271,   888,   889,   890,   891,   892,   974,   975,   980,   976,
     194,   981,   982,   983,   990,   996,  1005,  1075,   195,  1151,
    1606,  1167,  1153,  1156,  1131,   196,  -594,  -594,  -594,  -594,
    -594,  -594,  -594,  -594,  -594,  -594,  -594,  -594,  1092,  1101,
    1102,  1103,  1104,  1105,  1114,  -594,  -594,  -594,  -594,  -594,
    -594,  -594,  -594,  1115,  -594,  -594,  -594,  -594,  -594,  -594,
    -594,  -594,  -594,  -594,  1116,  -594,  1117,  1172,  1169,  -594,
    1170,  -594,  -594,  -594,  -594,  -594,  -594,  -594,  -594,  1157,
    1159,  -594,  -594,  -594,  1161,  1163,  1175,  -594,  -594,  -594,
    -594,  -594,  -594,  1131,  1176,  -562,  -562,  -562,  -562,  -562,
    -562,  -562,  -562,  -562,  -562,  -562,  -562,  1223,  1224,  1284,
    1297,  1301,  1310,  1311,  -562,  -562,  -562,  -562,  -562,  -562,
    -562,  -562,  1312,  -562,  -562,  -562,  -562,  -562,  -562,  -562,
    -562,  -562,  -562,  1329,  -562,  1330,  1331,  1332,  -562,  1345,
    -562,  -562,  -562,  -562,  -562,  -562,  -562,  -562,  1346,  1347,
    -562,  -562,  -562,  1355,  1356,  1357,  -562,  -562,  -562,  -562,
    -562,  -562,  1214,  1359,  -566,  -566,  -566,  -566,  -566,  -566,
    -566,  -566,  -566,  -566,  -566,  -566,  1358,  1360,  1363,  1365,
    1366,  1370,  1381,  -566,  -566,  -566,  -566,  -566,  -566,  -566,
    -566,  1390,  -566,  -566,  -566,  -566,  -566,  -566,  -566,  -566,
    -566,  -566,  1399,  -566,  1408,  1436,  1443,  -566,  -665,  -566,
    -566,  -566,  -566,  -566,  -566,  -566,  -566,  -666,  -677,  -566,
    -566,  -566,  -678,  1445,  1446,  -566,  -566,  -566,  -566,  -566,
    -566,  1214,  1463,  -583,  -583,  -583,  -583,  -583,  -583,  -583,
    -583,  -583,  -583,  -583,  -583,  1489,  1490,  1491,  1493,  1492,
    1525,  1531,  -583,  -583,  -583,  -583,  -583,  -583,  -583,  -583,
    1532,  -583,  -583,  -583,  -583,  -583,  -583,  -583,  -583,  -583,
    -583,  1494,  -583,  1497,  1498,  1499,  -583,  1500,  -583,  -583,
    -583,  -583,  -583,  -583,  -583,  -583,  1501,  1502,  -583,  -583,
    -583,  1503,  1504,  1505,  -583,  -583,  -583,  -583,  -583,  -583,
    1506,  1507,  1508,  1509,  1510,  1511,  1512,  1513,  1514,  -594,
    1515,  1516,  1517,  1518,  1519,  1520,  1521,  1522,  1523,  1526,
    1527,  1528,  1529,  1530,  1533,  -594,  -594,  -594,  -594,  -594,
    -594,  -594,  -594,  -594,  -594,  -594,  -594,  -594,  -594,  -594,
    -594,  -594,  -594,  -594,  -594,  -594,  -594,  -594,  1540,  1541,
    1542,  1554,  1543,  1544,  -594,  1545,  1546,  1547,  -594,  1548,
    1549,  1147,  -594,  -594,  1558,  -594,  -594,  -594,  -892,  -594,
    1563,  1564,  1565,  1567,  -594,  1568,  1569,  1574,  -562,  1570,
    1575,  1580,  1583,  1584,  1585,  1588,  1589,  1590,  1593,  1594,
    1595,  1598,  1599,  1600,  -562,  -562,  -562,  -562,  -562,  -562,
    -562,  -562,  -562,  -562,  -562,  -562,  -562,  -562,  -562,  -562,
    -562,  -562,  -562,  -562,  -562,  -562,  -562,  1601,  1602,  1603,
    1605,  1607,  1609,  1610,  1616,  1621,  1638,  -562,  1637,  1670,
    1673,  -562,  -562,  1674,  -562,  -562,  -562,  -892,  -562,  1639,
    1640,  1641,  1677,  -562,  1642,  1643,  1644,  -566,  1645,  1646,
    1647,  1648,  1649,  1650,  1651,  1652,  1653,  1654,  1655,  1656,
    1657,  1658,  1659,  -566,  -566,  -566,  -566,  -566,  -566,  -566,
    -566,  -566,  -566,  -566,  -566,  -566,  -566,  -566,  -566,  -566,
    -566,  -566,  -566,  -566,  -566,  -566,  1660,  1661,  1662,  1663,
    1671,  1672,  1679,  1682,  1683,  1684,  -566,   467,  1171,   988,
    -566,  -566,  1685,  -566,  -566,  -566,  1686,  -566,  1431,  1689,
    1690,   895,  -566,   893,  1361,  1676,  -583,  1434,   696,  1435,
    1623,   698,  1666,     0,  1553,  1681,   880,     0,     0,     0,
       0,     0,  -583,  -583,  -583,  -583,  -583,  -583,  -583,  -583,
    -583,  -583,  -583,  -583,  -583,  -583,  -583,  -583,  -583,  -583,
    -583,  -583,  -583,  -583,  -583,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  -583,     0,     0,     0,  -583,
    -583,     1,  -583,  -583,  -583,     0,  -583,     0,     0,     0,
       0,  -583,     0,     0,   -11,   -11,   -13,     2,     3,   -16,
     -18,   -20,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     4,     0,
       0,     5,     6,     7,     8,     9,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    10,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1249,  1250,  1251,
    1252,  1253,  1254,  1255,  1256,  1257,  1258,  1259,  1260,  1261,
    1262,  1263,  1264,  1265,  1266,  1267,  1268,  1269,  1270,  1271,
       0,     0,     0,     0,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,  1680,
       0,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,     0,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,     0,     0,     0,     0,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,     0,   177,   178,
       0,     0,     0,     0,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   191,   192,
     193,  1250,  1251,  1252,  1253,  1254,  1255,  1256,  1257,  1258,
    1259,  1260,  1261,  1262,  1263,  1264,  1265,  1266,  1267,  1268,
    1269,  1270,  1271,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1455,   194,   897,   898,   899,   900,
     901,     0,     0,   195,     0,   906,   907,   908,     0,     0,
     196,     0,     0,     0,     0,   909,   910,   911,   912,   913,
     914,   915,   916,     0,   917,   918,   919,   920,   921,   922,
     923,   924,   925,   926,     0,   927,     0,     0,     0,     0,
       0,   929,   930,   931,   932,   933,   934,   935,     0,     0,
       0,     0,   938,   939,     0,     0,     0,   940,   941,   942,
     943,   944,   945,  1016,  1017,  1018,  1019,  1020,  1021,  1022,
    1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1456,
    1033,  1691,     0,   897,   898,   899,   900,   901,   902,   903,
     904,   905,   906,   907,   908,     0,     0,     0,     0,     0,
       0,     0,   909,   910,   911,   912,   913,   914,   915,   916,
       0,   917,   918,   919,   920,   921,   922,   923,   924,   925,
     926,     0,   927,     0,     0,     0,   928,     0,   929,   930,
     931,   932,   933,   934,   935,   936,  -626,  -626,   937,   938,
     939,     0,     0,     0,   940,   941,   942,   943,   944,   945,
    1135,     0,   897,   898,   899,   900,   901,   902,   903,   904,
     905,   906,   907,   908,     0,     0,     0,     0,     0,     0,
       0,   909,   910,   911,   912,   913,   914,   915,   916,     0,
     917,   918,   919,   920,   921,   922,   923,   924,   925,   926,
       0,   927,     0,     0,     0,   928,     0,   929,   930,   931,
     932,   933,   934,   935,   936,  -628,  -628,   937,   938,   939,
       0,     0,     0,   940,   941,   942,   943,   944,   945,  1135,
       0,   897,   898,   899,   900,   901,   902,   903,   904,   905,
     906,   907,   908,     0,     0,     0,     0,     0,     0,     0,
     909,   910,   911,   912,   913,   914,   915,   916,     0,   917,
     918,   919,   920,   921,   922,   923,   924,   925,   926,     0,
     927,     0,     0,     0,   928,     0,   929,   930,   931,   932,
     933,   934,   935,   936,  -630,  -630,   937,   938,   939,   946,
    1034,     0,   940,   941,   942,   943,   944,   945,  1251,  1252,
    1253,  1254,  1255,  1256,  1257,  1258,  1259,  1260,  1261,  1262,
    1263,  1264,  1265,  1266,  1267,  1268,  1269,  1270,  1271,     0,
       0,     0,     0,     0,  1035,     0,     0,     0,  1036,     0,
    1037,  1038,  1039,  1040,     0,  1041,  1042,  1457,  1458,     0,
    1043,   543,   948,   949,     0,     0,     0,     0,  1106,  1045,
       0,   545,     0,     0,     0,     0,  1135,     0,   897,   898,
     899,   900,   901,   902,   903,   904,   905,   906,   907,   908,
       0,     0,     0,     0,     0,     0,   946,   909,   910,   911,
     912,   913,   914,   915,   916,     0,   917,   918,   919,   920,
     921,   922,   923,   924,   925,   926,     0,   927,     0,     0,
       0,   928,     0,   929,   930,   931,   932,   933,   934,   935,
     936,  -624,  -624,   937,   938,   939,     0,     0,     0,   940,
     941,   942,   943,   944,   945,   947,     0,     0,     0,   948,
     949,     0,     0,   950,     0,     0,     0,  -626,     0,     0,
       0,     0,     0,     0,     0,   946,  1252,  1253,  1254,  1255,
    1256,  1257,  1258,  1259,  1260,  1261,  1262,  1263,  1264,  1265,
    1266,  1267,  1268,  1269,  1270,  1271,     0,  1254,  1255,  1256,
    1257,  1258,  1259,  1260,  1261,  1262,  1263,  1264,  1265,  1266,
    1267,  1268,  1269,  1270,  1271,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   947,     0,     0,     0,   948,   949,
       0,     0,   950,     0,     0,     0,  -628,     0,     0,     0,
       0,     0,     0,     0,   946,  1255,  1256,  1257,  1258,  1259,
    1260,  1261,  1262,  1263,  1264,  1265,  1266,  1267,  1268,  1269,
    1270,  1271,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   947,     0,     0,     0,   948,   949,     0,
       0,   950,     0,     0,     0,  -630,     0,     0,     0,  1135,
       0,   897,   898,   899,   900,   901,   902,   903,   904,   905,
     906,   907,   908,     0,     0,     0,     0,     0,     0,     0,
     909,   910,   911,   912,   913,   914,   915,   916,     0,   917,
     918,   919,   920,   921,   922,   923,   924,   925,   926,     0,
     927,     0,     0,     0,   928,     0,   929,   930,   931,   932,
     933,   934,   935,   936,  -631,  -631,   937,   938,   939,     0,
       0,   946,   940,   941,   942,   943,   944,   945,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     947,     0,     0,     0,   948,   949,     0,     0,   950,     0,
       0,  1135,  -624,   897,   898,   899,   900,   901,   902,   903,
     904,   905,   906,   907,   908,     0,     0,     0,     0,     0,
       0,     0,   909,   910,   911,   912,   913,   914,   915,   916,
       0,   917,   918,   919,   920,   921,   922,   923,   924,   925,
     926,     0,   927,     0,     0,     0,   928,     0,   929,   930,
     931,   932,   933,   934,   935,   936,  -625,  -625,   937,   938,
     939,     0,     0,     0,   940,   941,   942,   943,   944,   945,
    1135,     0,   897,   898,   899,   900,   901,   902,   903,   904,
     905,   906,   907,   908,     0,     0,     0,     0,     0,     0,
       0,   909,   910,   911,   912,   913,   914,   915,   916,     0,
     917,   918,   919,   920,   921,   922,   923,   924,   925,   926,
       0,   927,     0,     0,     0,   928,     0,   929,   930,   931,
     932,   933,   934,   935,   936,     0,     0,   937,   938,   939,
       0,     0,     0,   940,   941,   942,   943,   944,   945,     0,
       0,     0,     0,     0,  1135,     0,   897,   898,   899,   900,
     901,   902,   903,   904,   905,   906,   907,   908,     0,     0,
       0,     0,     0,     0,   946,   909,   910,   911,   912,   913,
     914,   915,   916,     0,   917,   918,   919,   920,   921,   922,
     923,   924,   925,   926,     0,   927,     0,     0,     0,   928,
       0,   929,   930,   931,   932,   933,   934,   935,   936,     0,
       0,   937,   938,   939,     0,     0,     0,   940,   941,   942,
     943,   944,   945,   947,     0,     0,     0,   948,   949,     0,
       0,   950,     0,     0,  1135,  -631,   897,   898,   899,   900,
     901,   902,   903,   904,   905,   906,   907,   908,     0,     0,
       0,     0,     0,     0,     0,   909,   910,   911,   912,   913,
     914,   915,   916,     0,   917,   918,   919,   920,   921,   922,
     923,   924,   925,   926,     0,   927,     0,     0,     0,   928,
       0,   929,   930,   931,   932,   933,   934,   935,   936,     0,
       0,   937,   938,   939,     0,     0,   946,   940,   941,   942,
     943,   944,   945,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   947,     0,     0,     0,   948,
     949,     0,     0,   950,     0,     0,     0,  -625,     0,     0,
       0,     0,     0,     0,     0,   946,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   947,     0,     0,     0,   948,   949,
       0,     0,   950,     0,     0,     0,  1136,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   946,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   947,     0,
       0,     0,   948,   949,     0,     0,   950,     0,     0,  1135,
    1158,   897,   898,   899,   900,   901,   902,   903,   904,   905,
     906,   907,   908,     0,     0,     0,     0,     0,     0,   946,
     909,   910,   911,   912,   913,   914,   915,   916,     0,   917,
     918,   919,   920,   921,   922,   923,   924,   925,   926,     0,
     927,     0,     0,     0,   928,     0,   929,   930,   931,   932,
     933,   934,   935,   936,     0,     0,   937,   938,   939,     0,
       0,     0,   940,   941,   942,   943,   944,   945,   947,     0,
       0,     0,   948,   949,     0,     0,   950,     0,     0,  1135,
    1160,   897,   898,   899,   900,   901,   902,   903,   904,   905,
     906,   907,   908,     0,     0,     0,     0,     0,     0,     0,
     909,   910,   911,   912,   913,   914,   915,   916,     0,   917,
     918,   919,   920,   921,   922,   923,   924,   925,   926,     0,
     927,     0,     0,     0,   928,     0,   929,   930,   931,   932,
     933,   934,   935,   936,     0,     0,   937,   938,   939,     0,
       0,     0,   940,   941,   942,   943,   944,   945,  1135,     0,
     897,   898,   899,   900,   901,   902,   903,   904,   905,   906,
     907,   908,     0,     0,     0,     0,     0,     0,     0,   909,
     910,   911,   912,   913,   914,   915,   916,     0,   917,   918,
     919,   920,   921,   922,   923,   924,   925,   926,     0,   927,
       0,     0,     0,   928,     0,   929,   930,   931,   932,   933,
     934,   935,   936,     0,     0,   937,   938,   939,     0,     0,
       0,   940,   941,   942,   943,   944,   945,     0,     0,     0,
       0,     0,  1135,     0,   897,   898,   899,   900,   901,   902,
     903,   904,   905,   906,   907,   908,     0,     0,     0,     0,
       0,     0,     0,   909,   910,   911,   912,   913,   914,   915,
     916,     0,   917,   918,   919,   920,   921,   922,   923,   924,
     925,   926,     0,   927,     0,     0,     0,   928,     0,   929,
     930,   931,   932,   933,   934,   935,   936,     0,     0,   937,
     938,   939,     0,     0,   946,   940,   941,   942,   943,   944,
     945,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   947,     0,     0,     0,   948,   949,     0,
       0,   950,     0,     0,  1135,  1162,   897,   898,   899,   900,
     901,   902,   903,   904,   905,   906,   907,   908,     0,     0,
       0,     0,     0,     0,   946,   909,   910,   911,   912,   913,
     914,   915,   916,     0,   917,   918,   919,   920,   921,   922,
     923,   924,   925,   926,     0,   927,     0,     0,     0,   928,
       0,   929,   930,   931,   932,   933,   934,   935,   936,     0,
       0,   937,   938,   939,     0,     0,     0,   940,   941,   942,
     943,   944,   945,   947,     0,     0,     0,   948,   949,     0,
       0,   950,     0,     0,     0,  1168,     0,     0,     0,     0,
       0,     0,     0,   946,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   947,     0,     0,     0,   948,   949,     0,     0,
     950,     0,     0,     0,  1447,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   946,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   947,     0,     0,     0,
     948,   949,     0,     0,   950,     0,     0,  1135,  1566,   897,
     898,   899,   900,   901,   902,   903,   904,   905,   906,   907,
     908,     0,     0,     0,     0,     0,     0,     0,   909,   910,
     911,   912,   913,   914,   915,   916,     0,   917,   918,   919,
     920,   921,   922,   923,   924,   925,   926,     0,   927,     0,
       0,     0,   928,     0,   929,   930,   931,   932,   933,   934,
     935,   936,     0,     0,   937,   938,   939,     0,     0,   946,
     940,   941,   942,   943,   944,   945,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   947,     0,
       0,     0,   948,   949,     0,     0,   950,     0,     0,  1135,
    1571,   897,   898,   899,   900,   901,   902,   903,   904,   905,
     906,   907,   908,     0,     0,     0,     0,     0,     0,     0,
     909,   910,   911,   912,   913,   914,   915,   916,     0,   917,
     918,   919,   920,   921,   922,   923,   924,   925,   926,     0,
     927,     0,     0,     0,   928,     0,   929,   930,   931,   932,
     933,   934,   935,   936,     0,     0,   937,   938,   939,     0,
       0,     0,   940,   941,   942,   943,   944,   945,  1135,     0,
     897,   898,   899,   900,   901,   902,   903,   904,   905,   906,
     907,   908,     0,     0,     0,     0,     0,     0,     0,   909,
     910,   911,   912,   913,   914,   915,   916,     0,   917,   918,
     919,   920,   921,   922,   923,   924,   925,   926,     0,   927,
       0,     0,     0,   928,     0,   929,   930,   931,   932,   933,
     934,   935,   936,     0,     0,   937,   938,   939,     0,     0,
       0,   940,   941,   942,   943,   944,   945,     0,     0,     0,
       0,     0,  1135,     0,   897,   898,   899,   900,   901,   902,
     903,   904,   905,   906,   907,   908,     0,     0,     0,     0,
       0,     0,   946,   909,   910,   911,   912,   913,   914,   915,
     916,     0,   917,   918,   919,   920,   921,   922,   923,   924,
     925,   926,     0,   927,     0,     0,     0,   928,     0,   929,
     930,   931,   932,   933,   934,   935,   936,     0,     0,   937,
     938,   939,     0,     0,     0,   940,   941,   942,   943,   944,
     945,   947,     0,     0,     0,   948,   949,     0,     0,   950,
       0,     0,  1135,  1611,   897,   898,   899,   900,   901,   902,
     903,   904,   905,   906,   907,   908,     0,     0,     0,     0,
       0,     0,     0,   909,   910,   911,   912,   913,   914,   915,
     916,     0,   917,   918,   919,   920,   921,   922,   923,   924,
     925,   926,     0,   927,     0,     0,     0,   928,     0,   929,
     930,   931,   932,   933,   934,   935,   936,     0,     0,   937,
     938,   939,     0,     0,   946,   940,   941,   942,   943,   944,
     945,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   947,     0,     0,     0,   948,   949,     0,
       0,   950,     0,     0,     0,  1631,     0,     0,     0,     0,
       0,     0,     0,   946,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   947,     0,     0,     0,   948,   949,     0,     0,
     950,     0,     0,     0,  1632,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   946,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   947,     0,     0,     0,
     948,   949,     0,     0,   950,     0,     0,     0,  1633,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   946,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   947,     0,     0,     0,
     948,   949,     0,     0,   950,     0,     0,  1420,  1634,   897,
     898,   899,   900,   901,     0,     0,     0,     0,   906,   907,
     908,     0,     0,     0,     0,     0,     0,     0,   909,   910,
     911,   912,   913,   914,   915,   916,     0,   917,   918,   919,
     920,   921,   922,   923,   924,   925,   926,     0,   927,     0,
       0,     0,     0,     0,   929,   930,   931,   932,   933,   934,
     935,     0,     0,     0,     0,   938,   939,     0,     0,     0,
     940,   941,   942,   943,   944,   945,  1016,  1017,  1018,  1019,
    1020,  1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,  1029,
    1030,  1031,  1032,  1033,  1421,  1422,  1423,  1424,  1425,  1426,
    1430,     0,   897,   898,   899,   900,   901,     0,     0,     0,
       0,   906,   907,   908,     0,     0,     0,     0,     0,     0,
       0,   909,   910,   911,   912,   913,   914,   915,   916,     0,
     917,   918,   919,   920,   921,   922,   923,   924,   925,   926,
       0,   927,     0,     0,     0,     0,     0,   929,   930,   931,
     932,   933,   934,   935,     0,     0,     0,     0,   938,   939,
       0,     0,     0,   940,   941,   942,   943,   944,   945,  1016,
    1017,  1018,  1019,  1020,  1021,  1022,  1023,  1024,  1025,  1026,
    1027,  1028,  1029,  1030,  1031,  1032,  1033,  1421,  1422,  1423,
    1424,  1425,  1426,  1225,     0,   897,   898,   899,   900,   901,
       0,     0,     0,     0,   906,   907,   908,     0,     0,     0,
       0,     0,     0,     0,   909,   910,   911,   912,   913,   914,
     915,   916,     0,   917,   918,   919,   920,   921,   922,   923,
     924,   925,   926,     0,   927,     0,     0,     0,     0,     0,
     929,   930,   931,   932,   933,   934,   935,     0,     0,     0,
       0,   938,   939,     0,     0,     0,   940,   941,   942,   943,
     944,   945,  1016,  1017,  1018,  1019,  1020,  1021,  1022,  1023,
    1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   946,  1034,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1035,  1427,     0,
       0,  1036,     0,  1037,  1038,  1039,  1040,     0,  1041,  1042,
     504,   947,     0,  1043,     0,   948,   949,     0,     0,     0,
       0,  1106,  1045,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   946,  1034,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1035,  1427,     0,     0,  1036,     0,  1037,  1038,  1039,  1040,
       0,  1041,  1042,   504,   947,     0,  1043,     0,   948,   949,
       0,     0,     0,     0,  1106,  1045,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   946,  1034,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1035,     0,     0,     0,  1036,     0,  1037,
    1038,  1039,  1040,     0,  1041,  1042,   504,   947,     0,  1043,
       0,   948,   949,     0,     0,     0,  1226,  1106,  1045,  1225,
       0,   897,   898,   899,   900,   901,     0,     0,     0,     0,
     906,   907,   908,     0,     0,     0,     0,     0,     0,     0,
     909,   910,   911,   912,   913,   914,   915,   916,     0,   917,
     918,   919,   920,   921,   922,   923,   924,   925,   926,     0,
     927,     0,     0,     0,     0,     0,   929,   930,   931,   932,
     933,   934,   935,     0,     0,     0,     0,   938,   939,     0,
       0,     0,   940,   941,   942,   943,   944,   945,  1016,  1017,
    1018,  1019,  1020,  1021,  1022,  1023,  1024,  1025,  1026,  1027,
    1028,  1029,  1030,  1031,  1032,  1033,  1225,     0,   897,   898,
     899,   900,   901,     0,     0,     0,     0,   906,   907,   908,
       0,     0,     0,     0,     0,     0,     0,   909,   910,   911,
     912,   913,   914,   915,   916,     0,   917,   918,   919,   920,
     921,   922,   923,   924,   925,   926,     0,   927,     0,     0,
       0,     0,     0,   929,   930,   931,   932,   933,   934,   935,
       0,     0,     0,     0,   938,   939,     0,     0,     0,   940,
     941,   942,   943,   944,   945,  1016,  1017,  1018,  1019,  1020,
    1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,
    1031,  1032,  1033,  1617,     0,   897,   898,   899,   900,   901,
       0,     0,     0,     0,   906,   907,   908,     0,     0,     0,
       0,     0,     0,     0,   909,   910,   911,   912,   913,   914,
     915,   916,     0,   917,   918,   919,   920,   921,   922,   923,
     924,   925,   926,     0,   927,     0,     0,     0,     0,     0,
     929,   930,   931,   932,   933,   934,   935,     0,     0,     0,
       0,   938,   939,     0,     0,     0,   940,   941,   942,   943,
     944,   945,  1016,  1017,  1018,  1019,  1020,  1021,  1022,  1023,
    1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   946,  1034,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1035,
       0,     0,     0,  1036,     0,  1037,  1038,  1039,  1040,     0,
    1041,  1042,   504,   947,     0,  1043,     0,   948,   949,     0,
       0,     0,  1274,  1106,  1045,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   946,  1034,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1035,     0,     0,     0,
    1036,     0,  1037,  1038,  1039,  1040,     0,  1041,  1042,   504,
     947,     0,  1043,     0,   948,   949,     0,     0,     0,  1275,
    1106,  1045,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   946,  1034,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1035,     0,  1618,     0,  1036,     0,  1037,
    1038,  1039,  1040,     0,  1041,  1042,   504,   947,     0,  1043,
       0,   948,   949,     0,     0,     0,     0,  1106,  1045,  1118,
       0,   897,   898,   899,   900,   901,     0,     0,     0,     0,
     906,   907,   908,     0,     0,     0,     0,     0,     0,     0,
     909,   910,   911,   912,   913,   914,   915,   916,     0,   917,
     918,   919,   920,   921,   922,   923,   924,   925,   926,     0,
     927,     0,     0,     0,     0,     0,   929,   930,   931,   932,
     933,   934,   935,     0,     0,     0,     0,   938,   939,     0,
       0,     0,   940,   941,   942,   943,   944,   945,  1016,  1017,
    1018,  1019,  1020,  1021,  1022,  1023,  1024,  1025,  1026,  1027,
    1028,  1029,  1030,  1031,  1032,  1033,  1217,     0,   897,   898,
     899,   900,   901,     0,     0,     0,     0,   906,   907,   908,
       0,     0,     0,     0,     0,     0,     0,   909,   910,   911,
     912,   913,   914,   915,   916,     0,   917,   918,   919,   920,
     921,   922,   923,   924,   925,   926,     0,   927,     0,     0,
       0,     0,     0,   929,   930,   931,   932,   933,   934,   935,
       0,     0,     0,     0,   938,   939,     0,     0,     0,   940,
     941,   942,   943,   944,   945,  1016,  1017,  1018,  1019,  1020,
    1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,
    1031,  1032,  1033,  1219,     0,   897,   898,   899,   900,   901,
       0,     0,     0,     0,   906,   907,   908,     0,     0,     0,
       0,     0,     0,     0,   909,   910,   911,   912,   913,   914,
     915,   916,     0,   917,   918,   919,   920,   921,   922,   923,
     924,   925,   926,     0,   927,     0,     0,     0,     0,     0,
     929,   930,   931,   932,   933,   934,   935,     0,     0,     0,
       0,   938,   939,     0,     0,     0,   940,   941,   942,   943,
     944,   945,  1016,  1017,  1018,  1019,  1020,  1021,  1022,  1023,
    1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   946,  1034,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1035,
       0,     0,     0,  1036,     0,  1037,  1038,  1039,  1040,     0,
    1041,  1042,   504,   947,     0,  1043,     0,   948,   949,     0,
       0,     0,     0,  1106,  1045,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   946,  1034,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1035,     0,     0,     0,
    1036,     0,  1037,  1038,  1039,  1040,     0,  1041,  1042,   504,
     947,     0,  1043,     0,   948,   949,     0,     0,     0,     0,
    1106,  1045,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   946,  1034,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1035,     0,     0,     0,  1036,     0,  1037,
    1038,  1039,  1040,     0,  1041,  1042,   504,   947,     0,  1043,
       0,   948,   949,     0,     0,     0,     0,  1106,  1045,  1221,
       0,   897,   898,   899,   900,   901,     0,     0,     0,     0,
     906,   907,   908,     0,     0,     0,     0,     0,     0,     0,
     909,   910,   911,   912,   913,   914,   915,   916,     0,   917,
     918,   919,   920,   921,   922,   923,   924,   925,   926,     0,
     927,     0,     0,     0,     0,     0,   929,   930,   931,   932,
     933,   934,   935,     0,     0,     0,     0,   938,   939,     0,
       0,     0,   940,   941,   942,   943,   944,   945,  1016,  1017,
    1018,  1019,  1020,  1021,  1022,  1023,  1024,  1025,  1026,  1027,
    1028,  1029,  1030,  1031,  1032,  1033,  1247,     0,   897,   898,
     899,   900,   901,     0,     0,     0,     0,   906,   907,   908,
       0,     0,     0,     0,     0,     0,     0,   909,   910,   911,
     912,   913,   914,   915,   916,     0,   917,   918,   919,   920,
     921,   922,   923,   924,   925,   926,     0,   927,     0,     0,
       0,     0,     0,   929,   930,   931,   932,   933,   934,   935,
       0,     0,     0,     0,   938,   939,     0,     0,     0,   940,
     941,   942,   943,   944,   945,  1016,  1017,  1018,  1019,  1020,
    1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,
    1031,  1032,  1033,  1281,     0,   897,   898,   899,   900,   901,
       0,     0,     0,     0,   906,   907,   908,     0,     0,     0,
       0,     0,     0,     0,   909,   910,   911,   912,   913,   914,
     915,   916,     0,   917,   918,   919,   920,   921,   922,   923,
     924,   925,   926,     0,   927,     0,     0,     0,     0,     0,
     929,   930,   931,   932,   933,   934,   935,     0,     0,     0,
       0,   938,   939,     0,     0,     0,   940,   941,   942,   943,
     944,   945,  1016,  1017,  1018,  1019,  1020,  1021,  1022,  1023,
    1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   946,  1034,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1035,
       0,     0,     0,  1036,     0,  1037,  1038,  1039,  1040,     0,
    1041,  1042,   504,   947,     0,  1043,     0,   948,   949,     0,
       0,     0,     0,  1106,  1045,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   946,  1034,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1035,     0,     0,     0,
    1036,     0,  1037,  1038,  1039,  1040,     0,  1041,  1042,   504,
     947,     0,  1043,     0,   948,   949,     0,     0,     0,     0,
    1106,  1045,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   946,  1034,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1035,     0,     0,     0,  1036,     0,  1037,
    1038,  1039,  1040,     0,  1041,  1042,   504,  1282,     0,  1043,
       0,   948,   949,     0,     0,     0,     0,  1106,  1045,  1225,
       0,   897,   898,   899,   900,   901,     0,     0,     0,     0,
     906,   907,   908,     0,     0,     0,     0,     0,     0,     0,
     909,   910,   911,   912,   913,   914,   915,   916,     0,   917,
     918,   919,   920,   921,   922,   923,   924,   925,   926,     0,
     927,     0,     0,     0,     0,     0,   929,   930,   931,   932,
     933,   934,   935,     0,     0,     0,     0,   938,   939,     0,
       0,     0,   940,   941,   942,   943,   944,   945,  1016,  1017,
    1018,  1019,  1020,  1021,  1022,  1023,  1024,  1025,  1026,  1027,
    1028,  1029,  1030,  1031,  1032,  1033,  1417,     0,   897,   898,
     899,   900,   901,     0,     0,     0,     0,   906,   907,   908,
       0,     0,     0,     0,     0,     0,     0,   909,   910,   911,
     912,   913,   914,   915,   916,     0,   917,   918,   919,   920,
     921,   922,   923,   924,   925,   926,     0,   927,     0,     0,
       0,     0,     0,   929,   930,   931,   932,   933,   934,   935,
       0,     0,     0,     0,   938,   939,     0,     0,     0,   940,
     941,   942,   943,   944,   945,  1016,  1017,  1018,  1019,  1020,
    1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,
    1031,  1032,  1033,  1439,     0,   897,   898,   899,   900,   901,
       0,     0,     0,     0,   906,   907,   908,     0,     0,     0,
       0,     0,     0,     0,   909,   910,   911,   912,   913,   914,
     915,   916,     0,   917,   918,   919,   920,   921,   922,   923,
     924,   925,   926,     0,   927,     0,     0,     0,     0,     0,
     929,   930,   931,   932,   933,   934,   935,     0,     0,     0,
       0,   938,   939,     0,     0,     0,   940,   941,   942,   943,
     944,   945,  1016,  1017,  1018,  1019,  1020,  1021,  1022,  1023,
    1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   946,  1034,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1035,
       0,     0,     0,  1036,     0,  1037,  1038,  1039,  1040,     0,
    1041,  1042,   504,   947,     0,  1043,     0,   948,   949,     0,
       0,     0,     0,  1106,  1045,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   946,  1034,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1035,     0,     0,     0,
    1036,     0,  1037,  1038,  1039,  1040,     0,  1041,  1042,   504,
    1418,     0,  1043,     0,   948,   949,     0,     0,     0,     0,
    1106,  1045,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   946,  1034,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1035,     0,     0,     0,  1036,     0,  1037,
    1038,  1039,  1040,     0,  1041,  1042,   504,   947,     0,  1043,
       0,   948,   949,     0,     0,     0,     0,  1106,  1045,  1441,
       0,   897,   898,   899,   900,   901,     0,     0,     0,     0,
     906,   907,   908,     0,     0,     0,     0,     0,     0,     0,
     909,   910,   911,   912,   913,   914,   915,   916,     0,   917,
     918,   919,   920,   921,   922,   923,   924,   925,   926,     0,
     927,     0,     0,     0,     0,     0,   929,   930,   931,   932,
     933,   934,   935,     0,     0,     0,     0,   938,   939,     0,
       0,     0,   940,   941,   942,   943,   944,   945,  1016,  1017,
    1018,  1019,  1020,  1021,  1022,  1023,  1024,  1025,  1026,  1027,
    1028,  1029,  1030,  1031,  1032,  1033,  1448,     0,   897,   898,
     899,   900,   901,     0,     0,     0,     0,   906,   907,   908,
       0,     0,     0,     0,     0,     0,     0,   909,   910,   911,
     912,   913,   914,   915,   916,     0,   917,   918,   919,   920,
     921,   922,   923,   924,   925,   926,     0,   927,     0,     0,
       0,     0,     0,   929,   930,   931,   932,   933,   934,   935,
       0,     0,     0,     0,   938,   939,     0,     0,     0,   940,
     941,   942,   943,   944,   945,  1016,  1017,  1018,  1019,  1020,
    1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,
    1031,  1449,  1033,  1451,     0,   897,   898,   899,   900,   901,
       0,     0,     0,     0,   906,   907,   908,     0,     0,     0,
       0,     0,     0,     0,   909,   910,   911,   912,   913,   914,
     915,   916,     0,   917,   918,   919,   920,   921,   922,   923,
     924,   925,   926,     0,   927,     0,     0,     0,     0,     0,
     929,   930,   931,   932,   933,   934,   935,     0,     0,     0,
       0,   938,   939,     0,     0,     0,   940,   941,   942,   943,
     944,   945,  1016,  1017,  1018,  1019,  1020,  1021,  1022,  1023,
    1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   946,  1034,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1035,
       0,     0,     0,  1036,     0,  1037,  1038,  1039,  1040,     0,
    1041,  1042,   504,   947,     0,  1043,     0,   948,   949,     0,
       0,     0,     0,  1106,  1045,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   946,  1034,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1035,     0,     0,     0,
    1036,     0,  1037,  1038,  1039,  1040,     0,  1041,  1042,   504,
     947,     0,  1043,     0,   948,   949,     0,     0,     0,     0,
    1106,  1045,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   946,  1034,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1035,     0,     0,     0,  1036,     0,  1037,
    1038,  1039,  1040,     0,  1041,  1042,   504,   947,     0,  1043,
       0,   948,   949,     0,     0,     0,     0,  1106,  1045,  1453,
       0,   897,   898,   899,   900,   901,     0,     0,     0,     0,
     906,   907,   908,     0,     0,     0,     0,     0,     0,     0,
     909,   910,   911,   912,   913,   914,   915,   916,     0,   917,
     918,   919,   920,   921,   922,   923,   924,   925,   926,     0,
     927,     0,     0,     0,     0,     0,   929,   930,   931,   932,
     933,   934,   935,     0,     0,     0,     0,   938,   939,     0,
       0,     0,   940,   941,   942,   943,   944,   945,  1016,  1017,
    1018,  1019,  1020,  1021,  1022,  1023,  1024,  1025,  1026,  1027,
    1028,  1029,  1030,  1031,  1032,  1033,  1464,     0,   897,   898,
     899,   900,   901,     0,     0,     0,     0,   906,   907,   908,
       0,     0,     0,     0,     0,     0,     0,   909,   910,   911,
     912,   913,   914,   915,   916,     0,   917,   918,   919,   920,
     921,   922,   923,   924,   925,   926,     0,   927,     0,     0,
       0,     0,     0,   929,   930,   931,   932,   933,   934,   935,
       0,     0,     0,     0,   938,   939,     0,     0,     0,   940,
     941,   942,   943,   944,   945,  1016,  1017,  1018,  1019,  1020,
    1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,
    1031,  1032,  1033,  1466,     0,   897,   898,   899,   900,   901,
       0,     0,     0,     0,   906,   907,   908,     0,     0,     0,
       0,     0,     0,     0,   909,   910,   911,   912,   913,   914,
     915,   916,     0,   917,   918,   919,   920,   921,   922,   923,
     924,   925,   926,     0,   927,     0,     0,     0,     0,     0,
     929,   930,   931,   932,   933,   934,   935,     0,     0,     0,
       0,   938,   939,     0,     0,     0,   940,   941,   942,   943,
     944,   945,  1016,  1017,  1018,  1019,  1020,  1021,  1022,  1023,
    1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   946,  1034,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1035,
       0,     0,     0,  1036,     0,  1037,  1038,  1039,  1040,     0,
    1041,  1042,   504,   947,     0,  1043,     0,   948,   949,     0,
       0,     0,     0,  1106,  1045,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   946,  1034,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1035,     0,     0,     0,
    1036,     0,  1037,  1038,  1039,  1040,     0,  1041,  1042,   504,
     947,     0,  1043,     0,   948,   949,     0,     0,     0,     0,
    1106,  1045,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   946,  1034,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1035,     0,     0,     0,  1036,     0,  1037,
    1038,  1039,  1040,     0,  1041,  1042,   504,   947,     0,  1043,
       0,   948,   949,     0,     0,     0,     0,  1106,  1045,  1468,
       0,   897,   898,   899,   900,   901,     0,     0,     0,     0,
     906,   907,   908,     0,     0,     0,     0,     0,     0,     0,
     909,   910,   911,   912,   913,   914,   915,   916,     0,   917,
     918,   919,   920,   921,   922,   923,   924,   925,   926,     0,
     927,     0,     0,     0,     0,     0,   929,   930,   931,   932,
     933,   934,   935,     0,     0,     0,     0,   938,   939,     0,
       0,     0,   940,   941,   942,   943,   944,   945,  1016,  1017,
    1018,  1019,  1020,  1021,  1022,  1023,  1024,  1025,  1026,  1027,
    1028,  1029,  1030,  1031,  1032,  1033,  1470,     0,   897,   898,
     899,   900,   901,     0,     0,     0,     0,   906,   907,   908,
       0,     0,     0,     0,     0,     0,     0,   909,   910,   911,
     912,   913,   914,   915,   916,     0,   917,   918,   919,   920,
     921,   922,   923,   924,   925,   926,     0,   927,     0,     0,
       0,     0,     0,   929,   930,   931,   932,   933,   934,   935,
       0,     0,     0,     0,   938,   939,     0,     0,     0,   940,
     941,   942,   943,   944,   945,  1016,  1017,  1018,  1019,  1020,
    1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,
    1031,  1032,  1033,  1475,     0,   897,   898,   899,   900,   901,
       0,     0,     0,     0,   906,   907,   908,     0,     0,     0,
       0,     0,     0,     0,   909,   910,   911,   912,   913,   914,
     915,   916,     0,   917,   918,   919,   920,   921,   922,   923,
     924,   925,   926,     0,   927,     0,     0,     0,     0,     0,
     929,   930,   931,   932,   933,   934,   935,     0,     0,     0,
       0,   938,   939,     0,     0,     0,   940,   941,   942,   943,
     944,   945,  1016,  1017,  1018,  1019,  1020,  1021,  1022,  1023,
    1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   946,  1034,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1035,
       0,     0,     0,  1036,     0,  1037,  1038,  1039,  1040,     0,
    1041,  1042,   504,   947,     0,  1043,     0,   948,   949,     0,
       0,     0,     0,  1106,  1045,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   946,  1034,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1035,     0,     0,     0,
    1036,     0,  1037,  1038,  1039,  1040,     0,  1041,  1042,   504,
     947,     0,  1043,     0,   948,   949,     0,     0,     0,     0,
    1106,  1045,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   946,  1034,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1035,     0,     0,     0,  1036,     0,  1037,
    1038,  1039,  1040,     0,  1041,  1042,   504,   947,     0,  1043,
       0,   948,   949,     0,     0,     0,     0,  1106,  1045,  1477,
       0,   897,   898,   899,   900,   901,     0,     0,     0,     0,
     906,   907,   908,     0,     0,     0,     0,     0,     0,     0,
     909,   910,   911,   912,   913,   914,   915,   916,     0,   917,
     918,   919,   920,   921,   922,   923,   924,   925,   926,     0,
     927,     0,     0,     0,     0,     0,   929,   930,   931,   932,
     933,   934,   935,     0,     0,     0,     0,   938,   939,     0,
       0,     0,   940,   941,   942,   943,   944,   945,  1016,  1017,
    1018,  1019,  1020,  1021,  1022,  1023,  1024,  1025,  1026,  1027,
    1028,  1029,  1030,  1031,  1032,  1033,  1479,     0,   897,   898,
     899,   900,   901,     0,     0,     0,     0,   906,   907,   908,
       0,     0,     0,     0,     0,     0,     0,   909,   910,   911,
     912,   913,   914,   915,   916,     0,   917,   918,   919,   920,
     921,   922,   923,   924,   925,   926,     0,   927,     0,     0,
       0,     0,     0,   929,   930,   931,   932,   933,   934,   935,
       0,     0,     0,     0,   938,   939,     0,     0,     0,   940,
     941,   942,   943,   944,   945,  1016,  1017,  1018,  1019,  1020,
    1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,
    1031,  1032,  1033,  1481,     0,   897,   898,   899,   900,   901,
       0,     0,     0,     0,   906,   907,   908,     0,     0,     0,
       0,     0,     0,     0,   909,   910,   911,   912,   913,   914,
     915,   916,     0,   917,   918,   919,   920,   921,   922,   923,
     924,   925,   926,     0,   927,     0,     0,     0,     0,     0,
     929,   930,   931,   932,   933,   934,   935,     0,     0,     0,
       0,   938,   939,     0,     0,     0,   940,   941,   942,   943,
     944,   945,  1016,  1017,  1018,  1019,  1020,  1021,  1022,  1023,
    1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   946,  1034,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1035,
       0,     0,     0,  1036,     0,  1037,  1038,  1039,  1040,     0,
    1041,  1042,   504,   947,     0,  1043,     0,   948,   949,     0,
       0,     0,     0,  1106,  1045,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   946,  1034,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1035,     0,     0,     0,
    1036,     0,  1037,  1038,  1039,  1040,     0,  1041,  1042,   504,
     947,     0,  1043,     0,   948,   949,     0,     0,     0,     0,
    1106,  1045,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   946,  1034,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1035,     0,     0,     0,  1036,     0,  1037,
    1038,  1039,  1040,     0,  1041,  1042,   504,   947,     0,  1043,
       0,   948,   949,     0,     0,     0,     0,  1106,  1045,  1483,
       0,   897,   898,   899,   900,   901,     0,     0,     0,     0,
     906,   907,   908,     0,     0,     0,     0,     0,     0,     0,
     909,   910,   911,   912,   913,   914,   915,   916,     0,   917,
     918,   919,   920,   921,   922,   923,   924,   925,   926,     0,
     927,     0,     0,     0,     0,     0,   929,   930,   931,   932,
     933,   934,   935,     0,     0,     0,     0,   938,   939,     0,
       0,     0,   940,   941,   942,   943,   944,   945,  1016,  1017,
    1018,  1019,  1020,  1021,  1022,  1023,  1024,  1025,  1026,  1027,
    1028,  1029,  1030,  1031,  1032,  1033,  1485,     0,   897,   898,
     899,   900,   901,     0,     0,     0,     0,   906,   907,   908,
       0,     0,     0,     0,     0,     0,     0,   909,   910,   911,
     912,   913,   914,   915,   916,     0,   917,   918,   919,   920,
     921,   922,   923,   924,   925,   926,     0,   927,     0,     0,
       0,     0,     0,   929,   930,   931,   932,   933,   934,   935,
       0,     0,     0,     0,   938,   939,     0,     0,     0,   940,
     941,   942,   943,   944,   945,  1016,  1017,  1018,  1019,  1020,
    1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,
    1031,  1032,  1033,  1487,     0,   897,   898,   899,   900,   901,
       0,     0,     0,     0,   906,   907,   908,     0,     0,     0,
       0,     0,     0,     0,   909,   910,   911,   912,   913,   914,
     915,   916,     0,   917,   918,   919,   920,   921,   922,   923,
     924,   925,   926,     0,   927,     0,     0,     0,     0,     0,
     929,   930,   931,   932,   933,   934,   935,     0,     0,     0,
       0,   938,   939,     0,     0,     0,   940,   941,   942,   943,
     944,   945,  1016,  1017,  1018,  1019,  1020,  1021,  1022,  1023,
    1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   946,  1034,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1035,
       0,     0,     0,  1036,     0,  1037,  1038,  1039,  1040,     0,
    1041,  1042,   504,   947,     0,  1043,     0,   948,   949,     0,
       0,     0,     0,  1106,  1045,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   946,  1034,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1035,     0,     0,     0,
    1036,     0,  1037,  1038,  1039,  1040,     0,  1041,  1042,   504,
     947,     0,  1043,     0,   948,   949,     0,     0,     0,     0,
    1106,  1045,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   946,  1034,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1035,     0,     0,     0,  1036,     0,  1037,
    1038,  1039,  1040,     0,  1041,  1042,   504,   947,     0,  1043,
       0,   948,   949,     0,     0,     0,     0,  1106,  1045,  1675,
       0,   897,   898,   899,   900,   901,     0,     0,     0,     0,
     906,   907,   908,     0,     0,     0,     0,     0,     0,     0,
     909,   910,   911,   912,   913,   914,   915,   916,     0,   917,
     918,   919,   920,   921,   922,   923,   924,   925,   926,     0,
     927,     0,     0,     0,     0,     0,   929,   930,   931,   932,
     933,   934,   935,     0,     0,     0,     0,   938,   939,     0,
       0,     0,   940,   941,   942,   943,   944,   945,  1016,  1017,
    1018,  1019,  1020,  1021,  1022,  1023,  1024,  1025,  1026,  1027,
    1028,  1029,  1030,  1031,  1032,  1033,   897,   898,   899,   900,
     901,   902,   903,   904,   905,   906,   907,   908,     0,     0,
       0,     0,     0,     0,     0,   909,   910,   911,   912,   913,
     914,   915,   916,     0,   917,   918,   919,   920,   921,   922,
     923,   924,   925,   926,     0,   927,     0,     0,     0,   928,
       0,   929,   930,   931,   932,   933,   934,   935,   936,     0,
       0,   937,   938,   939,     0,     0,     0,   940,   941,   942,
     943,   944,   945,   897,   898,   899,   900,   901,     0,     0,
       0,     0,   906,   907,   908,     0,     0,     0,     0,     0,
       0,     0,   909,   910,   911,   912,   913,   914,   915,   916,
       0,   917,   918,   919,   920,   921,   922,   923,   924,   925,
     926,     0,   927,     0,     0,     0,     0,     0,   929,   930,
     931,   932,   933,   934,   935,     0,     0,     0,     0,   938,
     939,     0,     0,     0,   940,   941,   942,   943,   944,   945,
    1016,  1017,  1018,  1019,  1020,  1021,  1022,  1023,  1024,  1025,
    1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   946,  1034,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1035,
       0,     0,     0,  1036,     0,  1037,  1038,  1039,  1040,     0,
    1041,  1042,   504,   947,     0,  1043,     0,   948,   949,     0,
       0,     0,     0,  1106,  1045,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   946,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1249,  1250,  1251,  1252,  1253,
    1254,  1255,  1256,  1257,  1258,  1259,  1260,  1261,  1262,  1263,
    1264,  1265,  1266,  1267,  1268,  1269,  1270,  1271,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   947,     0,
       0,     0,   948,   949,     0,     0,   950,     0,     0,  1318,
       0,     0,     0,     0,     0,     0,   946,  1034,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1035,     0,     0,     0,  1036,     0,  1037,  1038,  1039,
    1040,     0,  1041,  1042,   504,   947,     0,  1043,     0,   948,
     949,     0,     0,     0,     0,  1044,  1045,   897,   898,   899,
     900,   901,     0,     0,     0,     0,   906,   907,   908,     0,
       0,     0,     0,     0,     0,     0,   909,   910,   911,   912,
     913,   914,   915,   916,     0,   917,   918,   919,   920,   921,
     922,   923,   924,   925,   926,     0,   927,     0,     0,     0,
       0,     0,   929,   930,   931,   932,   933,   934,   935,     0,
       0,     0,     0,   938,   939,     0,     0,     0,   940,   941,
     942,   943,   944,   945,  1016,  1017,  1018,  1019,  1020,  1021,
    1022,  1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,
    1032,  1033,   897,   898,   899,   900,   901,     0,     0,     0,
       0,   906,   907,   908,     0,     0,     0,     0,     0,     0,
       0,   909,   910,   911,   912,   913,   914,   915,   916,     0,
     917,   918,   919,   920,   921,   922,   923,   924,   925,   926,
       0,   927,     0,     0,     0,     0,     0,   929,   930,   931,
     932,   933,   934,   935,     0,     0,     0,     0,   938,   939,
       0,     0,     0,   940,   941,   942,   943,   944,   945,  1016,
    1017,  1018,  1019,  1020,  1021,  1022,  1023,  1024,  1025,  1026,
    1027,  1028,  1029,  1030,  1031,  1032,  1033,   897,   898,   899,
     900,   901,     0,     0,     0,     0,   906,   907,   908,     0,
       0,     0,     0,     0,     0,     0,   909,   910,   911,   912,
     913,   914,   915,   916,     0,   917,   918,   919,   920,   921,
     922,   923,   924,   925,   926,     0,   927,     0,     0,     0,
       0,     0,   929,   930,   931,   932,   933,   934,   935,     0,
       0,     0,     0,   938,   939,     0,     0,     0,   940,   941,
     942,   943,   944,   945,  1016,  1017,  1018,  1019,  1020,  1021,
    1022,  1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,
    1032,  1033,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     946,  1034,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1035,     0,     0,     0,  1036,
       0,  1037,  1038,  1039,  1040,     0,  1041,  1042,   504,   947,
       0,  1043,     0,   948,   949,     0,     0,     0,     0,  1065,
    1045,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   946,  1034,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1035,     0,     0,     0,  1036,     0,  1037,  1038,  1039,  1040,
       0,  1041,  1042,   504,   947,     0,  1043,     0,   948,   949,
       0,     0,     0,     0,  1067,  1045,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     946,  1034,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1035,     0,     0,     0,  1036,
       0,  1037,  1038,  1039,  1040,     0,  1041,  1042,   504,   947,
       0,  1043,     0,   948,   949,     0,     0,     0,     0,  1106,
    1045,   897,   898,   899,   900,   901,     0,     0,     0,     0,
     906,   907,   908,     0,     0,     0,     0,     0,     0,     0,
     909,   910,   911,   912,   913,   914,   915,   916,     0,   917,
     918,   919,   920,   921,   922,   923,   924,   925,   926,     0,
     927,     0,     0,     0,     0,     0,   929,   930,   931,   932,
     933,   934,   935,     0,     0,     0,     0,   938,   939,     0,
       0,     0,   940,   941,   942,   943,   944,   945,  1016,  1017,
    1018,  1019,  1020,  1021,  1022,  1023,  1024,  1025,  1026,  1027,
    1028,  1029,  1030,  1031,  1032,  1033,   897,   898,   899,   900,
     901,   902,   903,   904,   905,   906,   907,   908,     0,     0,
       0,     0,     0,     0,     0,   909,   910,   911,   912,   913,
     914,   915,   916,     0,   917,   918,   919,   920,   921,   922,
     923,   924,   925,   926,     0,   927,     0,     0,     0,   928,
       0,   929,   930,   931,   932,   933,   934,   935,   936,     0,
       0,   937,   938,   939,     0,     0,     0,   940,   941,   942,
     943,   944,   945,  1233,     0,   897,   898,   899,   900,   901,
     902,   903,   904,   905,   906,   907,   908,     0,     0,     0,
       0,     0,     0,     0,   909,   910,   911,   912,   913,   914,
     915,   916,     0,   917,   918,   919,   920,   921,   922,   923,
     924,   925,   926,     0,   927,     0,     0,     0,   928,     0,
     929,   930,   931,   932,   933,   934,   935,   936,     0,     0,
     937,   938,   939,     0,     0,     0,   940,   941,   942,   943,
     944,   945,     0,     0,     0,   897,   898,   899,   900,   901,
     902,   903,   904,   905,   906,   907,   908,     0,     0,     0,
       0,     0,     0,     0,   909,   910,   911,   912,   913,   914,
     915,   916,     0,   917,   918,   919,   920,   921,   922,   923,
     924,   925,   926,     0,   927,     0,     0,     0,   928,     0,
     929,   930,   931,   932,   933,   934,   935,   936,     0,     0,
     937,   938,   939,     0,   946,  1034,   940,   941,   942,   943,
     944,   945,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1035,
       0,     0,     0,  1036,     0,  1037,  1038,  1039,  1040,     0,
    1041,  1042,  1624,   947,     0,  1043,     0,   948,   949,     0,
       0,     0,     0,  1106,  1045,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   946,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   947,     0,
       0,     0,   948,   949,     0,     0,   950,     0,     0,  1318,
       0,     0,     0,     0,     0,     0,     0,     0,   946,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   947,     0,     0,
       0,   948,   949,     0,     0,   950,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   946,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   947,     0,     0,
       0,   948,   949,     0,     0,   950
};

static const yytype_int16 yycheck[] =
{
     221,   190,   220,   224,   407,  1172,  1007,  1028,  1009,  1030,
    1011,  1032,  1013,   860,  1015,   857,   863,  1120,   860,   866,
       1,   863,     1,     1,   866,     1,   301,   874,  1049,   250,
       1,   252,   874,   254,     1,   256,   952,     1,    62,     1,
       1,   857,     1,     1,   860,     1,     1,   863,   110,     1,
     866,  1055,     1,   969,    57,   971,     1,   973,   874,   301,
       1,   977,     1,     1,     1,   857,   331,   301,   860,    62,
       1,   863,     1,   322,   866,   321,     1,    62,    62,     1,
       1,     1,   874,   348,     1,   334,     1,     1,   334,     1,
     301,   337,     1,     1,   315,     1,     1,    56,    57,    61,
       1,     1,     1,   324,   325,   326,   327,   328,   329,   330,
     952,     1,     1,     1,     1,     1,     1,   321,     1,     1,
       1,    88,    89,    90,    91,     1,     1,   969,     1,   971,
     334,   973,     1,     1,     1,   977,   952,   301,   359,   360,
     361,   544,     1,     1,     1,   349,   321,     1,     1,    88,
      89,    90,    91,   969,     1,   971,     1,   973,   301,   334,
     952,   977,     1,     1,     1,     1,   301,    88,    89,    90,
      91,    14,    15,     1,     1,     1,     1,   969,   301,   971,
     334,   973,    62,   337,     1,   977,   239,     1,     1,   321,
     321,  1107,    61,     1,   886,   887,     1,     1,  1045,   331,
     331,   301,  1044,  1045,  1120,     1,   335,   321,   337,     1,
     342,   342,   344,   344,     1,   301,    61,   331,   439,     1,
       1,   442,   443,  1065,   857,  1067,     1,   860,  1044,  1045,
     863,     1,     1,   866,   342,     1,   344,   309,   310,     1,
       1,   874,   314,   315,  1245,     1,     1,     1,    61,  1065,
       1,  1067,  1044,  1045,     1,   301,     1,    61,     1,     1,
       1,   301,     1,     1,  1106,  1107,     1,     1,     1,     1,
     301,     1,   301,  1065,     1,  1067,     1,     1,  1120,     1,
       1,     1,     1,     1,     1,     1,     1,     1,   301,   351,
    1106,  1107,     1,   855,   342,     1,   344,   859,     1,     1,
     862,     1,   321,   865,  1120,   301,     1,  1047,   286,     1,
     334,  1051,   331,  1155,  1106,  1107,     1,     1,  1234,   952,
       1,     1,  1169,     1,   301,   301,     1,  1169,  1120,  1176,
     331,   334,   335,   301,  1176,     1,   969,     1,   971,  1155,
     973,   334,     1,     1,   977,   301,     1,  1351,     1,   334,
     334,     1,   301,  1169,     1,   322,     1,     1,     1,   337,
    1176,   337,   340,     1,  1531,   346,   345,   334,   335,   336,
     337,   338,   334,   335,   345,   337,   338,  1169,   345,   343,
     338,   348,   344,   322,  1176,   346,   348,   348,   347,   334,
     348,   346,  1234,   338,   346,   334,   335,   336,   337,   338,
     337,   322,   301,   348,   335,   346,   345,   348,   346,   348,
     348,  1044,  1045,   334,   335,   336,   337,   338,  1234,   348,
     337,   346,  1525,   348,   346,   345,   348,   348,  1449,   344,
     345,   345,  1065,   345,  1067,  1456,   345,   345,   337,   345,
     345,   301,  1234,   301,   345,   345,  1362,   334,   335,   336,
     337,   338,   301,  1369,   334,   345,   345,   345,   334,   345,
     345,   348,   345,   345,   345,   334,   335,   335,   337,   338,
     345,  1318,   345,  1106,  1107,   334,  1318,   857,   345,   348,
     860,   884,   321,   863,   337,   344,   866,  1120,   345,   334,
     335,   345,   337,   338,   874,   334,   549,   334,   345,   335,
     337,   337,  1318,   348,     1,   344,  1673,   345,  1355,  1356,
    1357,  1358,   337,  1355,  1356,  1357,  1358,   345,   345,   345,
    1362,   334,   335,   337,   337,   338,  1318,  1369,   345,   334,
     334,   335,   337,   337,   338,   348,  1169,   345,   334,  1355,
    1356,  1357,  1358,  1176,   348,   337,  1362,   334,   335,   336,
     337,   338,   301,  1369,   335,   337,   337,     1,    56,    57,
     335,   348,   337,  1355,  1356,  1357,  1358,   337,   337,   335,
    1362,   337,   952,   335,   335,   337,   337,  1369,   981,   335,
     335,   337,   337,   337,   335,     1,   337,     1,   335,   969,
     337,   971,   337,   973,   337,   337,   337,   977,   337,   337,
       1,  1234,   337,   337,   337,   337,  1607,   337,  1524,  1525,
     337,     1,   337,   337,     1,   337,   337,   337,   337,   337,
     337,   337,   337,   337,     1,   334,   335,   336,   334,   335,
     336,   334,   335,   335,   334,     1,   321,   321,     1,   334,
     321,   321,   334,  1559,  1560,  1561,  1562,   322,     1,   334,
     334,     1,     1,   334,   334,   321,   334,   321,     1,   334,
       1,     1,   321,   321,   853,  1045,   321,     1,   334,   322,
     334,   857,     1,     1,   860,   334,   334,   863,   321,   334,
     866,   334,  1524,  1525,   334,  1318,     1,   334,   874,   334,
     334,   334,     1,     1,     1,     1,   334,     1,     1,     1,
       1,     1,     1,     1,     1,     1,  1109,     1,  1524,  1525,
    1113,     1,     1,     1,     1,     1,     1,  1559,  1560,  1561,
    1562,     1,  1355,  1356,  1357,  1358,   342,  1107,   344,  1362,
       1,     1,  1524,  1525,     1,     1,  1369,     1,     1,     1,
    1120,     1,     1,  1559,  1560,  1561,  1562,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,  1678,     1,     1,     1,   952,  1559,  1560,  1561,
    1562,     1,  1688,     1,  1621,  1155,  1692,  1693,  1694,  1621,
       1,     1,     1,   969,     1,   971,     1,   973,     1,  1169,
       1,   977,     1,     1,     1,     1,  1176,     1,     1,     1,
       1,     1,     1,     1,     1,  1621,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,   342,     1,   344,
       1,   342,     1,   344,   321,   334,   335,  1674,   337,  1621,
    1677,   342,  1674,   344,   321,  1677,  1678,   334,     1,   301,
     301,     1,  1689,  1690,   331,   301,  1688,  1689,  1690,   347,
    1692,  1693,  1694,     1,  1234,   342,   301,   344,  1674,  1045,
       1,  1677,  1678,     1,   342,     1,   344,   321,     1,   342,
    1091,   344,  1688,  1689,  1690,     1,  1692,  1693,  1694,     1,
     334,   301,  1674,   337,   301,  1677,  1678,  1105,   301,     1,
     334,  1524,  1525,   301,     1,  1113,  1688,  1689,  1690,     1,
    1692,  1693,  1694,   301,     1,   321,     1,   321,   301,     1,
       1,     1,   301,   301,   902,   903,   904,     1,   334,     1,
     334,  1107,     1,   322,   323,   324,  1559,  1560,  1561,  1562,
       1,   321,     1,   334,  1120,   109,   110,  1126,  1318,  1128,
     928,  1130,   301,     1,   334,     1,     1,   334,   936,   937,
      88,    89,    90,    91,  1175,   321,     1,   334,   321,     1,
       1,     0,    88,    89,    90,    91,    16,    20,   334,     1,
       1,   334,     1,     1,     1,  1355,  1356,  1357,  1358,   301,
     337,   334,  1362,  1169,   334,   334,   321,   301,  1621,  1369,
    1176,   334,   346,   334,   334,  1009,   331,  1011,    19,  1013,
     334,  1015,    21,   334,   334,   334,   334,   342,   301,   344,
     301,   301,   301,   334,   335,   301,   337,   334,   335,   334,
     337,   334,   301,   301,     1,   334,   334,   334,   334,   301,
     334,   334,   334,   334,   334,   334,   334,   334,   334,   334,
     334,  1674,   301,   348,  1677,  1678,   334,   334,  1234,   334,
    1038,  1039,  1040,   301,   334,  1688,  1689,  1690,   334,  1692,
    1693,  1694,   301,   334,   334,   334,   334,   334,   334,   301,
     334,   334,   334,   334,   334,  1063,   334,   335,   301,   337,
     334,   334,   334,   334,   334,   334,  1074,   334,   334,   334,
     334,   334,   334,   334,   334,   351,   334,   334,   334,   301,
     270,   271,   272,   273,   334,   301,   334,   342,   342,   344,
     344,   301,   301,   334,   334,   334,   301,   334,   301,   334,
     301,   334,   301,   334,   301,   334,   334,   334,   334,  1532,
     334,   334,  1318,   334,   334,   334,   334,   334,   301,   334,
     334,   334,   334,   334,  1524,  1525,   334,   334,   334,   309,
     310,   301,  1044,   331,   314,   315,   316,   317,   318,   319,
     301,   309,   310,   311,  1152,   301,   314,   315,   301,  1355,
    1356,  1357,  1358,  1065,   301,  1067,  1362,   334,   301,  1559,
    1560,  1561,  1562,  1369,   322,   301,   301,   309,   310,   311,
     301,   301,   314,   315,   301,   301,   322,   309,   310,   311,
     301,   301,   314,   315,   301,   301,   301,   309,   310,   301,
     301,   301,   314,   315,  1106,   301,     1,   301,   342,   301,
     344,   301,   301,  1211,  1212,  1213,    88,    89,    90,    91,
     301,  1245,   301,   301,   342,  1223,  1224,   342,   342,   344,
     344,  1621,  1463,   301,   301,   301,   301,   301,  1236,   226,
     227,   228,   229,   301,  1242,  1243,   301,  1245,   301,   301,
     301,  1249,  1250,  1251,  1252,  1253,  1254,  1255,   301,   301,
     301,   301,   301,   301,   301,   342,   342,   344,   344,  1267,
    1268,  1269,  1270,  1271,  1272,  1273,    71,    72,    73,    74,
     342,    76,   344,    78,  1674,    80,   301,  1677,  1678,   288,
     289,   290,   291,   292,   293,   294,   295,   296,  1688,  1689,
    1690,   301,  1692,  1693,  1694,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,  1524,  1525,
     321,   334,   335,   336,   337,   338,   335,   342,   301,   344,
     331,   301,   345,   301,   301,   348,   301,  1345,   301,   346,
     301,   342,   301,   344,   301,   301,  1555,   301,   301,  1558,
     301,   301,   301,  1559,  1560,  1561,  1562,   301,   301,   301,
    1601,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   344,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   301,   301,  1621,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   301,
     322,   301,   301,   334,   335,   336,   337,   338,   301,   301,
     301,   301,   334,   335,   336,   337,   338,   348,   344,   301,
     301,   301,   301,   345,   301,   301,   348,   301,  1674,   301,
     301,  1677,  1678,   320,   321,   322,   323,   324,   301,   301,
     301,   301,  1688,  1689,  1690,   301,  1692,  1693,  1694,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   301,   301,   301,   301,   301,   301,   301,   301,
     301,   301,   301,   301,   301,     0,     1,  1535,   301,   301,
     301,   344,   301,  1541,   301,   301,   301,   301,   301,    14,
      15,    16,    17,    18,    19,    20,    21,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,    38,   301,   301,    41,    42,    43,    44,
      45,   301,   301,   301,   301,   301,   301,   334,   334,   334,
     334,   334,    57,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   346,   342,   346,   351,
    1618,   334,   334,   334,   334,   346,   334,   334,  1626,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   334,   334,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   334,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   334,   334,   334,   334,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   334,   268,   269,   334,   334,   334,   334,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   334,   334,   334,   334,   334,   334,   334,   346,   334,
     349,   334,   338,   298,   299,   300,   351,   334,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   342,   301,   301,   301,   301,   341,   301,   334,   349,
     335,   342,   344,   349,   337,   337,   349,   345,   343,   301,
     344,   331,   343,   343,     1,   350,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,   345,   345,
     345,   345,   345,   345,   345,    22,    23,    24,    25,    26,
      27,    28,    29,   345,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,   345,    42,   345,   351,   346,    46,
     331,    48,    49,    50,    51,    52,    53,    54,    55,   349,
     349,    58,    59,    60,   349,   349,   342,    64,    65,    66,
      67,    68,    69,     1,   346,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,   345,   345,   337,
     344,   344,   344,   344,    22,    23,    24,    25,    26,    27,
      28,    29,   344,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,   344,    42,   344,   344,   344,    46,   345,
      48,    49,    50,    51,    52,    53,    54,    55,   331,   348,
      58,    59,    60,   346,   346,   346,    64,    65,    66,    67,
      68,    69,     1,   267,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,   346,   267,   334,   337,
     334,   344,   344,    22,    23,    24,    25,    26,    27,    28,
      29,   344,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,   344,    42,   344,   335,   344,    46,   301,    48,
      49,    50,    51,    52,    53,    54,    55,   301,   301,    58,
      59,    60,   301,   344,   347,    64,    65,    66,    67,    68,
      69,     1,   348,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,   344,   342,   344,   342,   344,
      47,   351,    22,    23,    24,    25,    26,    27,    28,    29,
     351,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,   344,    42,   344,   344,   344,    46,   344,    48,    49,
      50,    51,    52,    53,    54,    55,   344,   344,    58,    59,
      60,   344,   344,   344,    64,    65,    66,    67,    68,    69,
     344,   344,   344,   344,   344,   344,   344,   344,   344,   286,
     344,   344,   344,   344,   344,   344,   344,   344,   344,   344,
     344,   344,   344,   344,   344,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   344,   342,
     344,   349,   344,   344,   331,   344,   344,   344,   335,   344,
     344,   335,   339,   340,   342,   342,   343,   344,   345,   346,
     337,   337,   301,   331,   351,   110,   344,   334,   286,   344,
     334,   334,   334,   334,   334,   334,   334,   334,   334,   334,
     334,   334,   334,   334,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   348,   331,   344,
     344,   323,   337,   337,   347,   351,   337,   335,   334,   349,
     351,   339,   340,   351,   342,   343,   344,   345,   346,   344,
     344,   344,   351,   351,   344,   344,   344,   286,   344,   344,
     344,   344,   344,   344,   344,   344,   344,   344,   344,   344,
     344,   344,   344,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   344,   344,   344,   344,
     344,   344,   344,   344,   344,   344,   335,   198,   981,   882,
     339,   340,   349,   342,   343,   344,   349,   346,  1213,   351,
     351,   853,   351,   851,  1167,  1618,   286,  1215,   366,  1215,
    1539,   367,  1602,    -1,  1346,  1626,   545,    -1,    -1,    -1,
      -1,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   335,    -1,    -1,    -1,   339,
     340,     1,   342,   343,   344,    -1,   346,    -1,    -1,    -1,
      -1,   351,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    38,    -1,
      -1,    41,    42,    43,    44,    45,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    57,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   344,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,    -1,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,    -1,    -1,    -1,    -1,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,    -1,   268,   269,
      -1,    -1,    -1,    -1,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   298,   299,
     300,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     1,   335,     3,     4,     5,     6,
       7,    -1,    -1,   343,    -1,    12,    13,    14,    -1,    -1,
     350,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,    -1,
      -1,    48,    49,    50,    51,    52,    53,    54,    -1,    -1,
      -1,    -1,    59,    60,    -1,    -1,    -1,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,     1,    -1,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    -1,    46,    -1,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    -1,    -1,    -1,    64,    65,    66,    67,    68,    69,
       1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    46,    -1,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,     1,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    46,    -1,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,   286,
     287,    -1,    64,    65,    66,    67,    68,    69,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,    -1,
      -1,    -1,    -1,    -1,   321,    -1,    -1,    -1,   325,    -1,
     327,   328,   329,   330,    -1,   332,   333,   334,   335,    -1,
     337,   338,   339,   340,    -1,    -1,    -1,    -1,   345,   346,
      -1,   348,    -1,    -1,    -1,    -1,     1,    -1,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,   286,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    46,    -1,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,   335,    -1,    -1,    -1,   339,
     340,    -1,    -1,   343,    -1,    -1,    -1,   347,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   286,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   335,    -1,    -1,    -1,   339,   340,
      -1,    -1,   343,    -1,    -1,    -1,   347,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   286,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   335,    -1,    -1,    -1,   339,   340,    -1,
      -1,   343,    -1,    -1,    -1,   347,    -1,    -1,    -1,     1,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    46,    -1,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    -1,
      -1,   286,    64,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     335,    -1,    -1,    -1,   339,   340,    -1,    -1,   343,    -1,
      -1,     1,   347,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    -1,    46,    -1,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    -1,    -1,    -1,    64,    65,    66,    67,    68,    69,
       1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    46,    -1,    48,    49,    50,
      51,    52,    53,    54,    55,    -1,    -1,    58,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,    -1,
      -1,    -1,    -1,    -1,     1,    -1,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,   286,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,    46,
      -1,    48,    49,    50,    51,    52,    53,    54,    55,    -1,
      -1,    58,    59,    60,    -1,    -1,    -1,    64,    65,    66,
      67,    68,    69,   335,    -1,    -1,    -1,   339,   340,    -1,
      -1,   343,    -1,    -1,     1,   347,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,    46,
      -1,    48,    49,    50,    51,    52,    53,    54,    55,    -1,
      -1,    58,    59,    60,    -1,    -1,   286,    64,    65,    66,
      67,    68,    69,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   335,    -1,    -1,    -1,   339,
     340,    -1,    -1,   343,    -1,    -1,    -1,   347,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   286,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   335,    -1,    -1,    -1,   339,   340,
      -1,    -1,   343,    -1,    -1,    -1,   347,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   286,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,    -1,    -1,   343,    -1,    -1,     1,
     347,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,   286,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    46,    -1,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    -1,    58,    59,    60,    -1,
      -1,    -1,    64,    65,    66,    67,    68,    69,   335,    -1,
      -1,    -1,   339,   340,    -1,    -1,   343,    -1,    -1,     1,
     347,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    46,    -1,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    -1,    58,    59,    60,    -1,
      -1,    -1,    64,    65,    66,    67,    68,    69,     1,    -1,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    -1,    -1,    46,    -1,    48,    49,    50,    51,    52,
      53,    54,    55,    -1,    -1,    58,    59,    60,    -1,    -1,
      -1,    64,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      -1,    -1,     1,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    -1,    -1,    46,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    -1,    -1,    58,
      59,    60,    -1,    -1,   286,    64,    65,    66,    67,    68,
      69,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   335,    -1,    -1,    -1,   339,   340,    -1,
      -1,   343,    -1,    -1,     1,   347,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,   286,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,    46,
      -1,    48,    49,    50,    51,    52,    53,    54,    55,    -1,
      -1,    58,    59,    60,    -1,    -1,    -1,    64,    65,    66,
      67,    68,    69,   335,    -1,    -1,    -1,   339,   340,    -1,
      -1,   343,    -1,    -1,    -1,   347,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   286,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   335,    -1,    -1,    -1,   339,   340,    -1,    -1,
     343,    -1,    -1,    -1,   347,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   286,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   335,    -1,    -1,    -1,
     339,   340,    -1,    -1,   343,    -1,    -1,     1,   347,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    -1,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    -1,    -1,    58,    59,    60,    -1,    -1,   286,
      64,    65,    66,    67,    68,    69,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,    -1,    -1,   343,    -1,    -1,     1,
     347,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    46,    -1,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    -1,    58,    59,    60,    -1,
      -1,    -1,    64,    65,    66,    67,    68,    69,     1,    -1,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    -1,    -1,    46,    -1,    48,    49,    50,    51,    52,
      53,    54,    55,    -1,    -1,    58,    59,    60,    -1,    -1,
      -1,    64,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      -1,    -1,     1,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,   286,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    -1,    -1,    46,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    -1,    -1,    58,
      59,    60,    -1,    -1,    -1,    64,    65,    66,    67,    68,
      69,   335,    -1,    -1,    -1,   339,   340,    -1,    -1,   343,
      -1,    -1,     1,   347,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    -1,    -1,    46,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    -1,    -1,    58,
      59,    60,    -1,    -1,   286,    64,    65,    66,    67,    68,
      69,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   335,    -1,    -1,    -1,   339,   340,    -1,
      -1,   343,    -1,    -1,    -1,   347,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   286,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   335,    -1,    -1,    -1,   339,   340,    -1,    -1,
     343,    -1,    -1,    -1,   347,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   286,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   335,    -1,    -1,    -1,
     339,   340,    -1,    -1,   343,    -1,    -1,    -1,   347,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   286,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   335,    -1,    -1,    -1,
     339,   340,    -1,    -1,   343,    -1,    -1,     1,   347,     3,
       4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,    53,
      54,    -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,
      51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,     1,    -1,     3,     4,     5,     6,     7,
      -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    -1,    -1,    -1,
      48,    49,    50,    51,    52,    53,    54,    -1,    -1,    -1,
      -1,    59,    60,    -1,    -1,    -1,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   286,   287,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   321,   322,    -1,
      -1,   325,    -1,   327,   328,   329,   330,    -1,   332,   333,
     334,   335,    -1,   337,    -1,   339,   340,    -1,    -1,    -1,
      -1,   345,   346,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   286,   287,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     321,   322,    -1,    -1,   325,    -1,   327,   328,   329,   330,
      -1,   332,   333,   334,   335,    -1,   337,    -1,   339,   340,
      -1,    -1,    -1,    -1,   345,   346,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   286,   287,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   321,    -1,    -1,    -1,   325,    -1,   327,
     328,   329,   330,    -1,   332,   333,   334,   335,    -1,   337,
      -1,   339,   340,    -1,    -1,    -1,   344,   345,   346,     1,
      -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,
      52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,    -1,
      -1,    -1,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    -1,    -1,    48,    49,    50,    51,    52,    53,    54,
      -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,     1,    -1,     3,     4,     5,     6,     7,
      -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    -1,    -1,    -1,
      48,    49,    50,    51,    52,    53,    54,    -1,    -1,    -1,
      -1,    59,    60,    -1,    -1,    -1,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   286,   287,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   321,
      -1,    -1,    -1,   325,    -1,   327,   328,   329,   330,    -1,
     332,   333,   334,   335,    -1,   337,    -1,   339,   340,    -1,
      -1,    -1,   344,   345,   346,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   286,   287,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   321,    -1,    -1,    -1,
     325,    -1,   327,   328,   329,   330,    -1,   332,   333,   334,
     335,    -1,   337,    -1,   339,   340,    -1,    -1,    -1,   344,
     345,   346,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   286,   287,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   321,    -1,   323,    -1,   325,    -1,   327,
     328,   329,   330,    -1,   332,   333,   334,   335,    -1,   337,
      -1,   339,   340,    -1,    -1,    -1,    -1,   345,   346,     1,
      -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,
      52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,    -1,
      -1,    -1,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    -1,    -1,    48,    49,    50,    51,    52,    53,    54,
      -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,     1,    -1,     3,     4,     5,     6,     7,
      -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    -1,    -1,    -1,
      48,    49,    50,    51,    52,    53,    54,    -1,    -1,    -1,
      -1,    59,    60,    -1,    -1,    -1,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   286,   287,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   321,
      -1,    -1,    -1,   325,    -1,   327,   328,   329,   330,    -1,
     332,   333,   334,   335,    -1,   337,    -1,   339,   340,    -1,
      -1,    -1,    -1,   345,   346,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   286,   287,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   321,    -1,    -1,    -1,
     325,    -1,   327,   328,   329,   330,    -1,   332,   333,   334,
     335,    -1,   337,    -1,   339,   340,    -1,    -1,    -1,    -1,
     345,   346,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   286,   287,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   321,    -1,    -1,    -1,   325,    -1,   327,
     328,   329,   330,    -1,   332,   333,   334,   335,    -1,   337,
      -1,   339,   340,    -1,    -1,    -1,    -1,   345,   346,     1,
      -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,
      52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,    -1,
      -1,    -1,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    -1,    -1,    48,    49,    50,    51,    52,    53,    54,
      -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,     1,    -1,     3,     4,     5,     6,     7,
      -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    -1,    -1,    -1,
      48,    49,    50,    51,    52,    53,    54,    -1,    -1,    -1,
      -1,    59,    60,    -1,    -1,    -1,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   286,   287,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   321,
      -1,    -1,    -1,   325,    -1,   327,   328,   329,   330,    -1,
     332,   333,   334,   335,    -1,   337,    -1,   339,   340,    -1,
      -1,    -1,    -1,   345,   346,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   286,   287,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   321,    -1,    -1,    -1,
     325,    -1,   327,   328,   329,   330,    -1,   332,   333,   334,
     335,    -1,   337,    -1,   339,   340,    -1,    -1,    -1,    -1,
     345,   346,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   286,   287,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   321,    -1,    -1,    -1,   325,    -1,   327,
     328,   329,   330,    -1,   332,   333,   334,   335,    -1,   337,
      -1,   339,   340,    -1,    -1,    -1,    -1,   345,   346,     1,
      -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,
      52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,    -1,
      -1,    -1,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    -1,    -1,    48,    49,    50,    51,    52,    53,    54,
      -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,     1,    -1,     3,     4,     5,     6,     7,
      -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    -1,    -1,    -1,
      48,    49,    50,    51,    52,    53,    54,    -1,    -1,    -1,
      -1,    59,    60,    -1,    -1,    -1,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   286,   287,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   321,
      -1,    -1,    -1,   325,    -1,   327,   328,   329,   330,    -1,
     332,   333,   334,   335,    -1,   337,    -1,   339,   340,    -1,
      -1,    -1,    -1,   345,   346,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   286,   287,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   321,    -1,    -1,    -1,
     325,    -1,   327,   328,   329,   330,    -1,   332,   333,   334,
     335,    -1,   337,    -1,   339,   340,    -1,    -1,    -1,    -1,
     345,   346,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   286,   287,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   321,    -1,    -1,    -1,   325,    -1,   327,
     328,   329,   330,    -1,   332,   333,   334,   335,    -1,   337,
      -1,   339,   340,    -1,    -1,    -1,    -1,   345,   346,     1,
      -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,
      52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,    -1,
      -1,    -1,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    -1,    -1,    48,    49,    50,    51,    52,    53,    54,
      -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,     1,    -1,     3,     4,     5,     6,     7,
      -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    -1,    -1,    -1,
      48,    49,    50,    51,    52,    53,    54,    -1,    -1,    -1,
      -1,    59,    60,    -1,    -1,    -1,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   286,   287,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   321,
      -1,    -1,    -1,   325,    -1,   327,   328,   329,   330,    -1,
     332,   333,   334,   335,    -1,   337,    -1,   339,   340,    -1,
      -1,    -1,    -1,   345,   346,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   286,   287,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   321,    -1,    -1,    -1,
     325,    -1,   327,   328,   329,   330,    -1,   332,   333,   334,
     335,    -1,   337,    -1,   339,   340,    -1,    -1,    -1,    -1,
     345,   346,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   286,   287,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   321,    -1,    -1,    -1,   325,    -1,   327,
     328,   329,   330,    -1,   332,   333,   334,   335,    -1,   337,
      -1,   339,   340,    -1,    -1,    -1,    -1,   345,   346,     1,
      -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,
      52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,    -1,
      -1,    -1,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    -1,    -1,    48,    49,    50,    51,    52,    53,    54,
      -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,     1,    -1,     3,     4,     5,     6,     7,
      -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    -1,    -1,    -1,
      48,    49,    50,    51,    52,    53,    54,    -1,    -1,    -1,
      -1,    59,    60,    -1,    -1,    -1,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   286,   287,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   321,
      -1,    -1,    -1,   325,    -1,   327,   328,   329,   330,    -1,
     332,   333,   334,   335,    -1,   337,    -1,   339,   340,    -1,
      -1,    -1,    -1,   345,   346,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   286,   287,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   321,    -1,    -1,    -1,
     325,    -1,   327,   328,   329,   330,    -1,   332,   333,   334,
     335,    -1,   337,    -1,   339,   340,    -1,    -1,    -1,    -1,
     345,   346,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   286,   287,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   321,    -1,    -1,    -1,   325,    -1,   327,
     328,   329,   330,    -1,   332,   333,   334,   335,    -1,   337,
      -1,   339,   340,    -1,    -1,    -1,    -1,   345,   346,     1,
      -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,
      52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,    -1,
      -1,    -1,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    -1,    -1,    48,    49,    50,    51,    52,    53,    54,
      -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,     1,    -1,     3,     4,     5,     6,     7,
      -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    -1,    -1,    -1,
      48,    49,    50,    51,    52,    53,    54,    -1,    -1,    -1,
      -1,    59,    60,    -1,    -1,    -1,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   286,   287,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   321,
      -1,    -1,    -1,   325,    -1,   327,   328,   329,   330,    -1,
     332,   333,   334,   335,    -1,   337,    -1,   339,   340,    -1,
      -1,    -1,    -1,   345,   346,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   286,   287,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   321,    -1,    -1,    -1,
     325,    -1,   327,   328,   329,   330,    -1,   332,   333,   334,
     335,    -1,   337,    -1,   339,   340,    -1,    -1,    -1,    -1,
     345,   346,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   286,   287,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   321,    -1,    -1,    -1,   325,    -1,   327,
     328,   329,   330,    -1,   332,   333,   334,   335,    -1,   337,
      -1,   339,   340,    -1,    -1,    -1,    -1,   345,   346,     1,
      -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,
      52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,    -1,
      -1,    -1,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    -1,    -1,    48,    49,    50,    51,    52,    53,    54,
      -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,     1,    -1,     3,     4,     5,     6,     7,
      -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    -1,    -1,    -1,
      48,    49,    50,    51,    52,    53,    54,    -1,    -1,    -1,
      -1,    59,    60,    -1,    -1,    -1,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   286,   287,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   321,
      -1,    -1,    -1,   325,    -1,   327,   328,   329,   330,    -1,
     332,   333,   334,   335,    -1,   337,    -1,   339,   340,    -1,
      -1,    -1,    -1,   345,   346,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   286,   287,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   321,    -1,    -1,    -1,
     325,    -1,   327,   328,   329,   330,    -1,   332,   333,   334,
     335,    -1,   337,    -1,   339,   340,    -1,    -1,    -1,    -1,
     345,   346,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   286,   287,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   321,    -1,    -1,    -1,   325,    -1,   327,
     328,   329,   330,    -1,   332,   333,   334,   335,    -1,   337,
      -1,   339,   340,    -1,    -1,    -1,    -1,   345,   346,     1,
      -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,
      52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,    -1,
      -1,    -1,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    -1,    -1,    48,    49,    50,    51,    52,    53,    54,
      -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,     1,    -1,     3,     4,     5,     6,     7,
      -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    -1,    -1,    -1,
      48,    49,    50,    51,    52,    53,    54,    -1,    -1,    -1,
      -1,    59,    60,    -1,    -1,    -1,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   286,   287,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   321,
      -1,    -1,    -1,   325,    -1,   327,   328,   329,   330,    -1,
     332,   333,   334,   335,    -1,   337,    -1,   339,   340,    -1,
      -1,    -1,    -1,   345,   346,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   286,   287,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   321,    -1,    -1,    -1,
     325,    -1,   327,   328,   329,   330,    -1,   332,   333,   334,
     335,    -1,   337,    -1,   339,   340,    -1,    -1,    -1,    -1,
     345,   346,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   286,   287,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   321,    -1,    -1,    -1,   325,    -1,   327,
     328,   329,   330,    -1,   332,   333,   334,   335,    -1,   337,
      -1,   339,   340,    -1,    -1,    -1,    -1,   345,   346,     1,
      -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,
      52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,    -1,
      -1,    -1,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,    46,
      -1,    48,    49,    50,    51,    52,    53,    54,    55,    -1,
      -1,    58,    59,    60,    -1,    -1,    -1,    64,    65,    66,
      67,    68,    69,     3,     4,     5,     6,     7,    -1,    -1,
      -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,
      50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,
      60,    -1,    -1,    -1,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   286,   287,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   321,
      -1,    -1,    -1,   325,    -1,   327,   328,   329,   330,    -1,
     332,   333,   334,   335,    -1,   337,    -1,   339,   340,    -1,
      -1,    -1,    -1,   345,   346,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   286,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,    -1,    -1,   343,    -1,    -1,   346,
      -1,    -1,    -1,    -1,    -1,    -1,   286,   287,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   321,    -1,    -1,    -1,   325,    -1,   327,   328,   329,
     330,    -1,   332,   333,   334,   335,    -1,   337,    -1,   339,
     340,    -1,    -1,    -1,    -1,   345,   346,     3,     4,     5,
       6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,
      -1,    -1,    48,    49,    50,    51,    52,    53,    54,    -1,
      -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,
      51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,     3,     4,     5,
       6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,
      -1,    -1,    48,    49,    50,    51,    52,    53,    54,    -1,
      -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     286,   287,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   321,    -1,    -1,    -1,   325,
      -1,   327,   328,   329,   330,    -1,   332,   333,   334,   335,
      -1,   337,    -1,   339,   340,    -1,    -1,    -1,    -1,   345,
     346,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   286,   287,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     321,    -1,    -1,    -1,   325,    -1,   327,   328,   329,   330,
      -1,   332,   333,   334,   335,    -1,   337,    -1,   339,   340,
      -1,    -1,    -1,    -1,   345,   346,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     286,   287,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   321,    -1,    -1,    -1,   325,
      -1,   327,   328,   329,   330,    -1,   332,   333,   334,   335,
      -1,   337,    -1,   339,   340,    -1,    -1,    -1,    -1,   345,
     346,     3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,
      52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,    -1,
      -1,    -1,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,    46,
      -1,    48,    49,    50,    51,    52,    53,    54,    55,    -1,
      -1,    58,    59,    60,    -1,    -1,    -1,    64,    65,    66,
      67,    68,    69,     1,    -1,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    -1,    46,    -1,
      48,    49,    50,    51,    52,    53,    54,    55,    -1,    -1,
      58,    59,    60,    -1,    -1,    -1,    64,    65,    66,    67,
      68,    69,    -1,    -1,    -1,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    -1,    46,    -1,
      48,    49,    50,    51,    52,    53,    54,    55,    -1,    -1,
      58,    59,    60,    -1,   286,   287,    64,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   321,
      -1,    -1,    -1,   325,    -1,   327,   328,   329,   330,    -1,
     332,   333,   334,   335,    -1,   337,    -1,   339,   340,    -1,
      -1,    -1,    -1,   345,   346,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   286,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,    -1,    -1,   343,    -1,    -1,   346,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   286,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   335,    -1,    -1,
      -1,   339,   340,    -1,    -1,   343,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   286,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   335,    -1,    -1,
      -1,   339,   340,    -1,    -1,   343
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     1,    17,    18,    38,    41,    42,    43,    44,    45,
      57,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   268,   269,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   298,   299,   300,   335,   343,   350,   353,   354,   355,
     356,   357,   358,   359,   360,   371,   375,   378,   379,   381,
     382,   392,   393,   402,   301,     1,   348,     1,   301,   301,
     301,   301,   301,   301,   301,   301,   301,   301,   301,   301,
     301,   301,   301,   301,   301,   301,   301,   301,   301,   301,
     301,   301,   301,     1,   301,     1,   301,     1,   301,     1,
     301,     1,   301,     1,   301,     1,   301,     1,   301,     1,
     301,     1,   301,     1,   301,     1,   301,     1,   301,     1,
     301,     1,   301,     1,   301,     1,   301,     1,   301,     1,
     301,     1,   301,     1,   301,     1,   301,     1,   301,     1,
     301,     1,   301,     1,   301,     1,   301,     1,   301,     1,
     301,     1,   301,     1,   301,     1,   301,     1,   301,     1,
     301,     1,   301,     1,   301,   301,   301,   301,   301,   301,
     301,   301,   301,   301,   301,   301,   301,   301,   301,   301,
     301,   301,   301,   301,   301,   301,     1,   337,     1,   301,
     337,     1,   345,     1,   301,   337,   301,   301,   301,   301,
     301,   301,   301,   301,   301,   301,   301,   301,   301,   301,
     301,   301,   301,   301,   301,   301,   301,   301,   301,   301,
       1,   301,     1,   301,     1,   301,     1,   301,   301,   301,
     301,   301,   301,   301,   301,   301,   301,   301,   301,   301,
     301,   301,   301,   301,   301,   301,   301,   301,   301,   301,
     301,   301,   301,   301,   301,   301,   301,   301,   301,   301,
     301,   301,   301,   301,   301,   301,   301,   301,   301,   301,
     301,   301,   301,   301,   301,     1,   301,   301,   301,   301,
     301,   301,   301,   301,   301,   301,   301,   301,   331,   301,
     301,   301,   301,   301,   301,   301,   301,   301,   301,     1,
     335,   337,   372,   373,   374,     1,   374,   376,   377,     1,
     337,     1,   337,     1,   337,     0,     1,   355,    14,    15,
     388,   389,    16,   390,   391,    19,   396,   397,    20,   398,
     399,    21,   400,   401,   331,   348,   346,   334,   335,   337,
     387,     1,   334,     1,   334,     1,    88,    89,    90,    91,
     322,   364,     1,   321,   334,   370,     1,   334,     1,   334,
       1,   370,     1,   334,     1,   334,     1,   334,     1,   334,
       1,   335,     1,   337,     1,   334,     1,   337,     1,   334,
       1,   337,     1,   337,     1,   337,     1,   337,     1,   334,
     335,   336,   337,   338,   345,   348,   361,   363,   364,   368,
     369,   383,   384,   385,   386,   416,   417,     1,   369,     1,
     334,     1,   334,     1,   334,   334,   334,   334,   370,   370,
     370,   370,   334,   334,   334,   334,   334,   334,   334,   334,
     334,   334,   334,   334,   334,   334,   334,   334,   334,   334,
     334,   334,   334,   334,   334,   334,   334,   334,   334,   334,
     334,     1,   370,     1,   334,     1,   334,     1,   334,     1,
     334,     1,   334,     1,   334,     1,   334,     1,   334,     1,
     370,     1,   370,     1,   370,     1,   370,     1,   370,     1,
     370,     1,   370,     1,   334,     1,   334,     1,   337,     1,
     337,     1,   334,     1,   337,   337,     1,   337,     1,   334,
       1,   334,     1,   335,   337,     1,   335,   337,     1,   335,
     337,     1,   335,   337,     1,   335,   337,     1,   334,     1,
     334,     1,   334,     1,   334,     1,   334,     1,   334,     1,
     370,     1,   370,     1,   370,     1,   335,   337,     1,   334,
       1,   334,     1,   334,     1,   334,   384,     1,   386,     1,
     334,     1,   334,   334,   334,   334,   334,     1,   334,     1,
     334,     1,   334,     1,   334,     1,   334,     1,   334,     1,
     334,     1,   334,     1,   334,     1,   334,     1,   334,     1,
     334,     1,   334,     1,   334,     1,   334,     1,   334,     1,
     334,     1,   334,     1,   226,   227,   228,   229,     1,   334,
       1,   334,     1,   334,     1,   334,     1,   337,     1,   337,
       1,   337,     1,   334,     1,   334,     1,   334,     1,   361,
       1,   334,     1,   334,     1,   334,     1,   334,     1,   334,
       1,   334,     1,   334,     1,   334,     1,   334,     1,   334,
       1,   334,     1,   334,     1,   334,     1,   334,     1,   334,
       1,   335,   337,     1,   334,   335,   334,     1,   334,     1,
     334,     1,   334,     1,   334,     1,   334,     1,   334,     1,
     334,     1,   337,     1,   334,     1,   334,     1,   334,   270,
     271,   272,   273,     1,   370,   334,   334,     1,   370,     1,
     370,     1,   334,     1,   334,     1,   334,     1,   334,     1,
     334,   342,   351,   342,     1,   348,     1,   346,     1,   348,
     346,     1,   348,   346,     1,   348,   346,     1,   348,    57,
     334,   335,   380,   334,   394,   349,   334,   331,   361,   362,
     385,   351,   351,   369,   109,   110,   321,   331,   342,   301,
     301,   301,   301,   372,   334,   376,   387,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    22,
      23,    24,    25,    26,    27,    28,    29,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    42,    46,    48,
      49,    50,    51,    52,    53,    54,    55,    58,    59,    60,
      64,    65,    66,    67,    68,    69,   286,   335,   339,   340,
     343,   418,   420,   421,   422,   426,   427,   435,   436,   438,
     439,   442,   443,   445,   449,   450,   451,   455,   387,   420,
     387,   420,   387,   420,   341,   301,   349,   420,     1,   395,
     334,   342,   344,   349,     1,   322,   334,   366,   363,   361,
     337,     1,   334,   416,     1,   416,   337,     1,   337,     1,
     337,     1,   337,     1,   337,   349,     1,   345,     1,   345,
       1,   345,     1,   345,     1,   345,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,   287,   321,   325,   327,   328,   329,
     330,   332,   333,   337,   345,   346,   370,   408,   409,   410,
     411,   412,   413,   418,   430,   435,   436,   437,   438,   440,
     442,   443,   446,   447,   448,   345,   448,   345,   448,     1,
     345,     1,   345,     1,   345,   345,     1,   345,     1,   345,
       1,   345,     1,   345,     1,   345,     1,   345,     1,   345,
       1,   345,   345,     1,   345,     1,   345,     1,   345,     1,
     345,   345,   345,   345,   345,   345,   345,   448,     1,   345,
       1,   345,     1,   345,   345,   345,   345,   345,     1,   448,
     448,     1,   345,     1,   345,     1,   345,     1,   345,     1,
     345,     1,   452,     1,   343,     1,   347,   421,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   335,   432,   433,
     434,   301,   444,   343,     1,   345,   343,   349,   347,   349,
     347,   349,   347,   349,     1,   334,   337,   331,   347,   346,
     331,   362,   351,   110,   351,   342,   346,     1,    61,   335,
     337,   344,   383,   415,     1,    61,   337,   383,   415,     1,
      61,   337,   383,   415,     1,    61,   337,   383,   415,     1,
      61,   337,   383,   415,     1,   309,   310,   311,   314,   315,
     403,   405,   403,   403,     1,   403,   431,     1,   448,     1,
     448,     1,   448,   345,   345,     1,   344,   436,   438,   442,
     443,   448,   449,     1,   420,     1,   405,     1,   316,   317,
     318,   319,   403,   404,     1,   405,   434,     1,   448,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   406,   407,   344,   344,     1,   334,   337,     1,
     337,     1,   335,   448,   337,     1,   337,     1,   337,     1,
     337,     1,   337,     1,   334,     1,   334,   344,     1,   344,
     370,   344,     1,   337,     1,   337,     1,   337,     1,   337,
     344,   344,   344,     1,   334,   344,     1,   364,   346,   419,
     421,     1,   361,     1,   334,     1,   361,   364,   367,   344,
     344,   344,   344,   346,   419,     1,   337,     1,   337,   334,
     374,   334,   374,   334,   374,   345,   331,   348,   448,     1,
     337,   435,   436,   441,   443,   346,   346,   346,   346,   267,
     267,   380,   420,   334,   366,   337,   334,   337,   370,   420,
     344,   342,   344,   342,   344,   342,   344,   321,   331,   342,
     344,   344,   342,   344,   342,   344,   342,   344,   342,   344,
     344,   342,   344,   342,   344,   342,   344,   342,   344,   344,
     342,   344,   342,   344,   342,   344,   342,   344,   344,   342,
     344,   342,   344,   342,   344,   342,   344,     1,   335,   448,
       1,    88,    89,    90,    91,    92,    93,   322,   365,   448,
       1,   365,   448,     1,   408,   412,   335,   428,   429,     1,
     448,     1,   448,   344,   344,   344,   347,   347,     1,    86,
     448,     1,   448,     1,   448,     1,    86,   334,   335,   383,
     414,   415,   448,   348,     1,   448,     1,   448,     1,   448,
       1,   448,   448,   448,   448,     1,   448,     1,   448,     1,
     448,     1,   448,     1,   448,     1,   448,     1,   448,   344,
     342,   344,   344,   342,   344,   344,   344,   344,   344,   344,
     344,   344,   344,   344,   344,   344,   344,   344,   344,   344,
     344,   344,   344,   344,   344,   344,   344,   344,   344,   344,
     344,   344,   344,   344,   420,    47,   344,   344,   344,   344,
     344,   351,   351,   344,     1,    56,    57,   347,   424,   425,
     344,   342,   344,   344,   344,   344,   344,   344,   344,   344,
     448,   453,   454,   433,   349,   342,   344,   434,   342,   420,
     420,   420,   420,   337,   337,   301,   347,   331,   110,   344,
     344,   347,    62,   334,   334,   334,     1,   335,     1,   335,
     334,    62,   334,   334,   334,   334,    62,   334,   334,   334,
     334,    62,   334,   334,   334,   334,    62,   334,   334,   334,
     334,   348,   331,   344,   344,   344,   344,   323,   370,   337,
     337,   347,   419,     1,   366,   361,   347,     1,   323,   423,
     448,   351,   347,   424,   334,   448,   342,   344,   374,     1,
     374,   347,   347,   347,   347,   334,   337,   334,   337,   344,
     344,   344,   344,   344,   344,   344,   344,   344,   344,   344,
     344,   344,   344,   344,   344,   344,   344,   344,   344,   344,
     344,   344,   344,   344,   337,   370,   428,     1,   334,   383,
     349,   344,   344,   351,   351,     1,   423,   351,   420,   344,
     344,   454,   344,   344,   344,   349,   349,   366,   420,   351,
     351,     1,   420,   420,   420
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   352,   353,   354,   354,   354,   355,   355,   355,   355,
     355,   356,   355,   357,   355,   355,   358,   355,   359,   355,
     360,   355,   355,   355,   361,   361,   361,   362,   362,   363,
     363,   364,   364,   364,   364,   364,   365,   365,   365,   365,
     365,   365,   365,   366,   366,   367,   367,   367,   367,   367,
     368,   368,   368,   368,   368,   369,   369,   370,   370,   371,
     371,   372,   372,   373,   373,   374,   374,   375,   375,   376,
     376,   377,   378,   378,   378,   378,   378,   378,   378,   378,
     378,   378,   378,   378,   378,   378,   378,   378,   378,   378,
     378,   378,   378,   378,   378,   378,   378,   378,   378,   378,
     378,   378,   378,   378,   378,   378,   378,   378,   378,   378,
     378,   378,   378,   378,   378,   378,   378,   378,   378,   378,
     378,   378,   378,   378,   378,   378,   378,   378,   378,   378,
     378,   378,   378,   378,   378,   378,   378,   378,   378,   378,
     378,   378,   378,   378,   378,   378,   378,   378,   378,   378,
     378,   378,   378,   378,   378,   378,   378,   378,   378,   378,
     378,   378,   378,   378,   378,   378,   378,   378,   378,   378,
     378,   378,   378,   378,   378,   378,   378,   378,   378,   378,
     378,   378,   378,   378,   378,   378,   378,   378,   378,   378,
     378,   378,   378,   378,   378,   378,   378,   378,   378,   378,
     378,   378,   378,   378,   378,   378,   378,   378,   378,   378,
     378,   378,   378,   378,   378,   378,   378,   378,   378,   378,
     378,   378,   378,   378,   378,   378,   378,   378,   378,   378,
     378,   378,   378,   378,   378,   378,   378,   378,   378,   378,
     378,   378,   378,   378,   378,   378,   378,   378,   378,   378,
     378,   378,   378,   378,   378,   378,   378,   378,   378,   378,
     378,   378,   378,   378,   378,   378,   378,   378,   378,   378,
     378,   378,   378,   378,   378,   378,   378,   378,   378,   378,
     378,   378,   378,   378,   378,   378,   378,   378,   378,   378,
     378,   378,   378,   378,   378,   378,   378,   378,   378,   378,
     378,   378,   378,   378,   378,   378,   378,   378,   378,   378,
     378,   378,   378,   378,   378,   378,   378,   378,   378,   378,
     378,   378,   378,   378,   378,   378,   378,   378,   378,   378,
     378,   378,   378,   378,   378,   378,   378,   378,   378,   378,
     378,   378,   378,   378,   378,   378,   378,   378,   378,   378,
     378,   378,   378,   378,   378,   378,   378,   378,   378,   378,
     378,   378,   378,   378,   378,   378,   378,   378,   378,   378,
     378,   378,   378,   378,   378,   378,   378,   378,   378,   378,
     378,   378,   378,   378,   378,   378,   378,   378,   378,   378,
     378,   378,   378,   378,   378,   378,   378,   378,   378,   378,
     378,   378,   378,   378,   378,   378,   378,   378,   378,   378,
     378,   378,   378,   378,   378,   378,   378,   378,   378,   378,
     378,   378,   378,   378,   378,   378,   378,   378,   378,   378,
     378,   378,   378,   378,   378,   378,   378,   378,   378,   378,
     378,   378,   378,   378,   378,   378,   378,   378,   378,   378,
     378,   378,   378,   378,   379,   379,   380,   380,   380,   381,
     381,   381,   381,   381,   381,   381,   382,   382,   382,   382,
     382,   382,   382,   382,   382,   382,   382,   382,   382,   383,
     383,   384,   385,   386,   386,   387,   387,   387,   388,   388,
     389,   389,   389,   389,   390,   391,   391,   391,   392,   392,
     394,   393,   393,   393,   395,   393,   393,   396,   397,   397,
     397,   398,   399,   399,   399,   400,   401,   401,   402,   402,
     402,   402,   402,   402,   403,   403,   403,   403,   404,   404,
     404,   404,   405,   405,   406,   406,   406,   406,   406,   406,
     406,   407,   407,   407,   407,   408,   408,   408,   409,   409,
     409,   410,   410,   410,   410,   410,   411,   411,   412,   412,
     412,   413,   413,   413,   413,   413,   413,   413,   413,   413,
     413,   413,   413,   413,   413,   413,   413,   413,   413,   413,
     413,   413,   413,   413,   413,   413,   413,   413,   413,   413,
     414,   414,   414,   414,   415,   415,   415,   415,   415,   416,
     416,   416,   417,   417,   417,   417,   417,   418,   419,   419,
     420,   420,   420,   421,   421,   421,   421,   421,   421,   421,
     421,   422,   422,   423,   424,   424,   424,   424,   424,   424,
     424,   424,   424,   424,   424,   425,   425,   426,   426,   426,
     426,   427,   428,   428,   428,   429,   429,   431,   430,   432,
     432,   432,   432,   432,   432,   432,   432,   432,   433,   434,
     434,   435,   436,   437,   438,   439,   439,   440,   440,   440,
     441,   441,   441,   442,   443,   444,   445,   445,   445,   446,
     446,   446,   446,   446,   446,   446,   446,   446,   446,   446,
     446,   447,   447,   447,   448,   448,   448,   448,   448,   448,
     448,   448,   448,   448,   448,   448,   448,   448,   448,   448,
     448,   448,   448,   448,   448,   448,   448,   448,   448,   448,
     448,   448,   448,   448,   448,   448,   448,   448,   448,   448,
     448,   448,   448,   449,   450,   450,   450,   451,   451,   451,
     451,   451,   451,   451,   451,   451,   451,   451,   451,   451,
     451,   451,   451,   451,   451,   451,   451,   451,   451,   451,
     451,   451,   451,   451,   451,   451,   451,   451,   451,   451,
     451,   451,   451,   451,   451,   451,   451,   451,   451,   451,
     451,   451,   451,   451,   451,   451,   451,   451,   451,   451,
     451,   451,   451,   451,   451,   451,   451,   451,   451,   451,
     451,   451,   451,   451,   451,   451,   451,   451,   451,   451,
     451,   451,   451,   451,   451,   451,   451,   451,   451,   451,
     451,   451,   451,   451,   451,   451,   451,   451,   451,   451,
     451,   451,   451,   451,   451,   451,   451,   451,   451,   451,
     451,   451,   451,   451,   451,   451,   451,   451,   451,   451,
     451,   451,   451,   451,   451,   451,   451,   451,   451,   451,
     451,   451,   451,   451,   451,   451,   451,   451,   451,   451,
     451,   451,   451,   451,   451,   451,   451,   451,   451,   451,
     451,   451,   451,   451,   451,   451,   451,   451,   451,   451,
     451,   451,   452,   451,   451,   453,   453,   453,   454,   455,
     455,   455,   455,   455,   455,   455,   455,   455,   455
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     1,     2,     1,     1,     1,     1,
       1,     0,     2,     0,     2,     1,     0,     2,     0,     2,
       0,     2,     1,     1,     1,     1,     1,     1,     3,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     5,     3,
       1,     3,     3,     5,     3,     1,     2,     1,     2,     2,
       2,     1,     3,     1,     3,     1,     1,     2,     2,     1,
       3,     1,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     5,     7,     9,     5,     7,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     2,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     5,     5,     5,     5,     5,     5,
       5,     5,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     1,     2,     1,     1,     1,     1,     1,     5,
       5,     7,     7,     5,     8,     8,     2,     2,     2,     2,
       3,     3,     8,     8,     2,     2,     2,     3,     3,     1,
       1,     7,     1,     1,     3,     1,     1,     1,     1,     1,
       4,     7,     2,     2,     1,     4,     7,     2,     1,     1,
       0,     5,     2,     2,     0,     8,     5,     1,     4,     7,
       2,     1,     4,     7,     2,     1,     7,     2,     2,     2,
       2,     2,     2,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     3,     3,     2,     3,     3,     3,     2,     3,
       3,     3,     3,     2,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     3,     3,     3,     2,
       3,     3,     1,     3,     1,     3,     3,     3,     3,     1,
       1,     1,     1,     3,     3,     3,     3,     1,     1,     3,
       2,     1,     2,     2,     1,     1,     1,     2,     2,     1,
       2,     3,     5,     1,     4,     5,     3,     4,     3,     2,
       4,     5,     3,     4,     4,     2,     1,     5,     4,     2,
       5,     3,     1,     4,     4,     3,     1,     0,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     1,     2,     5,     4,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     3,     3,
       3,     1,     1,     1,     1,     2,     2,     2,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     4,     4,     2,     2,     2,     2,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       4,     4,     2,     3,     1,     1,     1,     3,     4,     4,
       4,     6,     6,     6,     6,     6,     4,     2,     4,     4,
       4,     4,     6,     6,     6,     6,     6,     4,     2,     4,
       4,     4,     4,     6,     6,     6,     6,     6,     4,     2,
       4,     4,     4,     4,     6,     6,     6,     6,     6,     4,
       2,     4,     4,     4,     4,     6,     6,     6,     6,     6,
       4,     2,     4,     4,     6,     2,     4,     4,     4,     2,
       4,     4,     2,     4,     4,     2,     6,     6,     6,     4,
       2,     6,     2,     4,     4,     4,     2,     4,     4,     4,
       2,     4,     4,     2,     4,     4,     2,     4,     4,     2,
       4,     3,     2,     4,     3,     2,     4,     3,     4,     2,
       4,     4,     2,     4,     4,     2,     4,     4,     2,     4,
       4,     2,     4,     4,     2,     4,     3,     1,     3,     1,
       3,     1,     4,     3,     1,     4,     4,     4,     4,     4,
       2,     4,     4,     2,     4,     4,     2,     3,     1,     3,
       1,     3,     1,     3,     1,     6,     6,     2,     4,     4,
       2,     4,     0,     5,     2,     0,     3,     1,     1,     3,
       2,     1,     3,     2,     1,     1,     3,     2,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:
#line 629 "core/cfg.y" /* yacc.c:1646  */
    {}
#line 5088 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 4:
#line 630 "core/cfg.y" /* yacc.c:1646  */
    {}
#line 5094 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 5:
#line 631 "core/cfg.y" /* yacc.c:1646  */
    { yyerror(""); YYABORT;}
#line 5100 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 11:
#line 639 "core/cfg.y" /* yacc.c:1646  */
    {rt=REQUEST_ROUTE;}
#line 5106 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 13:
#line 640 "core/cfg.y" /* yacc.c:1646  */
    {rt=FAILURE_ROUTE;}
#line 5112 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 642 "core/cfg.y" /* yacc.c:1646  */
    {rt=BRANCH_ROUTE;}
#line 5118 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 643 "core/cfg.y" /* yacc.c:1646  */
    {rt=ONSEND_ROUTE;}
#line 5124 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 644 "core/cfg.y" /* yacc.c:1646  */
    {rt=EVENT_ROUTE;}
#line 5130 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 24:
#line 649 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].ipaddr)){
			tmp=ip_addr2a((yyvsp[0].ipaddr));
			if (tmp==0) {
				LM_CRIT("cfg. parser: bad ip address.\n");
				(yyval.strval)=0;
			} else {
				(yyval.strval)=pkg_malloc(strlen(tmp)+1);
				if ((yyval.strval)==0) {
					PKG_MEM_CRITICAL;
				} else {
					strncpy((yyval.strval), tmp, strlen(tmp)+1);
				}
			}
		}
	}
#line 5151 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 25:
#line 665 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.strval)=pkg_malloc(strlen((yyvsp[0].strval))+1);
		if ((yyval.strval)==0) {
				PKG_MEM_CRITICAL;
		} else {
				strncpy((yyval.strval), (yyvsp[0].strval), strlen((yyvsp[0].strval))+1);
		}
	}
#line 5164 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 26:
#line 673 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].strval)){
			(yyval.strval)=pkg_malloc(strlen((yyvsp[0].strval))+1);
			if ((yyval.strval)==0) {
					PKG_MEM_CRITICAL;
			} else {
					strncpy((yyval.strval), (yyvsp[0].strval), strlen((yyvsp[0].strval))+1);
			}
		}
	}
#line 5179 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 687 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.name_l)=mk_name_lst((yyvsp[0].strval), SI_IS_MHOMED); }
#line 5185 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 688 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.name_l)=mk_name_lst((yyvsp[-2].strval), SI_IS_MHOMED);
										if ((yyval.name_l)) (yyval.name_l)->next=(yyvsp[0].name_l);
									}
#line 5193 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 29:
#line 694 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.name_l)=(yyvsp[-1].name_l); }
#line 5199 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 695 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.name_l)=mk_name_lst((yyvsp[0].strval), 0); }
#line 5205 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 31:
#line 699 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_UDP; }
#line 5211 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 700 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_TCP; }
#line 5217 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 701 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_TLS; }
#line 5223 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 34:
#line 702 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_SCTP; }
#line 5229 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 703 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=0; }
#line 5235 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 706 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_UDP; }
#line 5241 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 707 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_TCP; }
#line 5247 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 708 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_TLS; }
#line 5253 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 709 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_SCTP; }
#line 5259 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 710 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_WS; }
#line 5265 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 711 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_WSS; }
#line 5271 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 712 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=0; }
#line 5277 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 715 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=(yyvsp[0].intval); }
#line 5283 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 716 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=0; }
#line 5289 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 719 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id((yyvsp[0].strval), 0, 0); }
#line 5295 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 720 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id((yyvsp[-2].strval), 0, (yyvsp[0].intval)); }
#line 5301 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 47:
#line 721 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id((yyvsp[0].strval), (yyvsp[-2].intval), 0); }
#line 5307 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 48:
#line 722 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id((yyvsp[-2].strval), (yyvsp[-4].intval), (yyvsp[0].intval));}
#line 5313 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 49:
#line 723 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=0; yyerror("port number expected"); }
#line 5319 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 727 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id2((yyvsp[0].name_l), 0, 0); }
#line 5325 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 51:
#line 728 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id2((yyvsp[-2].name_l), 0, (yyvsp[0].intval)); }
#line 5331 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 729 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id2((yyvsp[0].name_l), (yyvsp[-2].intval), 0); }
#line 5337 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 730 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id2((yyvsp[-2].name_l), (yyvsp[-4].intval), (yyvsp[0].intval));}
#line 5343 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 731 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=0; yyerror("port number expected"); }
#line 5349 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 735 "core/cfg.y" /* yacc.c:1646  */
    {  (yyval.sockid)=(yyvsp[0].sockid) ; }
#line 5355 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 736 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=(yyvsp[-1].sockid);  if ((yyval.sockid)) (yyval.sockid)->next=(yyvsp[0].sockid); }
#line 5361 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 740 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=-(yyvsp[0].intval); }
#line 5367 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 744 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("flag list expected\n"); }
#line 5373 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 63:
#line 750 "core/cfg.y" /* yacc.c:1646  */
    { if (register_flag((yyvsp[0].strval),-1)<0)
								yyerror("register flag failed");
						}
#line 5381 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 64:
#line 753 "core/cfg.y" /* yacc.c:1646  */
    {
						if (register_flag((yyvsp[-2].strval), (yyvsp[0].intval))<0)
								yyerror("register flag failed");
										}
#line 5390 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 65:
#line 759 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=(yyvsp[0].strval); }
#line 5396 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 66:
#line 760 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=(yyvsp[0].strval); }
#line 5402 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 68:
#line 765 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("avpflag list expected\n"); }
#line 5408 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 772 "core/cfg.y" /* yacc.c:1646  */
    {
		if (register_avpflag((yyvsp[0].strval))==0)
			yyerror("cannot declare avpflag");
	}
#line 5417 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 778 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.debug=(yyvsp[0].intval); }
#line 5423 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 73:
#line 779 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 5429 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 780 "core/cfg.y" /* yacc.c:1646  */
    { dont_fork= ! (yyvsp[0].intval); }
#line 5435 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 781 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5441 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 76:
#line 782 "core/cfg.y" /* yacc.c:1646  */
    { set_fork_delay((yyvsp[0].intval)); }
#line 5447 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 783 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5453 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 78:
#line 784 "core/cfg.y" /* yacc.c:1646  */
    { set_modinit_delay((yyvsp[0].intval)); }
#line 5459 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 785 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5465 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 80:
#line 786 "core/cfg.y" /* yacc.c:1646  */
    { if (!config_check)  /* if set from cmd line, don't overwrite from yyparse()*/
					if(log_stderr == 0) log_stderr=(yyvsp[0].intval);
				   }
#line 5473 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 81:
#line 789 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5479 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 790 "core/cfg.y" /* yacc.c:1646  */
    {
		if ( (i_tmp=str2facility((yyvsp[0].strval)))==-1)
			yyerror("bad facility (see syslog(3) man page)");
		if (!config_check)
			default_core_cfg.log_facility=i_tmp;
	}
#line 5490 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 796 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("ID expected"); }
#line 5496 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 84:
#line 797 "core/cfg.y" /* yacc.c:1646  */
    { log_name=(yyvsp[0].strval); }
#line 5502 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 798 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 5508 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 86:
#line 799 "core/cfg.y" /* yacc.c:1646  */
    { log_color=(yyvsp[0].intval); }
#line 5514 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 800 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5520 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 88:
#line 801 "core/cfg.y" /* yacc.c:1646  */
    { log_prefix_fmt=(yyvsp[0].strval); }
#line 5526 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 89:
#line 802 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 5532 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 90:
#line 803 "core/cfg.y" /* yacc.c:1646  */
    { log_prefix_mode=(yyvsp[0].intval); }
#line 5538 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 91:
#line 804 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5544 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 92:
#line 805 "core/cfg.y" /* yacc.c:1646  */
    { _km_log_engine_type=(yyvsp[0].strval); }
#line 5550 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 93:
#line 806 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 5556 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 94:
#line 807 "core/cfg.y" /* yacc.c:1646  */
    { _km_log_engine_data=(yyvsp[0].strval); }
#line 5562 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 95:
#line 808 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 5568 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 96:
#line 809 "core/cfg.y" /* yacc.c:1646  */
    { _ksr_xavp_via_params.s=(yyvsp[0].strval);
			_ksr_xavp_via_params.len=strlen((yyvsp[0].strval));
		}
#line 5576 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 97:
#line 812 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 5582 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 98:
#line 813 "core/cfg.y" /* yacc.c:1646  */
    { _ksr_xavp_via_params.s=(yyvsp[0].strval);
			_ksr_xavp_via_fields.len=strlen((yyvsp[0].strval));
		}
#line 5590 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 99:
#line 816 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 5596 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 100:
#line 817 "core/cfg.y" /* yacc.c:1646  */
    { received_dns|= ((yyvsp[0].intval))?DO_DNS:0; }
#line 5602 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 101:
#line 818 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5608 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 102:
#line 819 "core/cfg.y" /* yacc.c:1646  */
    { received_dns|= ((yyvsp[0].intval))?DO_REV_DNS:0; }
#line 5614 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 103:
#line 820 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5620 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 104:
#line 821 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_try_ipv6=(yyvsp[0].intval); }
#line 5626 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 105:
#line 822 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5632 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 106:
#line 823 "core/cfg.y" /* yacc.c:1646  */
    { IF_NAPTR(default_core_cfg.dns_try_naptr=(yyvsp[0].intval)); }
#line 5638 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 107:
#line 824 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5644 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 108:
#line 825 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_FAILOVER(default_core_cfg.dns_srv_lb=(yyvsp[0].intval)); }
#line 5650 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 109:
#line 826 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5656 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 110:
#line 827 "core/cfg.y" /* yacc.c:1646  */
    { IF_NAPTR(default_core_cfg.dns_udp_pref=(yyvsp[0].intval));}
#line 5662 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 111:
#line 828 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5668 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 112:
#line 829 "core/cfg.y" /* yacc.c:1646  */
    { IF_NAPTR(default_core_cfg.dns_tcp_pref=(yyvsp[0].intval));}
#line 5674 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 113:
#line 830 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5680 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 114:
#line 831 "core/cfg.y" /* yacc.c:1646  */
    { IF_NAPTR(default_core_cfg.dns_tls_pref=(yyvsp[0].intval));}
#line 5686 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 115:
#line 832 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5692 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 116:
#line 833 "core/cfg.y" /* yacc.c:1646  */
    {
								IF_NAPTR(default_core_cfg.dns_sctp_pref=(yyvsp[0].intval)); }
#line 5699 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 117:
#line 835 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5705 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 118:
#line 836 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_retr_time=(yyvsp[0].intval); }
#line 5711 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 119:
#line 837 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5717 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 120:
#line 838 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_slow_query_ms=(yyvsp[0].intval); }
#line 5723 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 121:
#line 839 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5729 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 122:
#line 840 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_retr_no=(yyvsp[0].intval); }
#line 5735 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 123:
#line 841 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5741 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 124:
#line 842 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_servers_no=(yyvsp[0].intval); }
#line 5747 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 125:
#line 843 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5753 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 126:
#line 844 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_search_list=(yyvsp[0].intval); }
#line 5759 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 127:
#line 845 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5765 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 128:
#line 846 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_search_fmatch=(yyvsp[0].intval); }
#line 5771 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 129:
#line 847 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5777 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 130:
#line 848 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_naptr_ignore_rfc=(yyvsp[0].intval); }
#line 5783 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 131:
#line 849 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5789 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 132:
#line 850 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(dns_cache_init=(yyvsp[0].intval)); }
#line 5795 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 133:
#line 851 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5801 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 134:
#line 852 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.use_dns_cache=(yyvsp[0].intval)); }
#line 5807 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 135:
#line 853 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5813 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 136:
#line 854 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_FAILOVER(default_core_cfg.use_dns_failover=(yyvsp[0].intval));}
#line 5819 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 137:
#line 855 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5825 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 138:
#line 856 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.dns_cache_flags=(yyvsp[0].intval)); }
#line 5831 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 139:
#line 857 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5837 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 140:
#line 858 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.dns_neg_cache_ttl=(yyvsp[0].intval)); }
#line 5843 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 141:
#line 859 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5849 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 142:
#line 860 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.dns_cache_max_ttl=(yyvsp[0].intval)); }
#line 5855 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 143:
#line 861 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5861 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 144:
#line 862 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.dns_cache_min_ttl=(yyvsp[0].intval)); }
#line 5867 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 145:
#line 863 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5873 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 146:
#line 864 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.dns_cache_max_mem=(yyvsp[0].intval)); }
#line 5879 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 147:
#line 865 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5885 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 148:
#line 866 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(dns_timer_interval=(yyvsp[0].intval)); }
#line 5891 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 149:
#line 867 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5897 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 150:
#line 868 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.dns_cache_del_nonexp=(yyvsp[0].intval)); }
#line 5903 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 151:
#line 869 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5909 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 152:
#line 870 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.dns_cache_rec_pref=(yyvsp[0].intval)); }
#line 5915 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 153:
#line 871 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5921 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 154:
#line 872 "core/cfg.y" /* yacc.c:1646  */
    {IF_AUTO_BIND_IPV6(auto_bind_ipv6 = (yyvsp[0].intval));}
#line 5927 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 155:
#line 873 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5933 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 156:
#line 874 "core/cfg.y" /* yacc.c:1646  */
    {sr_bind_ipv6_link_local = (yyvsp[0].intval);}
#line 5939 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 157:
#line 875 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5945 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 158:
#line 876 "core/cfg.y" /* yacc.c:1646  */
    { IF_DST_BLACKLIST(dst_blacklist_init=(yyvsp[0].intval)); }
#line 5951 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 159:
#line 877 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5957 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 160:
#line 878 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_DST_BLACKLIST(default_core_cfg.use_dst_blacklist=(yyvsp[0].intval));
	}
#line 5965 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 161:
#line 881 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5971 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 162:
#line 882 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_DST_BLACKLIST(default_core_cfg.blst_max_mem=(yyvsp[0].intval));
	}
#line 5979 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 163:
#line 885 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5985 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 164:
#line 886 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_DST_BLACKLIST(default_core_cfg.blst_timeout=(yyvsp[0].intval));
	}
#line 5993 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 165:
#line 889 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5999 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 166:
#line 890 "core/cfg.y" /* yacc.c:1646  */
    { IF_DST_BLACKLIST(blst_timer_interval=(yyvsp[0].intval));}
#line 6005 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 167:
#line 891 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6011 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 168:
#line 892 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_DST_BLACKLIST(default_core_cfg.blst_udp_imask=(yyvsp[0].intval));
	}
#line 6019 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 169:
#line 895 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number(flags) expected"); }
#line 6025 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 170:
#line 896 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_DST_BLACKLIST(default_core_cfg.blst_tcp_imask=(yyvsp[0].intval));
	}
#line 6033 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 171:
#line 899 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number(flags) expected"); }
#line 6039 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 172:
#line 900 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_DST_BLACKLIST(default_core_cfg.blst_tls_imask=(yyvsp[0].intval));
	}
#line 6047 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 173:
#line 903 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number(flags) expected"); }
#line 6053 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 174:
#line 904 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_DST_BLACKLIST(default_core_cfg.blst_sctp_imask=(yyvsp[0].intval));
	}
#line 6061 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 175:
#line 907 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number(flags) expected"); }
#line 6067 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 176:
#line 908 "core/cfg.y" /* yacc.c:1646  */
    { _sr_ip_free_bind=(yyvsp[0].intval); }
#line 6073 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 177:
#line 909 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6079 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 178:
#line 910 "core/cfg.y" /* yacc.c:1646  */
    { port_no=(yyvsp[0].intval); }
#line 6085 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 179:
#line 911 "core/cfg.y" /* yacc.c:1646  */
    { maxbuffer=(yyvsp[0].intval); }
#line 6091 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 180:
#line 912 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6097 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 181:
#line 913 "core/cfg.y" /* yacc.c:1646  */
    { sql_buffer_size=(yyvsp[0].intval); }
#line 6103 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 182:
#line 914 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6109 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 183:
#line 915 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6115 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 184:
#line 916 "core/cfg.y" /* yacc.c:1646  */
    { children_no=(yyvsp[0].intval); }
#line 6121 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 185:
#line 917 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6127 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 186:
#line 918 "core/cfg.y" /* yacc.c:1646  */
    { socket_workers=(yyvsp[0].intval); }
#line 6133 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 187:
#line 919 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6139 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 188:
#line 920 "core/cfg.y" /* yacc.c:1646  */
    { async_task_set_workers((yyvsp[0].intval)); }
#line 6145 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 189:
#line 921 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6151 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 190:
#line 922 "core/cfg.y" /* yacc.c:1646  */
    { async_task_set_usleep((yyvsp[0].intval)); }
#line 6157 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 191:
#line 923 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6163 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 192:
#line 924 "core/cfg.y" /* yacc.c:1646  */
    { async_task_set_nonblock((yyvsp[0].intval)); }
#line 6169 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 193:
#line 925 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6175 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 194:
#line 926 "core/cfg.y" /* yacc.c:1646  */
    { check_via=(yyvsp[0].intval); }
#line 6181 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 195:
#line 927 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6187 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 196:
#line 928 "core/cfg.y" /* yacc.c:1646  */
    { phone2tel=(yyvsp[0].intval); }
#line 6193 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 197:
#line 929 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6199 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 198:
#line 930 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.memlog=(yyvsp[0].intval); }
#line 6205 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 199:
#line 931 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6211 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 200:
#line 932 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.memdbg=(yyvsp[0].intval); }
#line 6217 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 201:
#line 933 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6223 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 202:
#line 934 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.mem_summary=(yyvsp[0].intval); }
#line 6229 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 203:
#line 935 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6235 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 204:
#line 936 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.mem_safety=(yyvsp[0].intval); }
#line 6241 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 205:
#line 937 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6247 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 206:
#line 938 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.mem_join=(yyvsp[0].intval); }
#line 6253 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 207:
#line 939 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6259 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 208:
#line 940 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.mem_status_mode=(yyvsp[0].intval); }
#line 6265 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 209:
#line 941 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6271 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 210:
#line 942 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.corelog=(yyvsp[0].intval); }
#line 6277 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 211:
#line 943 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6283 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 212:
#line 944 "core/cfg.y" /* yacc.c:1646  */
    { sip_warning=(yyvsp[0].intval); }
#line 6289 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 213:
#line 945 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6295 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 214:
#line 946 "core/cfg.y" /* yacc.c:1646  */
    { version_table.s=(yyvsp[0].strval);
			version_table.len=strlen(version_table.s);
	}
#line 6303 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 215:
#line 949 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 6309 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 216:
#line 950 "core/cfg.y" /* yacc.c:1646  */
    {
		if (shm_initialized())
			yyerror("user must be before any modparam or the"
					" route blocks");
		else if (user==0)
			user=(yyvsp[0].strval);
	}
#line 6321 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 217:
#line 957 "core/cfg.y" /* yacc.c:1646  */
    {
		if (shm_initialized())
			yyerror("user must be before any modparam or the"
					" route blocks");
		else if (user==0)
			user=(yyvsp[0].strval);
	}
#line 6333 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 218:
#line 964 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 6339 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 219:
#line 965 "core/cfg.y" /* yacc.c:1646  */
    { group=(yyvsp[0].strval); }
#line 6345 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 220:
#line 966 "core/cfg.y" /* yacc.c:1646  */
    { group=(yyvsp[0].strval); }
#line 6351 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 221:
#line 967 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 6357 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 222:
#line 968 "core/cfg.y" /* yacc.c:1646  */
    { chroot_dir=(yyvsp[0].strval); }
#line 6363 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 223:
#line 969 "core/cfg.y" /* yacc.c:1646  */
    { chroot_dir=(yyvsp[0].strval); }
#line 6369 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 224:
#line 970 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 6375 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 225:
#line 971 "core/cfg.y" /* yacc.c:1646  */
    { working_dir=(yyvsp[0].strval); }
#line 6381 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 226:
#line 972 "core/cfg.y" /* yacc.c:1646  */
    { working_dir=(yyvsp[0].strval); }
#line 6387 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 227:
#line 973 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 6393 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 228:
#line 974 "core/cfg.y" /* yacc.c:1646  */
    { runtime_dir=(yyvsp[0].strval); }
#line 6399 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 229:
#line 975 "core/cfg.y" /* yacc.c:1646  */
    { runtime_dir=(yyvsp[0].strval); }
#line 6405 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 230:
#line 976 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 6411 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 231:
#line 977 "core/cfg.y" /* yacc.c:1646  */
    { mhomed=(yyvsp[0].intval); }
#line 6417 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 232:
#line 978 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6423 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 233:
#line 979 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_disable=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6435 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 234:
#line 986 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6441 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 235:
#line 987 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.accept_aliases=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6453 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 236:
#line 994 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6459 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 237:
#line 995 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_accept_unique=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6471 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1002 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6477 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1003 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_connection_match=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6489 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1010 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6495 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1011 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_cfg_children_no=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6507 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1018 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6513 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1019 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.connect_timeout_s=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6525 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1026 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6531 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1027 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.send_timeout=S_TO_TICKS((yyvsp[0].intval));
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6543 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1034 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6549 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1035 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			if ((yyvsp[0].intval)<0)
				tcp_default_cfg.con_lifetime=-1;
			else
				tcp_default_cfg.con_lifetime=S_TO_TICKS((yyvsp[0].intval));
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6564 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1045 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6570 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1046 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_poll_method=get_poll_type((yyvsp[0].strval));
			if (tcp_poll_method==POLL_NONE) {
				LOG(L_CRIT, "bad poll method name:"
						" %s\n, try one of %s.\n",
						(yyvsp[0].strval), poll_support);
				yyerror("bad tcp_poll_method "
						"value");
			}
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6589 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1060 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_poll_method=get_poll_type((yyvsp[0].strval));
			if (tcp_poll_method==POLL_NONE) {
				LOG(L_CRIT, "bad poll method name:"
						" %s\n, try one of %s.\n",
						(yyvsp[0].strval), poll_support);
				yyerror("bad tcp_poll_method "
						"value");
			}
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6608 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1074 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("poll method name expected"); }
#line 6614 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1075 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_max_connections=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6626 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1082 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6632 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1083 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			tls_max_connections=(yyvsp[0].intval);
		#else
			warn("tls support not compiled in");
		#endif
	}
#line 6644 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1090 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6650 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1091 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.no_connect=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6662 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1098 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6668 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1099 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			if (tcp_set_src_addr((yyvsp[0].ipaddr))<0)
				warn("tcp_source_ipv4 failed");
		#else
			warn("tcp support not compiled in");
		#endif
		pkg_free((yyvsp[0].ipaddr));
	}
#line 6682 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1108 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("IPv4 address expected"); }
#line 6688 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1109 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
				if (tcp_set_src_addr((yyvsp[0].ipaddr))<0)
					warn("tcp_source_ipv6 failed");
		#else
			warn("tcp support not compiled in");
		#endif
		pkg_free((yyvsp[0].ipaddr));
	}
#line 6702 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1118 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("IPv6 address expected"); }
#line 6708 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1119 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.fd_cache=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6720 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1126 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6726 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1127 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.async=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6738 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1134 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6744 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1135 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.tcpconn_wq_max=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6756 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1142 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6762 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1143 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.tcp_wq_max=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6774 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1150 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6780 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1151 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.rd_buf_size=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6792 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1158 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6798 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1159 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.wq_blk_size=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6810 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 273:
#line 1166 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6816 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 274:
#line 1167 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.defer_accept=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6828 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 275:
#line 1174 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6834 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 276:
#line 1175 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.delayed_ack=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6846 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 277:
#line 1182 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6852 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 278:
#line 1183 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.syncnt=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6864 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 279:
#line 1190 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6870 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 280:
#line 1191 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.linger2=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6882 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 281:
#line 1198 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6888 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 282:
#line 1199 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.keepalive=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6900 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 283:
#line 1206 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected");}
#line 6906 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 284:
#line 1207 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.keepidle=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6918 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 285:
#line 1214 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6924 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 286:
#line 1215 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.keepintvl=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6936 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 287:
#line 1222 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6942 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 288:
#line 1223 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.keepcnt=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6954 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 289:
#line 1230 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6960 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 290:
#line 1231 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.crlf_ping=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6972 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 291:
#line 1238 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6978 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 292:
#line 1239 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.accept_no_cl=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6990 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 293:
#line 1246 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6996 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 294:
#line 1247 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			ksr_tcp_accept_hep3=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7008 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 295:
#line 1254 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7014 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 296:
#line 1255 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			ksr_tcp_accept_haproxy=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7026 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 297:
#line 1262 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7032 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 298:
#line 1264 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_set_clone_rcvbuf((yyvsp[0].intval));
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7044 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 299:
#line 1271 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7050 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 300:
#line 1272 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
		#ifdef SO_REUSEPORT
			tcp_default_cfg.reuse_port=(yyvsp[0].intval);
		#else
			warn("support for SO_REUSEPORT not compiled in");
		#endif
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7066 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 301:
#line 1283 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7072 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 302:
#line 1284 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			tls_disable=(yyvsp[0].intval);
		#else
			warn("tls support not compiled in");
		#endif
	}
#line 7084 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 303:
#line 1291 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7090 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 304:
#line 1292 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			tls_disable=!((yyvsp[0].intval));
		#else
			warn("tls support not compiled in");
		#endif
	}
#line 7102 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 305:
#line 1299 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7108 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 306:
#line 1300 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_log=(yyvsp[0].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7120 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 307:
#line 1307 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 7126 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 308:
#line 1308 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			tls_port_no=(yyvsp[0].intval);
		#else
			warn("tls support not compiled in");
		#endif
	}
#line 7138 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 309:
#line 1315 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7144 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 310:
#line 1316 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_method=TLS_USE_SSLv23;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7156 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 311:
#line 1323 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_method=TLS_USE_SSLv2;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7168 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 312:
#line 1330 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_method=TLS_USE_SSLv3;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7180 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 313:
#line 1337 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_method=TLS_USE_TLSv1;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7192 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 314:
#line 1344 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			yyerror("SSLv23, SSLv2, SSLv3 or TLSv1 expected");
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7204 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 315:
#line 1351 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_verify_cert=(yyvsp[0].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7216 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 316:
#line 1358 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7222 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 317:
#line 1359 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_require_cert=(yyvsp[0].intval);
		#else
			warn( "tls-in-core support not compiled in");
		#endif
	}
#line 7234 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 318:
#line 1366 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7240 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 319:
#line 1367 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_cert_file=(yyvsp[0].strval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7252 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 320:
#line 1374 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 7258 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 321:
#line 1375 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_pkey_file=(yyvsp[0].strval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7270 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 322:
#line 1382 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 7276 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 323:
#line 1383 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_ca_file=(yyvsp[0].strval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7288 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 324:
#line 1390 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 7294 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 325:
#line 1391 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_handshake_timeout=(yyvsp[0].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7306 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 326:
#line 1398 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7312 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 327:
#line 1399 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_send_timeout=(yyvsp[0].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7324 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 328:
#line 1406 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7330 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 329:
#line 1407 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			sctp_disable=(yyvsp[0].intval);
		#else
			warn("sctp support not compiled in");
		#endif
	}
#line 7342 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 330:
#line 1414 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7348 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 331:
#line 1415 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			sctp_disable=((yyvsp[0].intval)<=1)?!(yyvsp[0].intval):(yyvsp[0].intval);
		#else
			warn("sctp support not compiled in");
		#endif
	}
#line 7360 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 332:
#line 1422 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean or number expected"); }
#line 7366 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 333:
#line 1423 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			sctp_children_no=(yyvsp[0].intval);
		#else
			warn("sctp support not compiled in");
		#endif
	}
#line 7378 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 334:
#line 1430 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7384 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 335:
#line 1431 "core/cfg.y" /* yacc.c:1646  */
    { server_signature=(yyvsp[0].intval); }
#line 7390 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 336:
#line 1432 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7396 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 337:
#line 1433 "core/cfg.y" /* yacc.c:1646  */
    { server_hdr.s=(yyvsp[0].strval);
			server_hdr.len=strlen(server_hdr.s);
	}
#line 7404 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 338:
#line 1436 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 7410 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 339:
#line 1437 "core/cfg.y" /* yacc.c:1646  */
    { user_agent_hdr.s=(yyvsp[0].strval);
			user_agent_hdr.len=strlen(user_agent_hdr.s);
	}
#line 7418 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 340:
#line 1440 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 7424 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 341:
#line 1441 "core/cfg.y" /* yacc.c:1646  */
    { reply_to_via=(yyvsp[0].intval); }
#line 7430 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 342:
#line 1442 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7436 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 343:
#line 1443 "core/cfg.y" /* yacc.c:1646  */
    {
		for(lst_tmp=(yyvsp[0].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_iface(	lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[0].sockid));
	}
#line 7453 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 344:
#line 1455 "core/cfg.y" /* yacc.c:1646  */
    {
		for(lst_tmp=(yyvsp[-2].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_iface_name(lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto, (yyvsp[0].strval),
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[-2].sockid));
	}
#line 7470 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 345:
#line 1467 "core/cfg.y" /* yacc.c:1646  */
    {
		for(lst_tmp=(yyvsp[-4].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_advertise_iface(	lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									(yyvsp[-2].strval), (yyvsp[0].intval),
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[-4].sockid));
	}
#line 7488 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 346:
#line 1480 "core/cfg.y" /* yacc.c:1646  */
    {
		for(lst_tmp=(yyvsp[-6].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_advertise_iface_name(lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									(yyvsp[-4].strval), (yyvsp[-2].intval), (yyvsp[0].strval),
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[-6].sockid));
	}
#line 7506 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 347:
#line 1493 "core/cfg.y" /* yacc.c:1646  */
    {
		for(lst_tmp=(yyvsp[-2].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_advertise_iface(	lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									(yyvsp[0].strval), 0,
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[-2].sockid));
	}
#line 7524 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 348:
#line 1506 "core/cfg.y" /* yacc.c:1646  */
    {
		for(lst_tmp=(yyvsp[-4].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_advertise_iface_name(lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									(yyvsp[-2].strval), 0, (yyvsp[0].strval),
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[-4].sockid));
	}
#line 7542 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 349:
#line 1519 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("ip address, interface name or"
									" hostname expected"); }
#line 7549 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 350:
#line 1521 "core/cfg.y" /* yacc.c:1646  */
    {
		for(lst_tmp=(yyvsp[0].sockid); lst_tmp; lst_tmp=lst_tmp->next){
			add_alias(	lst_tmp->addr_lst->name,
						strlen(lst_tmp->addr_lst->name),
						lst_tmp->port, lst_tmp->proto);
			for (nl_tmp=lst_tmp->addr_lst->next; nl_tmp; nl_tmp=nl_tmp->next)
				add_alias(nl_tmp->name, strlen(nl_tmp->name),
							lst_tmp->port, lst_tmp->proto);
		}
		free_socket_id_lst((yyvsp[0].sockid));
	}
#line 7565 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 351:
#line 1532 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("hostname expected"); }
#line 7571 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 352:
#line 1533 "core/cfg.y" /* yacc.c:1646  */
    { sr_auto_aliases=(yyvsp[0].intval); }
#line 7577 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 353:
#line 1534 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7583 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 354:
#line 1535 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].strval)){
			default_global_address.s=(yyvsp[0].strval);
			default_global_address.len=strlen((yyvsp[0].strval));
		}
	}
#line 7594 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 355:
#line 1541 "core/cfg.y" /* yacc.c:1646  */
    {yyerror("ip address or hostname expected"); }
#line 7600 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 356:
#line 1542 "core/cfg.y" /* yacc.c:1646  */
    {
		tmp=int2str((yyvsp[0].intval), &i_tmp);
		if ((default_global_port.s=pkg_malloc(i_tmp))==0) {
			PKG_MEM_CRITICAL;
			default_global_port.len=0;
		} else {
			default_global_port.len=i_tmp;
			memcpy(default_global_port.s, tmp, default_global_port.len);
		};
	}
#line 7615 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 357:
#line 1552 "core/cfg.y" /* yacc.c:1646  */
    {yyerror("ip address or hostname expected"); }
#line 7621 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 358:
#line 1553 "core/cfg.y" /* yacc.c:1646  */
    { disable_core_dump=(yyvsp[0].intval); }
#line 7627 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 359:
#line 1554 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7633 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 360:
#line 1555 "core/cfg.y" /* yacc.c:1646  */
    { open_files_limit=(yyvsp[0].intval); }
#line 7639 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 361:
#line 1556 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7645 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 362:
#line 1557 "core/cfg.y" /* yacc.c:1646  */
    {
		if (shm_initialized())
			yyerror("shm/shm_mem_size must be before any modparam or the"
					" route blocks");
		else if (shm_mem_size == 0 || shm_mem_size == SHM_MEM_POOL_SIZE)
			shm_mem_size=(yyvsp[0].intval) * 1024 * 1024;
	}
#line 7657 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 363:
#line 1564 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7663 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 364:
#line 1565 "core/cfg.y" /* yacc.c:1646  */
    {
		if (shm_initialized())
			yyerror("shm_force_alloc must be before any modparam or the"
					" route blocks");
		else
			shm_force_alloc=(yyvsp[0].intval);
	}
#line 7675 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 365:
#line 1572 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7681 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 366:
#line 1573 "core/cfg.y" /* yacc.c:1646  */
    { mlock_pages=(yyvsp[0].intval); }
#line 7687 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 367:
#line 1574 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7693 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 368:
#line 1575 "core/cfg.y" /* yacc.c:1646  */
    { real_time=(yyvsp[0].intval); }
#line 7699 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 369:
#line 1576 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7705 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 370:
#line 1577 "core/cfg.y" /* yacc.c:1646  */
    { rt_prio=(yyvsp[0].intval); }
#line 7711 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 371:
#line 1578 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7717 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 372:
#line 1579 "core/cfg.y" /* yacc.c:1646  */
    { rt_policy=(yyvsp[0].intval); }
#line 7723 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 373:
#line 1580 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7729 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 374:
#line 1581 "core/cfg.y" /* yacc.c:1646  */
    { rt_timer1_prio=(yyvsp[0].intval); }
#line 7735 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 375:
#line 1582 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7741 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 376:
#line 1583 "core/cfg.y" /* yacc.c:1646  */
    { rt_timer1_policy=(yyvsp[0].intval); }
#line 7747 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 377:
#line 1584 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7753 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 378:
#line 1585 "core/cfg.y" /* yacc.c:1646  */
    { rt_timer2_prio=(yyvsp[0].intval); }
#line 7759 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 379:
#line 1586 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7765 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 380:
#line 1587 "core/cfg.y" /* yacc.c:1646  */
    { rt_timer2_policy=(yyvsp[0].intval); }
#line 7771 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 381:
#line 1588 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7777 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 382:
#line 1589 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_MCAST
			mcast_loopback=(yyvsp[0].intval);
		#else
			warn("no multicast support compiled in");
		#endif
	}
#line 7789 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 383:
#line 1596 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7795 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 384:
#line 1597 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_MCAST
			mcast_ttl=(yyvsp[0].intval);
		#else
			warn("no multicast support compiled in");
		#endif
	}
#line 7807 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 385:
#line 1604 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7813 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 386:
#line 1605 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_MCAST
			mcast=(yyvsp[0].strval);
		#else
			warn("no multicast support compiled in");
		#endif
	}
#line 7825 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 387:
#line 1612 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_MCAST
			mcast=(yyvsp[0].strval);
		#else
			warn("no multicast support compiled in");
		#endif
	}
#line 7837 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 388:
#line 1619 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 7843 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 389:
#line 1620 "core/cfg.y" /* yacc.c:1646  */
    { tos=(yyvsp[0].intval); }
#line 7849 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 390:
#line 1621 "core/cfg.y" /* yacc.c:1646  */
    { if (strcasecmp((yyvsp[0].strval),"IPTOS_LOWDELAY")) {
			tos=IPTOS_LOWDELAY;
		} else if (strcasecmp((yyvsp[0].strval),"IPTOS_THROUGHPUT")) {
			tos=IPTOS_THROUGHPUT;
		} else if (strcasecmp((yyvsp[0].strval),"IPTOS_RELIABILITY")) {
			tos=IPTOS_RELIABILITY;
#if defined(IPTOS_MINCOST)
		} else if (strcasecmp((yyvsp[0].strval),"IPTOS_MINCOST")) {
			tos=IPTOS_MINCOST;
#endif
#if defined(IPTOS_LOWCOST)
		} else if (strcasecmp((yyvsp[0].strval),"IPTOS_LOWCOST")) {
			tos=IPTOS_LOWCOST;
#endif
		} else {
			yyerror("invalid tos value - allowed: "
				"IPTOS_LOWDELAY,IPTOS_THROUGHPUT,"
				"IPTOS_RELIABILITY"
#if defined(IPTOS_LOWCOST)
				",IPTOS_LOWCOST"
#endif
#if !defined(IPTOS_MINCOST)
				",IPTOS_MINCOST"
#endif
				"\n");
		}
	}
#line 7881 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 391:
#line 1648 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7887 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 392:
#line 1649 "core/cfg.y" /* yacc.c:1646  */
    { pmtu_discovery=(yyvsp[0].intval); }
#line 7893 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 393:
#line 1650 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7899 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 394:
#line 1651 "core/cfg.y" /* yacc.c:1646  */
    { ser_kill_timeout=(yyvsp[0].intval); }
#line 7905 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 395:
#line 1652 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7911 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 396:
#line 1653 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.max_while_loops=(yyvsp[0].intval); }
#line 7917 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 397:
#line 1654 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7923 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 398:
#line 1655 "core/cfg.y" /* yacc.c:1646  */
    { pv_set_buffer_size((yyvsp[0].intval)); }
#line 7929 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 399:
#line 1656 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7935 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 400:
#line 1657 "core/cfg.y" /* yacc.c:1646  */
    { pv_set_buffer_slots((yyvsp[0].intval)); }
#line 7941 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 401:
#line 1658 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7947 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 402:
#line 1659 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.pv_cache_limit=(yyvsp[0].intval); }
#line 7953 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 403:
#line 1660 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7959 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 404:
#line 1661 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.pv_cache_action=(yyvsp[0].intval); }
#line 7965 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 405:
#line 1662 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7971 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 406:
#line 1663 "core/cfg.y" /* yacc.c:1646  */
    { http_reply_parse=(yyvsp[0].intval); }
#line 7977 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 407:
#line 1664 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7983 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 408:
#line 1665 "core/cfg.y" /* yacc.c:1646  */
    { ksr_verbose_startup=(yyvsp[0].intval); }
#line 7989 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 409:
#line 1666 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7995 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 410:
#line 1667 "core/cfg.y" /* yacc.c:1646  */
    { ksr_route_locks_size=(yyvsp[0].intval); }
#line 8001 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 411:
#line 1668 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8007 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 412:
#line 1669 "core/cfg.y" /* yacc.c:1646  */
    { server_id=(yyvsp[0].intval); }
#line 8013 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 413:
#line 1670 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8019 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 414:
#line 1671 "core/cfg.y" /* yacc.c:1646  */
    {
			kemi_onsend_route_callback.s = (yyvsp[0].strval);
			kemi_onsend_route_callback.len = strlen((yyvsp[0].strval));
			if(kemi_onsend_route_callback.len==4
					&& strcasecmp(kemi_onsend_route_callback.s, "none")==0) {
				kemi_onsend_route_callback.s = "";
				kemi_onsend_route_callback.len = 0;
			}
		}
#line 8033 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 415:
#line 1680 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 8039 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 416:
#line 1681 "core/cfg.y" /* yacc.c:1646  */
    {
			kemi_reply_route_callback.s = (yyvsp[0].strval);
			kemi_reply_route_callback.len = strlen((yyvsp[0].strval));
			if(kemi_reply_route_callback.len==4
					&& strcasecmp(kemi_reply_route_callback.s, "none")==0) {
				kemi_reply_route_callback.s = "";
				kemi_reply_route_callback.len = 0;
			}
		}
#line 8053 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 417:
#line 1690 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 8059 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 418:
#line 1691 "core/cfg.y" /* yacc.c:1646  */
    {
			kemi_event_route_callback.s = (yyvsp[0].strval);
			kemi_event_route_callback.len = strlen((yyvsp[0].strval));
			if(kemi_event_route_callback.len==4
					&& strcasecmp(kemi_event_route_callback.s, "none")==0) {
				kemi_event_route_callback.s = "";
				kemi_event_route_callback.len = 0;
			}
		}
#line 8073 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 419:
#line 1700 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 8079 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 420:
#line 1701 "core/cfg.y" /* yacc.c:1646  */
    {
			kemi_received_route_callback.s = (yyvsp[0].strval);
			kemi_received_route_callback.len = strlen((yyvsp[0].strval));
			if(kemi_received_route_callback.len==4
					&& strcasecmp(kemi_received_route_callback.s, "none")==0) {
				kemi_received_route_callback.s = "";
				kemi_received_route_callback.len = 0;
			}
		}
#line 8093 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 421:
#line 1710 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 8099 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 422:
#line 1711 "core/cfg.y" /* yacc.c:1646  */
    { ksr_evrt_received_mode=(yyvsp[0].intval); }
#line 8105 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 423:
#line 1712 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 8111 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 424:
#line 1713 "core/cfg.y" /* yacc.c:1646  */
    { set_max_recursive_level((yyvsp[0].intval)); }
#line 8117 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 425:
#line 1714 "core/cfg.y" /* yacc.c:1646  */
    { sr_dst_max_branches = (yyvsp[0].intval); }
#line 8123 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 426:
#line 1715 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.latency_log=(yyvsp[0].intval); }
#line 8129 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 427:
#line 1716 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 8135 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 428:
#line 1717 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.latency_cfg_log=(yyvsp[0].intval); }
#line 8141 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 429:
#line 1718 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 8147 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 430:
#line 1719 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.latency_limit_db=(yyvsp[0].intval); }
#line 8153 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 431:
#line 1720 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 8159 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 432:
#line 1721 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.latency_limit_action=(yyvsp[0].intval); }
#line 8165 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 433:
#line 1722 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 8171 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 434:
#line 1723 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.latency_limit_cfg=(yyvsp[0].intval); }
#line 8177 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 435:
#line 1724 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 8183 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 436:
#line 1725 "core/cfg.y" /* yacc.c:1646  */
    { sr_msg_time=(yyvsp[0].intval); }
#line 8189 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 437:
#line 1726 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 8195 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 438:
#line 1727 "core/cfg.y" /* yacc.c:1646  */
    { onsend_route_reply=(yyvsp[0].intval); }
#line 8201 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 439:
#line 1728 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 8207 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 440:
#line 1729 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.udp_mtu=(yyvsp[0].intval); }
#line 8213 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 441:
#line 1730 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8219 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 442:
#line 1732 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.force_rport=(yyvsp[0].intval); fix_global_req_flags(0, 0); }
#line 8225 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 443:
#line 1733 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 8231 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 444:
#line 1735 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.udp_mtu_try_proto=(yyvsp[0].intval); fix_global_req_flags(0, 0); }
#line 8237 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 445:
#line 1737 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("TCP, TLS, SCTP or UDP expected"); }
#line 8243 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 446:
#line 1738 "core/cfg.y" /* yacc.c:1646  */
    { IF_RAW_SOCKS(default_core_cfg.udp4_raw=(yyvsp[0].intval)); }
#line 8249 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 447:
#line 1739 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8255 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 448:
#line 1740 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_RAW_SOCKS(default_core_cfg.udp4_raw_mtu=(yyvsp[0].intval));
	}
#line 8263 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 449:
#line 1743 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8269 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 450:
#line 1744 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_RAW_SOCKS(default_core_cfg.udp4_raw_ttl=(yyvsp[0].intval));
	}
#line 8277 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 451:
#line 1747 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8283 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 453:
#line 1749 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("unknown config variable"); }
#line 8289 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 455:
#line 1753 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)="default" ; }
#line 8295 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 457:
#line 1757 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)="default" ; }
#line 8301 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 458:
#line 1758 "core/cfg.y" /* yacc.c:1646  */
    {
		yyerror("cfg var field name - use of number or reserved token not allowed: %s",
				yy_number_str);
		YYERROR;
	}
#line 8311 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 459:
#line 1766 "core/cfg.y" /* yacc.c:1646  */
    {
		if (cfg_declare_int((yyvsp[-4].strval), (yyvsp[-2].strval), (yyvsp[0].intval), 0, 0, NULL)) {
			yyerror("variable cannot be declared");
		}
	}
#line 8321 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 460:
#line 1771 "core/cfg.y" /* yacc.c:1646  */
    {
		if (cfg_declare_str((yyvsp[-4].strval), (yyvsp[-2].strval), (yyvsp[0].strval), NULL)) {
			yyerror("variable cannot be declared");
		}
	}
#line 8331 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 461:
#line 1776 "core/cfg.y" /* yacc.c:1646  */
    {
		if (cfg_declare_int((yyvsp[-6].strval), (yyvsp[-4].strval), (yyvsp[-2].intval), 0, 0, (yyvsp[0].strval))) {
			yyerror("variable cannot be declared");
		}
	}
#line 8341 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 462:
#line 1781 "core/cfg.y" /* yacc.c:1646  */
    {
		if (cfg_declare_str((yyvsp[-6].strval), (yyvsp[-4].strval), (yyvsp[-2].strval), (yyvsp[0].strval))) {
			yyerror("variable cannot be declared");
		}
	}
#line 8351 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 463:
#line 1786 "core/cfg.y" /* yacc.c:1646  */
    {
		yyerror("number or string expected");
	}
#line 8359 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 464:
#line 1789 "core/cfg.y" /* yacc.c:1646  */
    {
		if (cfg_ginst_var_int((yyvsp[-7].strval), (yyvsp[-5].intval), (yyvsp[-2].strval), (yyvsp[0].intval))) {
			yyerror("variable cannot be added to the group instance");
		}
	}
#line 8369 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 465:
#line 1794 "core/cfg.y" /* yacc.c:1646  */
    {
		if (cfg_ginst_var_string((yyvsp[-7].strval), (yyvsp[-5].intval), (yyvsp[-2].strval), (yyvsp[0].strval))) {
			yyerror("variable cannot be added to the group instance");
		}
	}
#line 8379 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 466:
#line 1802 "core/cfg.y" /* yacc.c:1646  */
    {
		LM_DBG("loading module %s\n", (yyvsp[0].strval));
			if (load_module((yyvsp[0].strval))!=0) {
				yyerror("failed to load module");
			}
	}
#line 8390 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 467:
#line 1808 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 8396 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 468:
#line 1809 "core/cfg.y" /* yacc.c:1646  */
    {
		if(mods_dir_cmd==0) {
			LM_DBG("loading modules under %s\n", (yyvsp[0].strval));
			printf("loading modules under config path: %s\n", (yyvsp[0].strval));
			mods_dir = (yyvsp[0].strval);
		} else {
			LM_DBG("ignoring mod path given in config: %s\n", (yyvsp[0].strval));
			printf("loading modules under command line path: %s\n", mods_dir);
		}
	}
#line 8411 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 469:
#line 1819 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 8417 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 470:
#line 1820 "core/cfg.y" /* yacc.c:1646  */
    {
		if(mods_dir_cmd==0) {
			LM_DBG("loading modules under %s\n", (yyvsp[0].strval));
			printf("loading modules under config path: %s\n", (yyvsp[0].strval));
			mods_dir = (yyvsp[0].strval);
		} else {
			LM_DBG("ignoring mod path given in config: %s\n", (yyvsp[0].strval));
			printf("loading modules under command line path: %s\n", mods_dir);
		}
	}
#line 8432 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 471:
#line 1830 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 8438 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 472:
#line 1831 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), PARAM_STRING, (yyvsp[-1].strval)) != 0) {
			 yyerror("Can't set module parameter");
		}
	}
#line 8452 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 473:
#line 1840 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), PARAM_INT, (void*)(yyvsp[-1].intval)) != 0) {
			 yyerror("Can't set module parameter");
		}
	}
#line 8466 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 474:
#line 1849 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("Invalid arguments"); }
#line 8472 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 475:
#line 1850 "core/cfg.y" /* yacc.c:1646  */
    {
		if(sr_kemi_eng_setz((yyvsp[0].strval), NULL)) {
			yyerror("Can't set config routing engine");
			YYABORT;
		}
	}
#line 8483 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 476:
#line 1856 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 8489 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 477:
#line 1857 "core/cfg.y" /* yacc.c:1646  */
    {
		if(sr_kemi_eng_setz((yyvsp[0].strval), NULL)) {
			yyerror("Can't set config routing engine");
			YYABORT;
		}
	}
#line 8500 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 478:
#line 1863 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 8506 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 479:
#line 1867 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 8512 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 480:
#line 1868 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 8518 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 481:
#line 1871 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
		if ((yyval.ipaddr)==0) {
			PKG_MEM_CRITICAL;
		} else {
			memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
			(yyval.ipaddr)->af=AF_INET;
			(yyval.ipaddr)->len=4;
			if (((yyvsp[-6].intval)>255) || ((yyvsp[-6].intval)<0) ||
				((yyvsp[-4].intval)>255) || ((yyvsp[-4].intval)<0) ||
				((yyvsp[-2].intval)>255) || ((yyvsp[-2].intval)<0) ||
				((yyvsp[0].intval)>255) || ((yyvsp[0].intval)<0)) {
				yyerror("invalid ipv4 address");
				(yyval.ipaddr)->u.addr32[0]=0;
				/* $$=0; */
			} else {
				(yyval.ipaddr)->u.addr[0]=(yyvsp[-6].intval);
				(yyval.ipaddr)->u.addr[1]=(yyvsp[-4].intval);
				(yyval.ipaddr)->u.addr[2]=(yyvsp[-2].intval);
				(yyval.ipaddr)->u.addr[3]=(yyvsp[0].intval);
				/*
				$$=htonl( ($1<<24)|
				($3<<16)| ($5<<8)|$7 );
				*/
			}
		}
	}
#line 8550 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 482:
#line 1900 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
		if ((yyval.ipaddr)==0) {
			PKG_MEM_CRITICAL;
		} else {
			memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
			(yyval.ipaddr)->af=AF_INET6;
			(yyval.ipaddr)->len=16;
			if (inet_pton(AF_INET6, (yyvsp[0].strval), (yyval.ipaddr)->u.addr)<=0) {
				yyerror("bad ipv6 address");
			}
		}
	}
#line 8568 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 483:
#line 1915 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 8574 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 484:
#line 1916 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.ipaddr)=(yyvsp[-1].ipaddr); }
#line 8580 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 485:
#line 1920 "core/cfg.y" /* yacc.c:1646  */
    {
					tmp=int2str((yyvsp[0].intval), &i_tmp);
					if (((yyval.strval)=pkg_malloc(i_tmp+1))==0) {
						yyerror("out of  memory");
						YYABORT;
					} else {
						memcpy((yyval.strval), tmp, i_tmp);
						(yyval.strval)[i_tmp]=0;
					}
					routename = tmp;
						}
#line 8596 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 486:
#line 1931 "core/cfg.y" /* yacc.c:1646  */
    { routename = (yyvsp[0].strval); (yyval.strval)=(yyvsp[0].strval); }
#line 8602 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 487:
#line 1932 "core/cfg.y" /* yacc.c:1646  */
    { routename = (yyvsp[0].strval); (yyval.strval)=(yyvsp[0].strval); }
#line 8608 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 488:
#line 1936 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 8614 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 489:
#line 1937 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 8620 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 490:
#line 1941 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		push((yyvsp[-1].action), &main_rt.rlist[DEFAULT_RT]);
	}
#line 8632 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 491:
#line 1948 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		i_tmp=route_get(&main_rt, (yyvsp[-4].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (main_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[-1].action), &main_rt.rlist[i_tmp]);
	}
#line 8653 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 492:
#line 1964 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid  route  statement"); }
#line 8659 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 493:
#line 1965 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid  request_route  statement"); }
#line 8665 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 494:
#line 1968 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 8671 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 495:
#line 1971 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		push((yyvsp[-1].action), &failure_rt.rlist[DEFAULT_RT]);
	}
#line 8683 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 496:
#line 1978 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		i_tmp=route_get(&failure_rt, (yyvsp[-4].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (failure_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[-1].action), &failure_rt.rlist[i_tmp]);
	}
#line 8704 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 497:
#line 1994 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid failure_route statement"); }
#line 8710 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 498:
#line 1998 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 8716 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 499:
#line 1999 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 8722 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 500:
#line 2004 "core/cfg.y" /* yacc.c:1646  */
    {rt=CORE_ONREPLY_ROUTE;}
#line 8728 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 501:
#line 2004 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		push((yyvsp[-1].action), &onreply_rt.rlist[DEFAULT_RT]);
	}
#line 8740 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 502:
#line 2011 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid onreply_route statement"); }
#line 8746 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 503:
#line 2012 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid onreply_route statement"); }
#line 8752 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 504:
#line 2014 "core/cfg.y" /* yacc.c:1646  */
    {rt=(*(yyvsp[-1].strval)=='0' && (yyvsp[-1].strval)[1]==0)?CORE_ONREPLY_ROUTE:TM_ONREPLY_ROUTE;}
#line 8758 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 505:
#line 2015 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		if (*(yyvsp[-5].strval)=='0' && (yyvsp[-5].strval)[1]==0){
			/* onreply_route[0] {} is equivalent with onreply_route {}*/
			push((yyvsp[-1].action), &onreply_rt.rlist[DEFAULT_RT]);
		}else{
			i_tmp=route_get(&onreply_rt, (yyvsp[-5].strval));
			if (i_tmp==-1){
				yyerror("internal error");
				YYABORT;
			}
			if (onreply_rt.rlist[i_tmp]){
				yyerror("duplicate route");
				YYABORT;
			}
			push((yyvsp[-1].action), &onreply_rt.rlist[i_tmp]);
		}
	}
#line 8784 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 506:
#line 2036 "core/cfg.y" /* yacc.c:1646  */
    {
		yyerror("invalid onreply_route statement");
	}
#line 8792 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 507:
#line 2041 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 8798 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 508:
#line 2044 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		push((yyvsp[-1].action), &branch_rt.rlist[DEFAULT_RT]);
	}
#line 8810 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 509:
#line 2051 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		i_tmp=route_get(&branch_rt, (yyvsp[-4].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (branch_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[-1].action), &branch_rt.rlist[i_tmp]);
	}
#line 8831 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 510:
#line 2067 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid branch_route statement"); }
#line 8837 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 511:
#line 2070 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 8843 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 512:
#line 2073 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		push((yyvsp[-1].action), &onsend_rt.rlist[DEFAULT_RT]);
	}
#line 8855 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 513:
#line 2080 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		i_tmp=route_get(&onsend_rt, (yyvsp[-4].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (onsend_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[-1].action), &onsend_rt.rlist[i_tmp]);
	}
#line 8876 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 514:
#line 2096 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid onsend_route statement"); }
#line 8882 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 515:
#line 2099 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 8888 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 516:
#line 2102 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		i_tmp=route_get(&event_rt, (yyvsp[-4].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (event_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[-1].action), &event_rt.rlist[i_tmp]);
	}
#line 8909 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 517:
#line 2119 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid event_route statement"); }
#line 8915 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 518:
#line 2122 "core/cfg.y" /* yacc.c:1646  */
    { if(pp_subst_add((yyvsp[0].strval))<0) YYERROR; }
#line 8921 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 519:
#line 2123 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid subst preprocess statement"); }
#line 8927 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 520:
#line 2124 "core/cfg.y" /* yacc.c:1646  */
    { if(pp_substdef_add((yyvsp[0].strval), 0)<0) YYERROR; }
#line 8933 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 521:
#line 2125 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid substdef preprocess statement"); }
#line 8939 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 522:
#line 2126 "core/cfg.y" /* yacc.c:1646  */
    { if(pp_substdef_add((yyvsp[0].strval), 1)<0) YYERROR; }
#line 8945 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 523:
#line 2127 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid substdefs preprocess statement"); }
#line 8951 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 524:
#line 2149 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=EQUAL_OP; }
#line 8957 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 525:
#line 2150 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=DIFF_OP; }
#line 8963 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 526:
#line 2151 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=EQUAL_OP; }
#line 8969 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 527:
#line 2152 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=DIFF_OP; }
#line 8975 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 528:
#line 2155 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=GT_OP; }
#line 8981 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 529:
#line 2156 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=LT_OP; }
#line 8987 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 530:
#line 2157 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=GTE_OP; }
#line 8993 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 531:
#line 2158 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=LTE_OP; }
#line 8999 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 532:
#line 2161 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=(yyvsp[0].intval); }
#line 9005 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 533:
#line 2162 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=MATCH_OP; }
#line 9011 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 534:
#line 2168 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_EQ_OP; }
#line 9017 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 535:
#line 2169 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_DIFF_OP; }
#line 9023 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 536:
#line 2170 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_IEQ_OP; }
#line 9029 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 537:
#line 2171 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_IDIFF_OP; }
#line 9035 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 538:
#line 2172 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_STREQ_OP; }
#line 9041 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 539:
#line 2173 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_STRDIFF_OP; }
#line 9047 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 540:
#line 2174 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_MATCH_OP; }
#line 9053 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 541:
#line 2177 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_GT_OP; }
#line 9059 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 542:
#line 2178 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_LT_OP; }
#line 9065 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 543:
#line 2179 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_GTE_OP; }
#line 9071 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 544:
#line 2180 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_LTE_OP; }
#line 9077 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 545:
#line 2187 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=URI_O;}
#line 9083 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 546:
#line 2188 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=FROM_URI_O;}
#line 9089 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 547:
#line 2189 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=TO_URI_O;}
#line 9095 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 548:
#line 2196 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=SNDPORT_O; }
#line 9101 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 549:
#line 2197 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=TOPORT_O; }
#line 9107 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 550:
#line 2198 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=SNDAF_O; }
#line 9113 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 551:
#line 2202 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=SRCPORT_O; }
#line 9119 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 552:
#line 2203 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=DSTPORT_O; }
#line 9125 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 553:
#line 2204 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=AF_O; }
#line 9131 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 554:
#line 2205 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=MSGLEN_O; }
#line 9137 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 556:
#line 2211 "core/cfg.y" /* yacc.c:1646  */
    { onsend_check("snd_ip"); (yyval.intval)=SNDIP_O; }
#line 9143 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 557:
#line 2212 "core/cfg.y" /* yacc.c:1646  */
    { onsend_check("to_ip");  (yyval.intval)=TOIP_O; }
#line 9149 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 558:
#line 2215 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=SRCIP_O; }
#line 9155 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 559:
#line 2216 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=DSTIP_O; }
#line 9161 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 561:
#line 2224 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.expr)= mk_elem((yyvsp[-1].intval), METHOD_O, 0, RVE_ST, (yyvsp[0].rv_expr));}
#line 9167 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 562:
#line 2226 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.expr) = mk_elem((yyvsp[-1].intval), METHOD_O, 0, STRING_ST,(yyvsp[0].strval)); }
#line 9173 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 563:
#line 2227 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("string expected"); }
#line 9179 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 564:
#line 2229 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("invalid operator,== , !=, or =~ expected"); }
#line 9185 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 565:
#line 2231 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.expr) = mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, RVE_ST, (yyvsp[0].rv_expr)); }
#line 9191 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 566:
#line 2233 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, MYSELF_ST, 0); }
#line 9197 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 567:
#line 2235 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("string or MYSELF expected"); }
#line 9203 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 568:
#line 2237 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("invalid operator, == , != or =~ expected"); }
#line 9209 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 569:
#line 2238 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, RVE_ST, (yyvsp[0].rv_expr) ); }
#line 9215 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 570:
#line 2240 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, RVE_ST, (yyvsp[0].rv_expr) ); }
#line 9221 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 571:
#line 2241 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("number expected"); }
#line 9227 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 572:
#line 2242 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("number expected"); }
#line 9233 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 573:
#line 2243 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("==, !=, <,>, >= or <=  expected"); }
#line 9239 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 574:
#line 2245 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), PROTO_O, 0, NUMBER_ST, (void*)(yyvsp[0].intval) ); }
#line 9245 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 575:
#line 2247 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), PROTO_O, 0, RVE_ST, (yyvsp[0].rv_expr) ); }
#line 9251 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 576:
#line 2249 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("protocol expected (udp, tcp, tls, sctp, ws, or wss)"); }
#line 9257 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 577:
#line 2251 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), SNDPROTO_O, 0, NUMBER_ST, (void*)(yyvsp[0].intval) ); }
#line 9263 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 578:
#line 2253 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), SNDPROTO_O, 0, RVE_ST, (yyvsp[0].rv_expr) ); }
#line 9269 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 579:
#line 2255 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("protocol expected (udp, tcp, tls, sctp, ws, or wss)"); }
#line 9275 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 580:
#line 2256 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, NET_ST, (yyvsp[0].ipnet)); }
#line 9281 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 581:
#line 2257 "core/cfg.y" /* yacc.c:1646  */
    {
			s_tmp.s=0;
			(yyval.expr)=0;
			if (rve_is_constant((yyvsp[0].rv_expr))){
				i_tmp=rve_guess_type((yyvsp[0].rv_expr));
				if (i_tmp==RV_INT)
					yyerror("string expected");
				else if (i_tmp==RV_STR){
					if (((rval_tmp=rval_expr_eval(0, 0, (yyvsp[0].rv_expr)))==0) ||
								(rval_get_str(0, 0, &s_tmp, rval_tmp, 0)<0)){
						rval_destroy(rval_tmp);
						yyerror("bad rvalue expression");
					}else{
						rval_destroy(rval_tmp);
					}
				}else{
					yyerror("BUG: unexpected dynamic type");
				}
			}else{
					/* warn("non constant rvalue in ip comparison") */;
			}
			if (s_tmp.s){
				ip_tmp=str2ip(&s_tmp);
				if (ip_tmp==0)
					ip_tmp=str2ip6(&s_tmp);
				pkg_free(s_tmp.s);
				if (ip_tmp) {
					(yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, NET_ST,
								mk_new_net_bitlen(ip_tmp, ip_tmp->len*8) );
				} else {
					(yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, RVE_ST, (yyvsp[0].rv_expr));
				}
			}else{
				(yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, RVE_ST, (yyvsp[0].rv_expr));
			}
		}
#line 9322 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 582:
#line 2294 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, STRING_ST, (yyvsp[0].strval)); }
#line 9328 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 583:
#line 2296 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, MYSELF_ST, 0); }
#line 9334 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 584:
#line 2298 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror( "ip address or hostname expected" ); }
#line 9340 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 585:
#line 2300 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("invalid operator, ==, != or =~ expected");}
#line 9346 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 586:
#line 2303 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[0].intval), 0, MYSELF_ST, 0); }
#line 9352 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 587:
#line 2305 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[0].intval), 0, MYSELF_ST, 0); }
#line 9358 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 588:
#line 2307 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("URI, SRCIP or DSTIP expected"); }
#line 9364 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 589:
#line 2308 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror ("invalid operator, == or != expected"); }
#line 9370 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 590:
#line 2312 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.ipnet)=mk_new_net((yyvsp[-2].ipaddr), (yyvsp[0].ipaddr)); }
#line 9376 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 591:
#line 2313 "core/cfg.y" /* yacc.c:1646  */
    {
		if (((yyvsp[0].intval)<0) || ((yyvsp[0].intval)>(yyvsp[-2].ipaddr)->len*8)) {
			yyerror("invalid bit number in netmask");
			(yyval.ipnet)=0;
		} else {
			(yyval.ipnet)=mk_new_net_bitlen((yyvsp[-2].ipaddr), (yyvsp[0].intval));
		/*
			$$=mk_new_net($1, htonl( ($3)?~( (1<<(32-$3))-1 ):0 ) );
		*/
		}
	}
#line 9392 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 592:
#line 2324 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.ipnet)=mk_new_net_bitlen((yyvsp[0].ipaddr), (yyvsp[0].ipaddr)->len*8); }
#line 9398 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 593:
#line 2325 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.ipnet)=0; yyerror("netmask (eg:255.0.0.0 or 8) expected"); }
#line 9404 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 594:
#line 2329 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=(yyvsp[0].strval); }
#line 9410 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 595:
#line 2330 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-2].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
			if ((yyval.strval)==0) {
				PKG_MEM_CRITICAL;
			} else {
				memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))]='.';
				memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
			}
			pkg_free((yyvsp[-2].strval));
		}
		if ((yyvsp[0].strval)) pkg_free((yyvsp[0].strval));
	}
#line 9430 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 596:
#line 2345 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-2].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
			if ((yyval.strval)==0) {
				PKG_MEM_CRITICAL;
			} else {
				memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))]='-';
				memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
			}
			pkg_free((yyvsp[-2].strval));
		}
		if ((yyvsp[0].strval)) pkg_free((yyvsp[0].strval));
	}
#line 9450 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 597:
#line 2360 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=0; pkg_free((yyvsp[-2].strval)); yyerror("invalid hostname"); }
#line 9456 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 598:
#line 2361 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=0; pkg_free((yyvsp[-2].strval)); yyerror("invalid hostname"); }
#line 9462 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 601:
#line 2366 "core/cfg.y" /* yacc.c:1646  */
    {
			/* get string version */
			(yyval.strval)=pkg_malloc(strlen(yy_number_str)+1);
			if ((yyval.strval)==0) {
				PKG_MEM_ERROR;
			} else {
				strcpy((yyval.strval), yy_number_str);
			}
		}
#line 9476 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 602:
#line 2378 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=(yyvsp[0].strval); }
#line 9482 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 603:
#line 2379 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-2].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
			if ((yyval.strval)==0) {
				PKG_MEM_CRITICAL;
			} else {
				memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))]='.';
				memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
			}
			pkg_free((yyvsp[-2].strval));
		}
		if ((yyvsp[0].strval)) pkg_free((yyvsp[0].strval));
	}
#line 9502 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 604:
#line 2394 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-2].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
			if ((yyval.strval)==0) {
				PKG_MEM_CRITICAL;
			} else {
				memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))]='-';
				memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
			}
			pkg_free((yyvsp[-2].strval));
		}
		if ((yyvsp[0].strval)) pkg_free((yyvsp[0].strval));
	}
#line 9522 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 605:
#line 2409 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=0; pkg_free((yyvsp[-2].strval));
								yyerror("invalid host or interface name"); }
#line 9529 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 606:
#line 2411 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=0; pkg_free((yyvsp[-2].strval));
								yyerror("invalid host or interface name"); }
#line 9536 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 607:
#line 2418 "core/cfg.y" /* yacc.c:1646  */
    {
		/* check if allowed */
		if ((yyvsp[0].action) && rt==ONSEND_ROUTE) {
			switch((yyvsp[0].action)->type) {
				case DROP_T:
				case LOG_T:
				case SETFLAG_T:
				case RESETFLAG_T:
				case ISFLAGSET_T:
				case IF_T:
				case MODULE0_T:
				case MODULE1_T:
				case MODULE2_T:
				case MODULE3_T:
				case MODULE4_T:
				case MODULE5_T:
				case MODULE6_T:
				case MODULEX_T:
				case SET_FWD_NO_CONNECT_T:
				case SET_RPL_NO_CONNECT_T:
				case SET_FWD_CLOSE_T:
				case SET_RPL_CLOSE_T:
					(yyval.action)=(yyvsp[0].action);
					break;
				default:
					(yyval.action)=0;
					yyerror("command not allowed in onsend_route\n");
			}
		} else {
			(yyval.action)=(yyvsp[0].action);
		}
	}
#line 9573 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 608:
#line 2460 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[0].action); }
#line 9579 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 609:
#line 2461 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[-1].action); }
#line 9585 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 610:
#line 2464 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 9591 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 611:
#line 2465 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 9597 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 612:
#line 2466 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad command"); }
#line 9603 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 613:
#line 2469 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[-1].action);}
#line 9609 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 614:
#line 2470 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 9615 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 615:
#line 2471 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 9621 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 616:
#line 2472 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[0].action); }
#line 9627 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 617:
#line 2473 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[-1].action); }
#line 9633 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 618:
#line 2474 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[-1].action);}
#line 9639 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 619:
#line 2475 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0;}
#line 9645 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 620:
#line 2476 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad command: missing ';'?"); }
#line 9651 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 621:
#line 2479 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-1].rv_expr) && rval_expr_int_check((yyvsp[-1].rv_expr))>=0){
			warn_ct_rve((yyvsp[-1].rv_expr), "if");
			(yyval.action)=mk_action( IF_T, 3, RVE_ST, (yyvsp[-1].rv_expr), ACTIONS_ST, (yyvsp[0].action), NOSUBTYPE, 0);
			set_cfg_pos((yyval.action));
		}else
			YYERROR;
	}
#line 9664 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 622:
#line 2487 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-3].rv_expr) && rval_expr_int_check((yyvsp[-3].rv_expr))>=0){
			warn_ct_rve((yyvsp[-3].rv_expr), "if");
			(yyval.action)=mk_action( IF_T, 3, RVE_ST, (yyvsp[-3].rv_expr), ACTIONS_ST, (yyvsp[-2].action), ACTIONS_ST, (yyvsp[0].action));
			set_cfg_pos((yyval.action));
		}else
			YYERROR;
	}
#line 9677 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 623:
#line 2497 "core/cfg.y" /* yacc.c:1646  */
    {
			(yyval.rv_expr)=0;
			if ((yyvsp[0].rv_expr) && !rve_is_constant((yyvsp[0].rv_expr))){
				yyerror("constant expected");
				YYERROR;
			/*
			} else if ($1 &&
						!rve_check_type((enum rval_type*)&i_tmp, $1, 0, 0 ,0)){
				yyerror("invalid expression (bad type)");
			}else if ($1 && i_tmp!=RV_INT){
				yyerror("invalid expression type, int expected\n");
			*/
			}else
				(yyval.rv_expr)=(yyvsp[0].rv_expr);
		}
#line 9697 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 624:
#line 2514 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.case_stms)=0;
		if ((yyvsp[-2].rv_expr)==0) { yyerror ("bad case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[-2].rv_expr), 0, (yyvsp[0].action), &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 9709 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 625:
#line 2521 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.case_stms)=0;
		if ((yyvsp[-2].rv_expr)==0) { yyerror ("bad case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[-2].rv_expr), 1, (yyvsp[0].action), &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 9721 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 626:
#line 2528 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.case_stms)=0;
		if ((yyvsp[-1].rv_expr)==0) { yyerror ("bad case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[-1].rv_expr), 0, 0, &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 9733 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 627:
#line 2535 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.case_stms)=0;
		if ((yyvsp[-1].rv_expr)==0) { yyerror ("bad regex case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[-1].rv_expr), 1, 0, &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 9745 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 628:
#line 2542 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((((yyval.case_stms)=mk_case_stm(0, 0, (yyvsp[0].action), &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 9755 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 629:
#line 2547 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((((yyval.case_stms)=mk_case_stm(0, 0, 0, &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 9765 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 630:
#line 2552 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.case_stms)=0; yyerror("bad case label"); }
#line 9771 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 631:
#line 2553 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.case_stms)=0; yyerror("bad case regex label"); }
#line 9777 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 632:
#line 2554 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.case_stms)=0; yyerror("bad case label"); }
#line 9783 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 633:
#line 2555 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.case_stms)=0; yyerror("bad case regex label"); }
#line 9789 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 634:
#line 2556 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.case_stms)=0; yyerror ("bad case body"); }
#line 9795 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 635:
#line 2559 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.case_stms)=(yyvsp[-1].case_stms);
		if ((yyvsp[0].case_stms)==0) yyerror ("bad case");
		if ((yyval.case_stms)){
			*((yyval.case_stms)->append)=(yyvsp[0].case_stms);
			if (*((yyval.case_stms)->append)!=0)
				(yyval.case_stms)->append=&((*((yyval.case_stms)->append))->next);
		}
	}
#line 9809 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 636:
#line 2568 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.case_stms)=(yyvsp[0].case_stms);
		if ((yyvsp[0].case_stms)==0) yyerror ("bad case");
		else (yyval.case_stms)->append=&((yyval.case_stms)->next);
	}
#line 9819 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 637:
#line 2575 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=0;
		if ((yyvsp[-3].rv_expr)==0){
			yyerror("bad expression in switch(...)");
			YYERROR;
		}else if ((yyvsp[-1].case_stms)==0){
			yyerror ("bad switch body");
			YYERROR;
		}else if (case_check_default((yyvsp[-1].case_stms))!=0){
			yyerror_at(&(yyvsp[-3].rv_expr)->fpos, "bad switch(): too many "
							"\"default:\" labels\n");
			YYERROR;
		}else if (case_check_type((yyvsp[-1].case_stms))!=0){
			yyerror_at(&(yyvsp[-3].rv_expr)->fpos, "bad switch(): mixed integer and"
							" string/RE cases not allowed\n");
			YYERROR;
		}else{
			(yyval.action)=mk_action(SWITCH_T, 2, RVE_ST, (yyvsp[-3].rv_expr), CASE_ST, (yyvsp[-1].case_stms));
			if ((yyval.action)==0) {
				yyerror("internal error");
				YYABORT;
			}
			set_cfg_pos((yyval.action));
		}
	}
#line 9849 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 638:
#line 2600 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=0;
		warn("empty switch()");
		if ((yyvsp[-2].rv_expr)==0){
			yyerror("bad expression in switch(...)");
			YYERROR;
		}else{
			/* it might have sideffects, so leave it for the optimizer */
			(yyval.action)=mk_action(SWITCH_T, 2, RVE_ST, (yyvsp[-2].rv_expr), CASE_ST, 0);
			if ((yyval.action)==0) {
				yyerror("internal error");
				YYABORT;
			}
			set_cfg_pos((yyval.action));
		}
	}
#line 9870 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 639:
#line 2616 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror ("bad expression in switch(...)"); }
#line 9876 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 640:
#line 2618 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0; yyerror ("bad switch body"); }
#line 9882 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 641:
#line 2622 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-1].rv_expr) && rval_expr_int_check((yyvsp[-1].rv_expr))>=0){
			warn_ct_rve((yyvsp[-1].rv_expr), "while");
			(yyval.action)=mk_action( WHILE_T, 2, RVE_ST, (yyvsp[-1].rv_expr), ACTIONS_ST, (yyvsp[0].action));
			set_cfg_pos((yyval.action));
		}else{
			yyerror_at(&(yyvsp[-1].rv_expr)->fpos, "bad while(...) expression");
			YYERROR;
		}
	}
#line 9897 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 642:
#line 2641 "core/cfg.y" /* yacc.c:1646  */
    {
		if (sel.n >= MAX_SELECT_PARAMS-1) {
			yyerror("Select identifier too long\n");
		}
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[0].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[0].strval));
		sel.n++;
	}
#line 9911 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 643:
#line 2650 "core/cfg.y" /* yacc.c:1646  */
    {
		if (sel.n >= MAX_SELECT_PARAMS-2) {
			yyerror("Select identifier too long\n");
		}
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[-3].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[-3].strval));
		sel.n++;
		sel.params[sel.n].type = SEL_PARAM_INT;
		sel.params[sel.n].v.i = (yyvsp[-1].intval);
		sel.n++;
	}
#line 9928 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 644:
#line 2662 "core/cfg.y" /* yacc.c:1646  */
    {
		if (sel.n >= MAX_SELECT_PARAMS-2) {
			yyerror("Select identifier too long\n");
		}
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[-3].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[-3].strval));
		sel.n++;
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[-1].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[-1].strval));
		sel.n++;
	}
#line 9946 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 647:
#line 2681 "core/cfg.y" /* yacc.c:1646  */
    { sel.n = 0; sel.f[0] = 0; }
#line 9952 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 648:
#line 2681 "core/cfg.y" /* yacc.c:1646  */
    {
		sel_ptr = (select_t*)pkg_malloc(sizeof(select_t));
		if (!sel_ptr) {
			yyerror("No memory left to allocate select structure\n");
		}
		memcpy(sel_ptr, &sel, sizeof(select_t));
		(yyval.select) = sel_ptr;
	}
#line 9965 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 649:
#line 2691 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_FROM; }
#line 9971 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 650:
#line 2692 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_TO; }
#line 9977 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 651:
#line 2693 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_FROM | AVP_CLASS_URI; }
#line 9983 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 652:
#line 2694 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_TO | AVP_CLASS_URI; }
#line 9989 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 653:
#line 2695 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_FROM | AVP_CLASS_USER; }
#line 9995 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 654:
#line 2696 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_TO | AVP_CLASS_USER; }
#line 10001 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 655:
#line 2697 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_FROM | AVP_CLASS_DOMAIN; }
#line 10007 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 656:
#line 2698 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_TO | AVP_CLASS_DOMAIN; }
#line 10013 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 657:
#line 2699 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_ALL | AVP_CLASS_GLOBAL; }
#line 10019 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 658:
#line 2702 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_NAME_STR; s_attr->name.s.s = (yyvsp[0].strval); s_attr->name.s.len = strlen ((yyvsp[0].strval)); }
#line 10025 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 661:
#line 2709 "core/cfg.y" /* yacc.c:1646  */
    {
		s_attr = (struct avp_spec*)pkg_malloc(sizeof(struct avp_spec));
		if (!s_attr) { yyerror("No memory left"); YYABORT; }
		else s_attr->type = 0;
	}
#line 10035 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 662:
#line 2716 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.attr) = s_attr; }
#line 10041 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 663:
#line 2719 "core/cfg.y" /* yacc.c:1646  */
    {
		s_attr->type|= (AVP_NAME_STR | ((yyvsp[-1].intval)<0?AVP_INDEX_BACKWARD:AVP_INDEX_FORWARD));
		s_attr->index = ((yyvsp[-1].intval)<0?-(yyvsp[-1].intval):(yyvsp[-1].intval));
		(yyval.attr) = s_attr;
	}
#line 10051 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 664:
#line 2726 "core/cfg.y" /* yacc.c:1646  */
    {
		s_attr->type|= AVP_INDEX_ALL;
		(yyval.attr) = s_attr;
	}
#line 10060 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 671:
#line 2748 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].lval)->type==LV_AVP){
			s_attr = pkg_malloc(sizeof(struct avp_spec));
			if (!s_attr) { yyerror("No memory left"); YYABORT; }
			else{
				*s_attr=(yyvsp[0].lval)->lv.avps;
			}
			(yyval.attr)=s_attr;
		}else
			(yyval.attr)=0; /* not an avp, a pvar */
		pkg_free((yyvsp[0].lval));
	}
#line 10077 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 672:
#line 2760 "core/cfg.y" /* yacc.c:1646  */
    {
		avp_spec_t *avp_spec;
		str s;
		int type, idx;
		avp_spec = pkg_malloc(sizeof(*avp_spec));
		if (!avp_spec) {
			yyerror("Not enough memory");
			YYABORT;
		}
		s.s = (yyvsp[0].strval);
		if (s.s[0] == '$')
			s.s++;
		s.len = strlen(s.s);
		if (parse_avp_name(&s, &type, &avp_spec->name, &idx)) {
			yyerror("error when parsing AVP");
			pkg_free(avp_spec);
			YYABORT;
		}
		avp_spec->type = type;
		avp_spec->index = idx;
		(yyval.attr) = avp_spec;
	}
#line 10104 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 673:
#line 2784 "core/cfg.y" /* yacc.c:1646  */
    {
			s_tmp.s=(yyvsp[0].strval); s_tmp.len=strlen((yyvsp[0].strval));
			pv_spec=pv_cache_get(&s_tmp);
			if (!pv_spec) {
				yyerror("Can't get from cache: %s", (yyvsp[0].strval));
				YYABORT;
			}
			(yyval.pvar)=pv_spec;
		}
#line 10118 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 674:
#line 2795 "core/cfg.y" /* yacc.c:1646  */
    {
				lval_tmp=pkg_malloc(sizeof(*lval_tmp));
				if (!lval_tmp) {
					yyerror("Not enough memory");
					YYABORT;
				}
				memset(lval_tmp, 0, sizeof(*lval_tmp));
				s_tmp.s=(yyvsp[0].strval); s_tmp.len=strlen(s_tmp.s);
				lval_tmp->lv.pvs = pv_cache_get(&s_tmp);
				if (lval_tmp->lv.pvs==NULL){
					lval_tmp->lv.avps.type|= AVP_NAME_STR;
					lval_tmp->lv.avps.name.s.s = s_tmp.s+1;
					lval_tmp->lv.avps.name.s.len = s_tmp.len-1;
					lval_tmp->type=LV_AVP;
				}else{
					lval_tmp->type=LV_PVAR;
				}
				(yyval.lval) = lval_tmp;
				DBG("parsed ambiguous avp/pvar \"%.*s\" to %d\n",
							s_tmp.len, s_tmp.s, lval_tmp->type);
			}
#line 10144 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 675:
#line 2826 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = ASSIGN_T; }
#line 10150 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 676:
#line 2830 "core/cfg.y" /* yacc.c:1646  */
    {
					lval_tmp=pkg_malloc(sizeof(*lval_tmp));
					if (!lval_tmp) {
						yyerror("Not enough memory");
						YYABORT;
					}
					lval_tmp->type=LV_AVP; lval_tmp->lv.avps=*(yyvsp[0].attr);
					pkg_free((yyvsp[0].attr)); /* free the avp spec we just copied */
					(yyval.lval)=lval_tmp;
				}
#line 10165 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 677:
#line 2840 "core/cfg.y" /* yacc.c:1646  */
    {
					if (!pv_is_w((yyvsp[0].pvar)))
						yyerror("read only pvar in assignment left side");
					if ((yyvsp[0].pvar)->trans!=0)
						yyerror("pvar with transformations in assignment"
								" left side");
					lval_tmp=pkg_malloc(sizeof(*lval_tmp));
					if (!lval_tmp) {
						yyerror("Not enough memory");
						YYABORT;
					}
					lval_tmp->type=LV_PVAR; lval_tmp->lv.pvs=(yyvsp[0].pvar);
					(yyval.lval)=lval_tmp;
				}
#line 10184 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 678:
#line 2854 "core/cfg.y" /* yacc.c:1646  */
    {
					if (((yyvsp[0].lval))->type==LV_PVAR){
						if (!pv_is_w((yyvsp[0].lval)->lv.pvs))
							yyerror("read only pvar in assignment left side");
						if ((yyvsp[0].lval)->lv.pvs->trans!=0)
							yyerror("pvar with transformations in assignment"
									" left side");
					}
					(yyval.lval)=(yyvsp[0].lval);
				}
#line 10199 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 679:
#line 2866 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve_rval(RV_INT, (void*)(yyvsp[0].intval)); }
#line 10205 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 680:
#line 2867 "core/cfg.y" /* yacc.c:1646  */
    {	s_tmp.s=(yyvsp[0].strval); s_tmp.len=strlen((yyvsp[0].strval));
							(yyval.rv_expr)=mk_rve_rval(RV_STR, &s_tmp); }
#line 10212 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 681:
#line 2869 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve_rval(RV_AVP, (yyvsp[0].attr)); pkg_free((yyvsp[0].attr)); }
#line 10218 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 682:
#line 2870 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve_rval(RV_PVAR, (yyvsp[0].pvar)); }
#line 10224 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 683:
#line 2871 "core/cfg.y" /* yacc.c:1646  */
    {
							switch((yyvsp[0].lval)->type){
								case LV_AVP:
									(yyval.rv_expr)=mk_rve_rval(RV_AVP, &(yyvsp[0].lval)->lv.avps);
									break;
								case LV_PVAR:
									(yyval.rv_expr)=mk_rve_rval(RV_PVAR, (yyvsp[0].lval)->lv.pvs);
									break;
								default:
									yyerror("BUG: invalid lvalue type ");
									YYABORT;
							}
							pkg_free((yyvsp[0].lval)); /* not needed anymore */
						}
#line 10243 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 684:
#line 2885 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve_rval(RV_SEL, (yyvsp[0].select)); pkg_free((yyvsp[0].select)); }
#line 10249 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 685:
#line 2886 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve_rval(RV_ACTION_ST, (yyvsp[0].action)); }
#line 10255 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 686:
#line 2887 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=mk_rve_rval(RV_BEXPR, (yyvsp[0].expr)); }
#line 10261 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 687:
#line 2888 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve_rval(RV_ACTION_ST, (yyvsp[-1].action)); }
#line 10267 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 688:
#line 2889 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad command block"); }
#line 10273 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 689:
#line 2890 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve_rval(RV_ACTION_ST, (yyvsp[-1].action)); }
#line 10279 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 690:
#line 2891 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10285 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 691:
#line 2895 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=RVE_LNOT_OP; }
#line 10291 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 692:
#line 2896 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=RVE_BNOT_OP; }
#line 10297 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 693:
#line 2897 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=RVE_UMINUS_OP; }
#line 10303 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 694:
#line 2910 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=(yyvsp[0].rv_expr);
										if ((yyval.rv_expr)==0){
											/*yyerror("out of memory\n");*/
											YYERROR;
										}
									}
#line 10314 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 695:
#line 2916 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve1((yyvsp[-1].intval), (yyvsp[0].rv_expr)); }
#line 10320 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 696:
#line 2917 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve1(RVE_INT_OP, (yyvsp[0].rv_expr)); }
#line 10326 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 697:
#line 2918 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve1(RVE_STR_OP, (yyvsp[0].rv_expr)); }
#line 10332 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 698:
#line 2919 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_PLUS_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr)); }
#line 10338 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 699:
#line 2920 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_MINUS_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr)); }
#line 10344 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 700:
#line 2921 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_MUL_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr)); }
#line 10350 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 701:
#line 2922 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_DIV_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr)); }
#line 10356 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 702:
#line 2923 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_MOD_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr)); }
#line 10362 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 703:
#line 2924 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_BOR_OP, (yyvsp[-2].rv_expr),  (yyvsp[0].rv_expr)); }
#line 10368 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 704:
#line 2925 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_BAND_OP, (yyvsp[-2].rv_expr),  (yyvsp[0].rv_expr));}
#line 10374 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 705:
#line 2926 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_BXOR_OP, (yyvsp[-2].rv_expr),  (yyvsp[0].rv_expr));}
#line 10380 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 706:
#line 2927 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_BLSHIFT_OP, (yyvsp[-2].rv_expr),  (yyvsp[0].rv_expr));}
#line 10386 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 707:
#line 2928 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_BRSHIFT_OP, (yyvsp[-2].rv_expr),  (yyvsp[0].rv_expr));}
#line 10392 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 708:
#line 2929 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=mk_rve2( (yyvsp[-1].intval), (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr));}
#line 10398 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 709:
#line 2930 "core/cfg.y" /* yacc.c:1646  */
    {
			/* comparing with $null => treat as defined or !defined */
			if((yyvsp[0].rv_expr) != NULL && (yyvsp[0].rv_expr)->op==RVE_RVAL_OP && (yyvsp[0].rv_expr)->left.rval.type==RV_PVAR
					&& (yyvsp[0].rv_expr)->left.rval.v.pvs.type==PVT_NULL) {
				if((yyvsp[-1].intval)==RVE_DIFF_OP || (yyvsp[-1].intval)==RVE_IDIFF_OP
						|| (yyvsp[-1].intval)==RVE_STRDIFF_OP) {
					DBG("comparison with $null switched to notdefined operator\n");
					(yyval.rv_expr)=mk_rve1(RVE_DEFINED_OP, (yyvsp[-2].rv_expr));
				} else {
					DBG("comparison with $null switched to defined operator\n");
					(yyval.rv_expr)=mk_rve1(RVE_NOTDEFINED_OP, (yyvsp[-2].rv_expr));
				}
				/* free rve struct for $null */
				rve_destroy((yyvsp[0].rv_expr));
			} else {
				(yyval.rv_expr)=mk_rve2((yyvsp[-1].intval), (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr));
			}
		}
#line 10421 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 710:
#line 2948 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=mk_rve2(RVE_LAND_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr));}
#line 10427 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 711:
#line 2949 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=mk_rve2(RVE_LOR_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr));}
#line 10433 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 712:
#line 2950 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=(yyvsp[-1].rv_expr);}
#line 10439 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 713:
#line 2951 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=mk_rve1(RVE_STRLEN_OP, (yyvsp[-1].rv_expr));}
#line 10445 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 714:
#line 2952 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve1(RVE_STREMPTY_OP, (yyvsp[-1].rv_expr));}
#line 10451 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 715:
#line 2953 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=mk_rve1(RVE_DEFINED_OP, (yyvsp[0].rv_expr));}
#line 10457 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 716:
#line 2954 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10463 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 717:
#line 2955 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10469 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 718:
#line 2956 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10475 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 719:
#line 2957 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10481 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 720:
#line 2958 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10487 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 721:
#line 2959 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10493 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 722:
#line 2960 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10499 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 723:
#line 2961 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10505 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 724:
#line 2962 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10511 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 725:
#line 2963 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10517 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 726:
#line 2965 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10523 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 727:
#line 2967 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10529 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 728:
#line 2968 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10535 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 729:
#line 2969 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10541 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 730:
#line 2970 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10547 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 731:
#line 2971 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10553 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 732:
#line 2972 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10559 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 733:
#line 2975 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action((yyvsp[-1].intval), 2, LVAL_ST, (yyvsp[-2].lval),
														 	  RVE_ST, (yyvsp[0].rv_expr));
											set_cfg_pos((yyval.action));
										}
#line 10568 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 734:
#line 2993 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = 1; }
#line 10574 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 735:
#line 2994 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = 0; }
#line 10580 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 736:
#line 2995 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = -1; }
#line 10586 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 737:
#line 2998 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); }
#line 10592 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 738:
#line 2999 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(	FORWARD_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10598 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 739:
#line 3000 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(	FORWARD_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10604 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 740:
#line 3001 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(	FORWARD_T, 2, IP_ST, (void*)(yyvsp[-1].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10610 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 741:
#line 3002 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10616 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 742:
#line 3003 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(FORWARD_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10622 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 743:
#line 3004 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_T, 2, IP_ST, (void*)(yyvsp[-3].ipaddr), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10628 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 744:
#line 3005 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); }
#line 10634 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 745:
#line 3006 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10640 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 746:
#line 3007 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10646 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 747:
#line 3008 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 10652 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 748:
#line 3009 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad forward argument"); }
#line 10658 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 749:
#line 3010 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10664 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 750:
#line 3011 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10670 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 751:
#line 3012 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, IP_ST, (void*)(yyvsp[-1].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10676 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 752:
#line 3013 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10682 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 753:
#line 3014 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10688 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 754:
#line 3015 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, IP_ST, (void*)(yyvsp[-3].ipaddr), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10694 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 755:
#line 3016 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(FORWARD_UDP_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); }
#line 10700 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 756:
#line 3017 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10706 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 757:
#line 3018 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10712 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 758:
#line 3019 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 10718 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 759:
#line 3020 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad forward_udp argument"); }
#line 10724 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 760:
#line 3021 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10730 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 761:
#line 3022 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10736 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 762:
#line 3023 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, IP_ST, (void*)(yyvsp[-1].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10742 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 763:
#line 3024 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10748 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 764:
#line 3025 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10754 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 765:
#line 3026 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, IP_ST, (void*)(yyvsp[-3].ipaddr), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10760 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 766:
#line 3027 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(FORWARD_TCP_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); }
#line 10766 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 767:
#line 3028 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10772 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 768:
#line 3029 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10778 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 769:
#line 3030 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 10784 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 770:
#line 3031 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad forward_tcp argument"); }
#line 10790 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 771:
#line 3032 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 10803 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 772:
#line 3040 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 10816 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 773:
#line 3048 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, IP_ST, (void*)(yyvsp[-1].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 10829 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 774:
#line 3056 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 10842 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 775:
#line 3064 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 10855 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 776:
#line 3072 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, IP_ST, (void*)(yyvsp[-3].ipaddr), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
					}
#line 10868 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 777:
#line 3080 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 10881 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 778:
#line 3088 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 10894 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 779:
#line 3096 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 10907 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 780:
#line 3104 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 10913 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 781:
#line 3105 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0;
									yyerror("bad forward_tls argument"); }
#line 10920 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 782:
#line 3107 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 10933 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 783:
#line 3115 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 10946 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 784:
#line 3123 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, IP_ST, (void*)(yyvsp[-1].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 10959 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 785:
#line 3131 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST,
							(void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 10973 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 786:
#line 3140 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST,
							(void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 10987 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 787:
#line 3149 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, IP_ST, (void*)(yyvsp[-3].ipaddr), NUMBER_ST,
							(void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
					}
#line 11001 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 788:
#line 3158 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 11014 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 789:
#line 3166 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, URIHOST_ST, 0, NUMBER_ST,
							(void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 11028 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 790:
#line 3175 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 11041 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 791:
#line 3183 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11047 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 792:
#line 3184 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0;
									yyerror("bad forward_sctp argument"); }
#line 11054 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 793:
#line 3186 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(LOG_T, 2, NUMBER_ST,
										(void*)(L_DBG+1), STRING_ST, (yyvsp[-1].strval));
									set_cfg_pos((yyval.action)); }
#line 11062 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 794:
#line 3189 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(LOG_T, 2, NUMBER_ST, (void*)(yyvsp[-3].intval), STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11068 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 795:
#line 3190 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11074 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 796:
#line 3191 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad log argument"); }
#line 11080 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 797:
#line 3192 "core/cfg.y" /* yacc.c:1646  */
    {
							if (check_flag((yyvsp[-1].intval))==-1)
								yyerror("bad flag value");
							(yyval.action)=mk_action(SETFLAG_T, 1, NUMBER_ST,
													(void*)(yyvsp[-1].intval));
							set_cfg_pos((yyval.action));
									}
#line 11092 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 798:
#line 3199 "core/cfg.y" /* yacc.c:1646  */
    {
							i_tmp=get_flag_no((yyvsp[-1].strval), strlen((yyvsp[-1].strval)));
							if (i_tmp<0) yyerror("flag not declared");
							(yyval.action)=mk_action(SETFLAG_T, 1, NUMBER_ST,
										(void*)(long)i_tmp);
							set_cfg_pos((yyval.action));
									}
#line 11104 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 799:
#line 3206 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 11110 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 800:
#line 3207 "core/cfg.y" /* yacc.c:1646  */
    {
							if (check_flag((yyvsp[-1].intval))==-1)
								yyerror("bad flag value");
							(yyval.action)=mk_action(RESETFLAG_T, 1, NUMBER_ST, (void*)(yyvsp[-1].intval));
							set_cfg_pos((yyval.action));
									}
#line 11121 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 801:
#line 3213 "core/cfg.y" /* yacc.c:1646  */
    {
							i_tmp=get_flag_no((yyvsp[-1].strval), strlen((yyvsp[-1].strval)));
							if (i_tmp<0) yyerror("flag not declared");
							(yyval.action)=mk_action(RESETFLAG_T, 1, NUMBER_ST,
										(void*)(long)i_tmp);
							set_cfg_pos((yyval.action));
									}
#line 11133 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 802:
#line 3220 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 11139 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 803:
#line 3221 "core/cfg.y" /* yacc.c:1646  */
    {
							if (check_flag((yyvsp[-1].intval))==-1)
								yyerror("bad flag value");
							(yyval.action)=mk_action(ISFLAGSET_T, 1, NUMBER_ST, (void*)(yyvsp[-1].intval));
							set_cfg_pos((yyval.action));
									}
#line 11150 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 804:
#line 3227 "core/cfg.y" /* yacc.c:1646  */
    {
							i_tmp=get_flag_no((yyvsp[-1].strval), strlen((yyvsp[-1].strval)));
							if (i_tmp<0) yyerror("flag not declared");
							(yyval.action)=mk_action(ISFLAGSET_T, 1, NUMBER_ST,
										(void*)(long)i_tmp);
							set_cfg_pos((yyval.action));
									}
#line 11162 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 805:
#line 3234 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 11168 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 806:
#line 3235 "core/cfg.y" /* yacc.c:1646  */
    {
		i_tmp=get_avpflag_no((yyvsp[-1].strval));
		if (i_tmp==0) yyerror("avpflag not declared");
		(yyval.action)=mk_action(AVPFLAG_OPER_T, 3, AVP_ST, (yyvsp[-3].attr), NUMBER_ST, (void*)(long)i_tmp, NUMBER_ST, (void*)(yyvsp[-5].intval));
		set_cfg_pos((yyval.action));
	}
#line 11179 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 807:
#line 3241 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=0; yyerror("error parsing flag name");
	}
#line 11187 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 808:
#line 3244 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=0; yyerror("error parsing first parameter (avp or string)");
	}
#line 11195 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 809:
#line 3247 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad parameters"); }
#line 11201 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 810:
#line 3248 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 11207 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 811:
#line 3249 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(ERROR_T, 2, STRING_ST, (yyvsp[-3].strval), STRING_ST, (yyvsp[-1].strval));
			set_cfg_pos((yyval.action));
	}
#line 11215 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 812:
#line 3252 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11221 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 813:
#line 3253 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad error argument"); }
#line 11227 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 814:
#line 3254 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-1].rv_expr)) {
			(yyval.action) = mk_action(ROUTE_T, 1, RVE_ST, (void*)(yyvsp[-1].rv_expr));
			set_cfg_pos((yyval.action));
		} else {
			(yyval.action) = 0;
			YYERROR;
		}
	}
#line 11241 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 815:
#line 3263 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-1].strval)) {
			(yyval.action) = mk_action(ROUTE_T, 1, STRING_ST, (void*)(yyvsp[-1].strval));
			set_cfg_pos((yyval.action));
		} else {
			(yyval.action) = 0;
			YYERROR;
		}
	}
#line 11255 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 816:
#line 3272 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11261 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 817:
#line 3273 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad route argument"); }
#line 11267 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 818:
#line 3274 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(EXEC_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11273 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 819:
#line 3275 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_HOST_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11279 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 820:
#line 3276 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11285 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 821:
#line 3277 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11291 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 822:
#line 3278 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(PREFIX_T, 1, STRING_ST,  (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11297 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 823:
#line 3279 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11303 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 824:
#line 3280 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11309 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 825:
#line 3281 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(STRIP_TAIL_T, 1, NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11315 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 826:
#line 3282 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11321 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 827:
#line 3283 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, number expected"); }
#line 11327 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 828:
#line 3284 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(STRIP_T, 1, NUMBER_ST, (void*) (yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11333 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 829:
#line 3285 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11339 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 830:
#line 3286 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, number expected"); }
#line 11345 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 831:
#line 3287 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_USERPHONE_T, 0); set_cfg_pos((yyval.action)); }
#line 11351 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 832:
#line 3288 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11357 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 833:
#line 3289 "core/cfg.y" /* yacc.c:1646  */
    {
			(yyval.action)=mk_action(REMOVE_BRANCH_T, 1, NUMBER_ST, (void*)(yyvsp[-1].intval));
			set_cfg_pos((yyval.action));
	}
#line 11366 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 834:
#line 3293 "core/cfg.y" /* yacc.c:1646  */
    {
			(yyval.action)=mk_action(REMOVE_BRANCH_T, 0);
			set_cfg_pos((yyval.action));
	}
#line 11375 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 835:
#line 3297 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11381 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 836:
#line 3298 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, number expected"); }
#line 11387 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 837:
#line 3299 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(CLEAR_BRANCHES_T, 0); set_cfg_pos((yyval.action)); }
#line 11393 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 838:
#line 3300 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_HOSTPORT_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11399 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 839:
#line 3301 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11405 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 840:
#line 3302 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11411 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 841:
#line 3303 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_HOSTPORTTRANS_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11417 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 842:
#line 3304 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11423 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 843:
#line 3305 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11429 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 844:
#line 3306 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_PORT_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11435 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 845:
#line 3307 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11441 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 846:
#line 3308 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11447 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 847:
#line 3309 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_USER_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11453 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 848:
#line 3310 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11459 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 849:
#line 3311 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11465 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 850:
#line 3312 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_USERPASS_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11471 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 851:
#line 3313 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11477 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 852:
#line 3314 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11483 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 853:
#line 3315 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_URI_T, 1, STRING_ST,(yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11489 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 854:
#line 3316 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11495 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 855:
#line 3317 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11501 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 856:
#line 3318 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(REVERT_URI_T, 0); set_cfg_pos((yyval.action)); }
#line 11507 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 857:
#line 3319 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(REVERT_URI_T, 0); set_cfg_pos((yyval.action)); }
#line 11513 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 858:
#line 3320 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORCE_RPORT_T, 0); set_cfg_pos((yyval.action)); }
#line 11519 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 859:
#line 3321 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(FORCE_RPORT_T, 0); set_cfg_pos((yyval.action)); }
#line 11525 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 860:
#line 3322 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(ADD_LOCAL_RPORT_T, 0); set_cfg_pos((yyval.action)); }
#line 11531 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 861:
#line 3323 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(ADD_LOCAL_RPORT_T, 0); set_cfg_pos((yyval.action)); }
#line 11537 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 862:
#line 3324 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			(yyval.action)=mk_action(FORCE_TCP_ALIAS_T, 1, NUMBER_ST, (void*)(yyvsp[-1].intval));
			set_cfg_pos((yyval.action));
		#else
			yyerror("tcp support not compiled in");
		#endif
	}
#line 11550 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 863:
#line 3332 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			(yyval.action)=mk_action(FORCE_TCP_ALIAS_T, 0);
			set_cfg_pos((yyval.action));
		#else
			yyerror("tcp support not compiled in");
		#endif
	}
#line 11563 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 864:
#line 3340 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			(yyval.action)=mk_action(FORCE_TCP_ALIAS_T, 0);
			set_cfg_pos((yyval.action));
		#else
			yyerror("tcp support not compiled in");
		#endif
	}
#line 11576 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 865:
#line 3348 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0; yyerror("bad argument, number expected"); }
#line 11582 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 866:
#line 3350 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(UDP_MTU_TRY_PROTO_T, 1, NUMBER_ST, (yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11588 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 867:
#line 3352 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, UDP, TCP, TLS or SCTP expected"); }
#line 11594 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 868:
#line 3353 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=0;
		if ((str_tmp=pkg_malloc(sizeof(str)))==0) {
			PKG_MEM_CRITICAL;
		} else {
			str_tmp->s=(yyvsp[-1].strval);
			str_tmp->len=(yyvsp[-1].strval)?strlen((yyvsp[-1].strval)):0;
			(yyval.action)=mk_action(SET_ADV_ADDR_T, 1, STR_ST, str_tmp);
			set_cfg_pos((yyval.action));
		}
	}
#line 11610 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 869:
#line 3364 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11616 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 870:
#line 3365 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11622 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 871:
#line 3366 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=0;
		tmp=int2str((yyvsp[-1].intval), &i_tmp);
		if ((str_tmp=pkg_malloc(sizeof(str)))==0) {
			PKG_MEM_CRITICAL;
		} else {
			if ((str_tmp->s=pkg_malloc(i_tmp))==0) {
				PKG_MEM_CRITICAL;
			} else {
				memcpy(str_tmp->s, tmp, i_tmp);
				str_tmp->len=i_tmp;
				(yyval.action)=mk_action(SET_ADV_PORT_T, 1, STR_ST, str_tmp);
				set_cfg_pos((yyval.action));
			}
		}
	}
#line 11643 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 872:
#line 3382 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11649 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 873:
#line 3383 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11655 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 874:
#line 3384 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(FORCE_SEND_SOCKET_T, 1, SOCKID_ST, (yyvsp[-1].sockid));
		set_cfg_pos((yyval.action));
	}
#line 11664 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 875:
#line 3388 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=0; yyerror("bad argument, [proto:]host[:port] expected");
	}
#line 11672 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 876:
#line 3391 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11678 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 877:
#line 3392 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_FWD_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	}
#line 11686 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 878:
#line 3395 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_FWD_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	}
#line 11694 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 879:
#line 3398 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_RPL_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	}
#line 11702 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 880:
#line 3401 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_RPL_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	}
#line 11710 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 881:
#line 3404 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_FWD_CLOSE_T, 0); set_cfg_pos((yyval.action));
	}
#line 11718 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 882:
#line 3407 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_FWD_CLOSE_T, 0); set_cfg_pos((yyval.action));
	}
#line 11726 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 883:
#line 3410 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_RPL_CLOSE_T, 0); set_cfg_pos((yyval.action));
	}
#line 11734 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 884:
#line 3413 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_RPL_CLOSE_T, 0); set_cfg_pos((yyval.action));
	}
#line 11742 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 885:
#line 3416 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(CFG_SELECT_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
	}
#line 11750 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 886:
#line 3419 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(CFG_SELECT_T, 2, STRING_ST, (yyvsp[-3].strval), RVE_ST, (yyvsp[-1].rv_expr)); set_cfg_pos((yyval.action));
	}
#line 11758 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 887:
#line 3422 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11764 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 888:
#line 3423 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad arguments, string and number expected"); }
#line 11770 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 889:
#line 3424 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(CFG_RESET_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action));
	}
#line 11778 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 890:
#line 3427 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11784 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 891:
#line 3428 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad arguments, string expected"); }
#line 11790 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 892:
#line 3429 "core/cfg.y" /* yacc.c:1646  */
    {
		if (mod_func_action != NULL) {
			LM_ERR("function used inside params of another function: %s\n", (yyvsp[0].strval));
			yyerror("use of function execution inside params not allowed\n");
			exit(-1);
		}
		mod_func_action = mk_action(MODULE0_T, 2, MODEXP_ST, NULL, NUMBER_ST, 0);
		}
#line 11803 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 893:
#line 3436 "core/cfg.y" /* yacc.c:1646  */
    {
		mod_func_action->val[0].u.data =
			find_export_record((yyvsp[-4].strval), mod_func_action->val[1].u.number, rt);
		if (mod_func_action->val[0].u.data == 0) {
			if (find_export_record((yyvsp[-4].strval), mod_func_action->val[1].u.number, 0) ) {
					LM_ERR("misused command %s\n", (yyvsp[-4].strval));
					yyerror("Command cannot be used in the block\n");
			} else {
				LM_ERR("cfg. parser: failed to find command %s (params %ld)\n",
						(yyvsp[-4].strval), mod_func_action->val[1].u.number);
				yyerror("unknown command, missing loadmodule?\n");
			}
			free_mod_func_action(mod_func_action);
			mod_func_action=0;
		}else{
			if (mod_func_action && mod_f_params_pre_fixup(mod_func_action)<0) {
				/* error messages are printed inside the function */
				free_mod_func_action(mod_func_action);
				mod_func_action = 0;
				YYERROR;
			}
		}
		(yyval.action) = mod_func_action;
		set_cfg_pos((yyval.action));
		mod_func_action = NULL;
	}
#line 11834 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 894:
#line 3462 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("'('')' expected (function call)");}
#line 11840 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 896:
#line 3466 "core/cfg.y" /* yacc.c:1646  */
    { }
#line 11846 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 897:
#line 3467 "core/cfg.y" /* yacc.c:1646  */
    {}
#line 11852 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 898:
#line 3470 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].rv_expr) && mod_func_action->val[1].u.number < MAX_ACTIONS-2) {
			mod_func_action->val[mod_func_action->val[1].u.number+2].type =
				RVE_ST;
			mod_func_action->val[mod_func_action->val[1].u.number+2].u.data =
				(yyvsp[0].rv_expr);
			mod_func_action->val[1].u.number++;
		} else if ((yyvsp[0].rv_expr)) {
			yyerror("Too many arguments\n");
			YYERROR;
		} else {
			YYERROR;
		}
	}
#line 11871 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 899:
#line 3487 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, 0, NUMBER_ST,
						(void*)(DROP_R_F|EXIT_R_F)); set_cfg_pos((yyval.action));
	}
#line 11880 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 900:
#line 3491 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, RVE_ST, (yyvsp[0].rv_expr), NUMBER_ST,
						(void*)(DROP_R_F|EXIT_R_F)); set_cfg_pos((yyval.action));
	}
#line 11889 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 901:
#line 3495 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, 0, NUMBER_ST,
						(void*)(DROP_R_F|EXIT_R_F)); set_cfg_pos((yyval.action));
	}
#line 11898 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 902:
#line 3499 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, (void*)1, NUMBER_ST,
						(void*)EXIT_R_F);
		set_cfg_pos((yyval.action));
	}
#line 11908 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 903:
#line 3504 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, RVE_ST, (yyvsp[0].rv_expr), NUMBER_ST, (void*)EXIT_R_F);
		set_cfg_pos((yyval.action));
	}
#line 11917 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 904:
#line 3508 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, (void*)1, NUMBER_ST,
						(void*)EXIT_R_F);
		set_cfg_pos((yyval.action));
	}
#line 11927 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 905:
#line 3513 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, (void*)1, NUMBER_ST,
						(void*)RETURN_R_F); set_cfg_pos((yyval.action));
	}
#line 11936 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 906:
#line 3517 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, (void*)1, NUMBER_ST,
						(void*)RETURN_R_F); set_cfg_pos((yyval.action));
	}
#line 11945 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 907:
#line 3521 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, RVE_ST, (yyvsp[0].rv_expr), NUMBER_ST, (void*)RETURN_R_F);
		set_cfg_pos((yyval.action));
	}
#line 11954 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 908:
#line 3525 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, 0, NUMBER_ST, (void*)BREAK_R_F);
		set_cfg_pos((yyval.action));
	}
#line 11963 "core/cfg.tab.c" /* yacc.c:1646  */
    break;


#line 11967 "core/cfg.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 3531 "core/cfg.y" /* yacc.c:1906  */


static void get_cpos(struct cfg_pos* pos)
{
	pos->s_line=startline;
	pos->e_line=line;
	pos->s_col=startcolumn;
	pos->e_col=column-1;
	if(finame==0)
		finame = (cfg_file!=0)?cfg_file:"default";
	pos->fname=finame;
	pos->rname=(routename!=0)?routename:default_routename;
}


static void warn_at(struct cfg_pos* p, char* format, ...)
{
	va_list ap;
	char s[256];

	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	if (p->e_line!=p->s_line)
		LM_WARN("warning in config file %s, from line %d, column %d to"
					" line %d, column %d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_line, p->e_col, s);
	else if (p->s_col!=p->e_col)
		LM_WARN("warning in config file %s, line %d, column %d-%d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_col, s);
	else
		LM_WARN("warning in config file %s, line %d, column %d: %s\n",
				p->fname, p->s_line, p->s_col, s);
	cfg_warnings++;
}



static void yyerror_at(struct cfg_pos* p, char* format, ...)
{
	va_list ap;
	char s[256];

	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	if (p->e_line!=p->s_line)
		LM_CRIT("parse error in config file %s, from line %d, column %d"
					" to line %d, column %d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_line, p->e_col, s);
	else if (p->s_col!=p->e_col)
		LM_CRIT("parse error in config file %s, line %d, column %d-%d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_col, s);
	else
		LM_CRIT("parse error in config file %s, line %d, column %d: %s\n",
					p->fname, p->s_line, p->s_col, s);
	cfg_errors++;
}



static void warn(char* format, ...)
{
	va_list ap;
	char s[256];
	struct cfg_pos pos;

	get_cpos(&pos);
	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	warn_at(&pos, s);
}



static void yyerror(char* format, ...)
{
	va_list ap;
	char s[256];
	struct cfg_pos pos;

	get_cpos(&pos);
	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	yyerror_at(&pos, s);
}



/** mk_rval_expr_v wrapper.
 *  checks mk_rval_expr_v return value and sets the cfg. pos
 *  (line and column numbers)
 *  @return rval_expr* on success, 0 on error (@see mk_rval_expr_v)
 */
static struct rval_expr* mk_rve_rval(enum rval_type type, void* v)
{
	struct rval_expr* ret;
	struct cfg_pos pos;

	get_cpos(&pos);
	ret=mk_rval_expr_v(type, v, &pos);
	if (ret==0){
		yyerror("internal error: failed to create rval expr");
		/* YYABORT; */
	}
	return ret;
}


/** mk_rval_expr1 wrapper.
 *  checks mk_rval_expr1 return value (!=0 and type checking)
 *  @return rval_expr* on success, 0 on error (@see mk_rval_expr1)
 */
static struct rval_expr* mk_rve1(enum rval_expr_op op, struct rval_expr* rve1)
{
	struct rval_expr* ret;
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;

	if (rve1==0)
		return 0;
	ret=mk_rval_expr1(op, rve1, &rve1->fpos);
	if (ret && (rve_check_type(&type, ret, &bad_rve, &bad_t, &exp_t)!=1)){
		yyerror_at(&rve1->fpos, "bad expression: type mismatch"
					" (%s instead of %s)", rval_type_name(bad_t),
					rval_type_name(exp_t));
		rve_destroy(ret);
		ret=0;
	}
	return ret;
}


/** mk_rval_expr2 wrapper.
 *  checks mk_rval_expr2 return value (!=0 and type checking)
 *  @return rval_expr* on success, 0 on error (@see mk_rval_expr2)
 */
static struct rval_expr* mk_rve2(enum rval_expr_op op, struct rval_expr* rve1,
									struct rval_expr* rve2)
{
	struct rval_expr* ret;
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;
	struct cfg_pos pos;

	if ((rve1==0) || (rve2==0))
		return 0;
	bad_rve=0;
	bad_t=0;
	exp_t=0;
	cfg_pos_join(&pos, &rve1->fpos, &rve2->fpos);
	ret=mk_rval_expr2(op, rve1, rve2, &pos);
	if (ret && (rve_check_type(&type, ret, &bad_rve, &bad_t, &exp_t)!=1)){
		if (bad_rve)
			yyerror_at(&pos, "bad expression: type mismatch:"
						" %s instead of %s at (%d,%d)",
						rval_type_name(bad_t), rval_type_name(exp_t),
						bad_rve->fpos.s_line, bad_rve->fpos.s_col);
		else
			yyerror("BUG: unexpected null \"bad\" expression\n");
		rve_destroy(ret);
		ret=0;
	}
	return ret;
}


/** check if the expression is an int.
 * if the expression does not evaluate to an int return -1 and
 * log an error.
 * @return 0 success, no warnings; 1 success but warnings; -1 on error */
static int rval_expr_int_check(struct rval_expr *rve)
{
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;

	if (rve==0){
		yyerror("invalid expression");
		return -1;
	}else if (!rve_check_type(&type, rve, &bad_rve, &bad_t ,&exp_t)){
		if (bad_rve)
			yyerror_at(&rve->fpos, "bad expression: type mismatch:"
						" %s instead of %s at (%d,%d)",
						rval_type_name(bad_t), rval_type_name(exp_t),
						bad_rve->fpos.s_line, bad_rve->fpos.s_col);
		else
			yyerror("BUG: unexpected null \"bad\" expression\n");
		return -1;
	}else if (type!=RV_INT && type!=RV_NONE){
		warn_at(&rve->fpos, "non-int expression (you might want to use"
				" casts)\n");
		return 1;
	}
	return 0;
}


/** warn if the expression is constant.
 * @return 0 on success (no warning), 1 when warning */
static int warn_ct_rve(struct rval_expr *rve, char* name)
{
	if (rve && rve_is_constant(rve)){
		warn_at(&rve->fpos, "constant value in %s%s",
				name?name:"expression", name?"(...)":"");
		return 1;
	}
	return 0;
}


static struct name_lst* mk_name_lst(char* host, int flags)
{
	struct name_lst* l;
	if (host==0) return 0;
	l=pkg_malloc(sizeof(struct name_lst));
	if (l==0) {
		PKG_MEM_CRITICAL;
	} else {
		l->name=host;
		l->flags=flags;
		l->next=0;
	}
	return l;
}


static struct socket_id* mk_listen_id(char* host, int proto, int port)
{
	struct socket_id* l;
	if (host==0) return 0;
	l=pkg_malloc(sizeof(struct socket_id));
	if (l==0) {
		PKG_MEM_CRITICAL;
	} else {
		l->addr_lst=mk_name_lst(host, 0);
		if (l->addr_lst==0){
			pkg_free(l);
			return 0;
		}
		l->flags=0;
		l->port=port;
		l->proto=proto;
		l->next=0;
	}
	return l;
}


static void free_name_lst(struct name_lst* lst)
{
	struct name_lst* tmp;

	while(lst){
		tmp=lst;
		lst=lst->next;
		pkg_free(tmp);
	}
}


static struct socket_id* mk_listen_id2(struct name_lst* addr_l, int proto,
										int port)
{
	struct socket_id* l;
	if (addr_l==0) return 0;
	l=pkg_malloc(sizeof(struct socket_id));
	if (l==0) {
		PKG_MEM_CRITICAL;
	} else {
		l->flags=addr_l->flags;
		l->port=port;
		l->proto=proto;
		l->addr_lst=addr_l;
		l->next=0;
	}
	return l;
}


static void free_socket_id(struct socket_id* i)
{
	free_name_lst(i->addr_lst);
	pkg_free(i);
}


static void free_socket_id_lst(struct socket_id* lst)
{
	struct socket_id* tmp;

	while(lst){
		tmp=lst;
		lst=lst->next;
		free_socket_id(tmp);
	}
}


/** create a temporary case statmenet structure.
 *  *err will be filled in case of error (return == 0):
 *   -1 - non constant expression
 *   -2 - expression error (bad type)
 *   -10 - memory allocation error
 */
static struct case_stms* mk_case_stm(struct rval_expr* ct, int is_re,
											struct action* a, int* err)
{
	struct case_stms* s;
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;
	enum match_str_type t;

	t=MATCH_UNKNOWN;
	if (ct){
		/* if ct!=0 => case, else if ct==0 is a default */
		if (!rve_is_constant(ct)){
			yyerror_at(&ct->fpos, "non constant expression in case");
			*err=-1;
			return 0;
		}
		if (rve_check_type(&type, ct, &bad_rve, &bad_t, &exp_t)!=1){
			yyerror_at(&ct->fpos, "bad expression: type mismatch:"
							" %s instead of %s at (%d,%d)",
							rval_type_name(bad_t), rval_type_name(exp_t),
							bad_rve->fpos.s_line, bad_rve->fpos.s_col);
			*err=-2;
			return 0;
		}
		if (is_re)
			t=MATCH_RE;
		else if (type==RV_STR)
			t=MATCH_STR;
		else
			t=MATCH_INT;
	}

	s=pkg_malloc(sizeof(*s));
	if (s==0) {
		yyerror("internal error: memory allocation failure");
		*err=-10;
	} else {
		memset(s, 0, sizeof(*s));
		s->ct_rve=ct;
		s->type=t;
		s->actions=a;
		s->next=0;
		s->append=0;
	}
	return s;
}


/*
 * @return 0 on success, -1 on error.
 */
static int case_check_type(struct case_stms* stms)
{
	struct case_stms* c;
	struct case_stms* s;

	for(c=stms; c ; c=c->next){
		if (!c->ct_rve) continue;
		for (s=c->next; s; s=s->next){
			if (!s->ct_rve) continue;
			if ((s->type!=c->type) &&
				!(	(c->type==MATCH_STR || c->type==MATCH_RE) &&
					(s->type==MATCH_STR || s->type==MATCH_RE) ) ){
					yyerror_at(&s->ct_rve->fpos, "type mismatch in case");
					return -1;
			}
		}
	}
	return 0;
}


/*
 * @return 0 on success, -1 on error.
 */
static int case_check_default(struct case_stms* stms)
{
	struct case_stms* c;
	int default_no;

	default_no=0;
	for(c=stms; c ; c=c->next)
		if (c->ct_rve==0) default_no++;
	return (default_no<=1)?0:-1;
}



/** fixes the parameters and the type of a module function call.
 * It is done here instead of fix action, to have quicker feedback
 * on error cases (e.g. passing a non constant to a function with a
 * declared fixup)
 * The rest of the fixup is done inside do_action().
 * @param a - filled module function call (MODULE*_T) action structure
 *            complete with parameters, starting at val[2] and parameter
 *            number at val[1].
 * @return 0 on success, -1 on error (it will also print the error msg.).
 *
 */
static int mod_f_params_pre_fixup(struct action* a)
{
	ksr_cmd_export_t* cmd_exp;
	action_u_t* params;
	int param_no;
	struct rval_expr* rve;
	struct rvalue* rv;
	int r;
	str s;

	cmd_exp = a->val[0].u.data;
	param_no = a->val[1].u.number;
	params = &a->val[2];

	switch(cmd_exp->param_no) {
		case 0:
			a->type = MODULE0_T;
			break;
		case 1:
			a->type = MODULE1_T;
			break;
		case 2:
			a->type = MODULE2_T;
			break;
		case 3:
			a->type = MODULE3_T;
			break;
		case 4:
			a->type = MODULE4_T;
			break;
		case 5:
			a->type = MODULE5_T;
			break;
		case 6:
			a->type = MODULE6_T;
			break;
		case VAR_PARAM_NO:
			a->type = MODULEX_T;
			break;
		default:
			yyerror("function %s: bad definition"
					" (invalid number of parameters)", cmd_exp->name);
			return -1;
	}

	if ( cmd_exp->fixup) {
		if (is_fparam_rve_fixup(cmd_exp->fixup))
			/* mark known fparam rve safe fixups */
			cmd_exp->fixup_flags  |= FIXUP_F_FPARAM_RVE;
		else if (!(cmd_exp->fixup_flags & FIXUP_F_FPARAM_RVE) &&
				 cmd_exp->free_fixup == 0) {
			/* v0 or v1 functions that have fixups and no coresp. fixup_free
			   functions, need constant, string params.*/
			for (r=0; r < param_no; r++) {
				rve=params[r].u.data;
				if (!rve_is_constant(rve)) {
					yyerror_at(&rve->fpos, "function %s: parameter %d is not"
								" constant\n", cmd_exp->name, r+1);
					return -1;
				}
				if ((rv = rval_expr_eval(0, 0, rve)) == 0 ||
						rval_get_str(0, 0, &s, rv, 0) < 0 ) {
					/* out of mem or bug ? */
					rval_destroy(rv);
					yyerror_at(&rve->fpos, "function %s: bad parameter %d"
									" expression\n", cmd_exp->name, r+1);
					return -1;
				}
				rval_destroy(rv);
				rve_destroy(rve);
				params[r].type = STRING_ST; /* asciiz */
				params[r].u.string = s.s;
				params[r].u.str.len = s.len; /* not used right now */
			}
		}
	}/* else
		if no fixups are present, the RVEs can be transformed
		into strings at runtime, allowing seamless var. use
		even with old functions.
		Further optimizations -> in fix_actions()
		*/
	return 0;
}



/** frees a filled module function call action structure.
 * @param a - filled module function call action structure
 *            complete with parameters, starting at val[2] and parameter
 *            number at val[1].
 */
static void free_mod_func_action(struct action* a)
{
	action_u_t* params;
	int param_no;
	int r;

	param_no = a->val[1].u.number;
	params = &a->val[2];

	for (r=0; r < param_no; r++)
		if (params[r].u.data)
			rve_destroy(params[r].u.data);
	pkg_free(a);
}



/*
int main(int argc, char ** argv)
{
	if (yyparse()!=0)
		fprintf(stderr, "parsing error\n");
}
*/
